unit UAlfaForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, jpeg, ExtCtrls;

type
  TAlfaForm = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Button1: TButton;
    TxTLabel: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    Label6: TLabel;
    Edit6: TEdit;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
    procedure Edit3Exit(Sender: TObject);
    procedure Edit4Exit(Sender: TObject);
    procedure Edit5Exit(Sender: TObject);
    procedure Edit6Exit(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
  private
    { Private declarations }
    Ka, Kb, D, U, P, L, AA, BB, Deq, FFt,
    XX, FF1, FF3, FF5, YY1, YY3, YY5     : real;
    OK : boolean;
    function StringToFloat(Str : string) : double;
    procedure CheckValues;
    procedure SetBlank;
  public
    { Public declarations }
  end;

var
  AlfaForm: TForm;

implementation

uses UDMRainOff, URainForm, URainOffUtils;

{$R *.dfm}

procedure TAlfaForm.FormCreate(Sender: TObject);
begin
  Ka:=0;
  Kb:=0;
  D:=0;
  U:=0;
  P:=0;
  L:=0;
end;

procedure TAlfaForm.Edit1Exit(Sender: TObject);
begin
  Ka:=StringToFloat(Edit1.Text);
  if Ka<0 then
  begin
    Showmessage ('Ka should be greater than zero');
    Edit1.Text:='';
    Ka:=0;
    exit;
  end;
  CheckValues;
end;

procedure TAlfaForm.Edit1Change(Sender: TObject);
begin
  setblank;
end;

procedure TAlfaForm.Edit2Exit(Sender: TObject);
begin
  Kb:=StringToFloat(Edit2.Text);
  if Kb<0 then
  begin
    Showmessage ('Kb should be greater than zero');
    Edit2.Text:='';
    Kb:=0;
    exit;
  end;
  CheckValues;
end;

procedure TAlfaForm.Edit2Change(Sender: TObject);
begin
  SetBlank;
end;

procedure TAlfaForm.Edit3Exit(Sender: TObject);
begin
  D:=StringToFloat(Edit3.Text);
  if D<=0 then
  begin
    Showmessage ('D should be greater than zero');
    Edit3.Text:='';
    D:=0;
    exit;
  end;
  CheckValues;
end;

procedure TAlfaForm.Edit3Change(Sender: TObject);
begin
  SetBlank;
end;

procedure TAlfaForm.Edit4Exit(Sender: TObject);
begin
  U:=StringToFloat(Edit4.Text);
  if U<=0 then
  begin
    Showmessage ('U should be greater than zero');
    Edit4.Text:='';
    U:=0;
    exit;
  end;
  CheckValues;
end;

procedure TAlfaForm.Edit4Change(Sender: TObject);
begin
  SetBlank;
end;

procedure TAlfaForm.Edit5Exit(Sender: TObject);
begin
  P:=StringToFloat(Edit5.Text);
  if P<=0 then
  begin
    Showmessage ('P should be greater than zero');
    Edit5.Text:='';
    exit;
  end;
  if P<1 then
  begin
    Showmessage ('P should be greater than 1%');
    Edit5.Text:='';
    exit;
  end;
  if P>30 then
  begin
    Showmessage ('P should be less than 30%');
    Edit5.Text:='';
    exit;
  end;
  CheckValues;
end;

procedure TAlfaForm.Edit5Change(Sender: TObject);
begin
  SetBlank;
end;

procedure TAlfaForm.Edit6Exit(Sender: TObject);
begin
  L:=StringToFloat(Edit6.Text);
  if L<=0 then
  begin
    Showmessage ('L should be greater than zero');
    Edit6.Text:='';
    exit;
  end;
  CheckValues;
end;

procedure TAlfaForm.Edit6Change(Sender: TObject);
begin
  SetBlank;
end;


function TAlfaForm.StringToFloat(Str : string) : double;
{------------------------------------------------------}
{accepts comma or point for decimal separator}
var
  OldDecSep : char;
begin
  try
    Result := StrToFloat(Str);
  except
    on EConvertError do begin
      OldDecSep := DecimalSeparator;
      {change to other decimal separator}
      if DecimalSeparator = ',' then
        DecimalSeparator := '.'
      else
        DecimalSeparator := ',';
      Result := StrToFloat(Str);
      {revert to original decimal separator}
      DecimalSeparator :=     OldDecSep;
    end;
  end;
end; {TSegRegForm.StringToFloat}
{------------------------------}


procedure TAlfaForm.CheckValues;
begin
  OK:=false;
  if (Ka>0) and (Kb>0) and (D>0) and (U>0) and (P>1) and (P<30) and (L>0) then
  OK:=true;
end;

procedure TAlfaForm.SetBlank;
begin
  AA:=0;
  Edit7.Text:='';
  BB:=0;
  Edit8.Text:='';
end;

procedure TAlfaForm.Button2Click(Sender: TObject);
begin
  TxtLabel.Visible:=true;
  Label7.Visible:=true;
  Label8.Visible:=true;
  Edit7.Visible:=true;
  Edit8.Visible:=true;
end;


procedure TAlfaForm.Button1Click(Sender: TObject);
var OutA, OutB, OutP : string;
begin

  CheckValues;
  if not OK then
  begin
    showmessage ('One or more data values are incorrect');
    exit;
  end;
  P:=P/100;
  AA:=4*Ka/(P*L*L);
  Acoeff:=AA;
  XX:=2*3.142*D/L;
  if XX>1 then
  begin
    YY1:=exp(-2*XX);
    YY3:=exp(-2*3*XX);
    YY5:=exp(-2*5*XX);
    FF1:=4*YY1/(1-YY1);
    FF3:=4*YY3/(3*(1-YY3));
    FF5:=4*YY5/(5*(1-YY5));
    FFt:=FF1+FF3+FF5;
  end else
    FFt:=3.142*3.142/(4*XX) + ln(0.5*XX/3.142);
  Deq:=(3.142*L/8)/(ln(L/U)+FFt);
  BB:=8*Kb*Deq/(P*L*L);
  DMRainOff.Bvalue:=BB;
  OutA := format('%6.3f',[AA]);
  Edit7.Text:=OutA;
  RainForm.A1coeffEdit.Text:=OutA;
  RainForm.A2coeffEdit.Text:=' 0';
  OutB := format('%6.3f',[BB]);
  Edit8.Text:=OutB;
  RainForm.B1valueEdit.Text:=OutB;
  RainForm.B2valueEdit.Text:=' 0';
  P:=P*100;
  OutP := format('%5.1f',[P]);
  RainForm.PorosityEdit.Text:=OutP;
  RainForm.DivideEdit.Text:=' 0';
  DMRainOff.EffPor:=P;
  DMRainOff.Drainage:=true;
  Showmessage ('The calculations were done and the values are'+
               ' entered in the input tabsheet.');
end;


end.
