unit URainRun;

interface

uses Dialogs, SysUtils, URainForm, UDMRainOff, URainOffUtils;

var
Extens                            : string[4];
Run,    Time                      : array [1..1501] of real;
Rech,   RunCalc, AlphCalc, Alfa5  : array [1..1501] of real;
Alfa1, Alfa2,  AlfReg,  Flow      : array [1..1501] of real;
SerNum                            : array [1..1501] of string [7];
Serial                            : array [1..1501] of integer;
EscMax, StorIni, StorMax          : real;
Inter,  Slope, RunFactor          : real;
Slope1,    Inter1                 : real;
Slope2,    Inter2                 : real;
AlfAv,  FlwAv, RunAv, RainAv      : real;
LowSq,  LowAb, AlfDev             : real;
SumResRunSq, SumResRunAb          : real;
SumRun, {AvRun,} SumSqAv, Rsq     : real;
R2sq, R3sq, R4sq, R5sq, R6sq,
R7sq, RtSq, RtSq0                 : real;
R3sqA, R4sqA, R5sqA, R6sqA        : real;
SumResSq5, SumResAb5 {Fraction}   : real;
Method, Number,  NumDat, Phase    : integer;
Count1, Count2, Count, Timeshift  : integer;
CountA, CountB                    : integer;
AlfSum, AlfSumSq, FlwSum, FlwSumSq, AlfFlwPr   : real;
RunSum, RunSumSq, RainSum, RainSumSq, RunRainPr: real;
AlfRedSumSq, FlwRedSumSq, AlfFlwRedPr          : real;
RunRedSumSq, RainRedSumSq, RunRainRedPr        : real;
FlwSum3rd, Flw2Alf1, FlwSum4th                 : real;  {for 2nd degree funct.}
RainSum3rd, Rain2Run1, RainSum4th              : real;  {for 2nd degree funct.}
Sxxx, Sxxy, Sxxxx                              : real;   {for 2nd degree funct.}
CoeffA, CoeffB, CoeffC                         : real;  {for Rain-Run statist.}
CoeffA0, CoeffB0, CoeffC0                      : real;  {for Rain-Run statist.}
FalseTime, StorOK, Problem1, Problem2,
Problem3, Scarce, NoWrite, Note, TimeVar, NoZero : boolean;
TT : string[22]; RR : string[11];

Procedure RainRunOff;
procedure Regres;
procedure Regres1;
procedure Regres2;
procedure Regres5;
procedure AlfaFunc;
procedure SaveCoefficients;
procedure ReadCoefficients;
procedure Construc;
procedure WriteOut;

implementation

Procedure RainRunOff;
{-------------------}
begin
  AlfaFunc;
  if not TimeVar or NoZero then exit;
  if FalseTime then exit;
  if DMRainOff.NoRange then exit;
  if Scarce then exit;
  if not StorOK then
     exit;
  Construc;
  if not NoWrite then
     WriteOut;
end;
{end of RainRunOff}
{*****************}


{Regres is part of AlfaFunc}
{--------------------------}
procedure Regres;

var kk : integer;

begin

  RunSum   := 0;
  RainSum   := 0;
  RunSumSq := 0;
  RainSumSq := 0;
  RunRainPr := 0;
  RainSum3rd := 0;
  Rain2Run1 := 0;
  RainSum4th := 0;

  for kk:=1 to NumDat do
  begin
    RunSum    := RunSum + Run[kk];                       {sum Y, A4}
    RainSum   := RainSum + Rech[kk];                       {sum X, A6}
    RunSumSq  := RunSumSq + Run[kk]*Run[kk];          {sum Xsq, A10}
    RainSumSq := RainSumSq + Rech[kk]*Rech[kk];          {sum Ysq}
    RunRainPr := RunRainPr + Run[kk]*Rech[kk];          {sum YX, A12}
// For 2nd degree function:
    RainSum3rd := RainSum3rd + sqr(Rech[kk])*Rech[kk];    {Sum XXX, A14}
    Rain2Run1  := Rain2Run1 + sqr(Rech[kk])*Run[kk];     {Sum XXY, A16}
    RainSum4th := RainSum4th + sqr(Rech[kk])*sqr(Rech[kk]);  {Sum XXXX, A18}
 end;

  Qtrend:=true;
  if RainSum=0 then
  begin
    Qtrend:=false;
    exit;
  end;

  if not noWrite then
  begin

    RunAv       := RunSum/NumDat;
    RainAv      := RainSum/Numdat;
    RunRedSumSq := RunSumSq - RunSum*RunSum/Numdat;           {Syy}
    RainRedSumSq := RainSumSq - RainSum*RainSum/Numdat;       {Sxx}
    RunRainRedPr := RunRainPr - RunSum*RainSum/NumDat;        {Sxy}

    Slope       := RunRainRedPr/RainRedSumSq;
    Inter       := RunAv - Slope*RainAv;

// For 2nd degree function:
  if NumDat>2 then
  begin
    Sxxx  := RainSum3rd-RainSum*RainSumSq/NumDat;
    Sxxy  := Rain2Run1- RainSumSq*RunSum/Numdat;
    Sxxxx := RainSum4th-sqr(RainSumSq)/Numdat;
    Acoeff:=(Sxxy*RainRedSumSq-RunRainRedPr*Sxxx)/(RainRedSumSq*Sxxxx-sqr(Sxxx));
    Bcoeff:=(RunRainRedPr*Sxxxx-Sxxy*Sxxx)/(RainRedSumSq*Sxxxx-sqr(Sxxx));
    Ccoeff:=RunSum/Numdat-Bcoeff*RainSum/Numdat-Acoeff*RainSumSq/Numdat;
  end;
  end;
end;
{end of Regres}
{-------------}


{Regres1 is part of AlfaFunc}
{--------------------------}
procedure Regres1;

var kk, MM : integer;

begin

  AlfSum   := 0;
  FlwSum   := 0;
  AlfSumSq := 0;
  FlwSumSq := 0;
  AlfFlwPr := 0;
  FlwSum3rd := 0;
  Flw2Alf1 := 0;
  FlwSum4th := 0;
  MM:=0;

  for kk:=1 to NumDat do if Trace[kk] then if Run[kk]>RunRef then
  begin
    AlfSum    := AlfSum + Alfa1[kk];                       {sum Y, A4}
    FlwSum    := FlwSum + Flow[kk];                       {sum X, A6}
    AlfSumSq  := AlfSumSq + Alfa1[kk]*Alfa1[kk];          {sum Xsq, A10}
    FlwSumSq  := FlwSumSq + Flow[kk]*Flow[kk];          {sum Ysq}
    AlfFlwPr  := AlfFlwPr + Alfa1[kk]*Flow[kk];          {sum YX, A12}
// For 2nd degree function:
    FlwSum3rd := FlwSum3rd + sqr(Flow[kk])*Flow[kk];    {Sum XXX, A14}
    Flw2Alf1  := Flw2Alf1 + sqr(Flow[kk])*Alfa1[kk];     {Sum XXY, A16}
    FlwSum4th := FlwSum4th + sqr(Flow[kk])*sqr(Flow[kk]);  {Sum XXXX, A18}
    MM:=MM+1;
 end;

  if MM>0 then
  begin
    AlfAv       := AlfSum/MM;
    FlwAv       := FlwSum/MM;
    AlfRedSumSq := AlfSumSq - AlfSum*AlfSum/MM;       {Syy}
    FlwRedSumSq := FlwSumSq - FlwSum*FlwSum/MM;       {Sxx}
    AlfFlwRedPr := AlfFlwPr - AlfSum*FlwSum/MM;       {Sxy}
  end;

  if FlwRedSumSq>0 then Slope := AlfFlwRedPr/FlwRedSumSq else Slope:=0;

  if MM>0 then
  begin
    Sxxx  := FlwSum3rd-FlwSum*FlwSumSq/MM;
    Sxxy  := Flw2Alf1- FlwSumSq*AlfSum/MM;
    Sxxxx := FlwSum4th-sqr(FlwSumSq)/MM;
    if (FlwRedSumSq*Sxxxx-sqr(Sxxx))<>0 then
    A1coeff:=(Sxxy*FlwRedSumSq-AlfFlwRedPr*Sxxx)/(FlwRedSumSq*Sxxxx-sqr(Sxxx))
    else A1Coeff:=100;
    if (FlwRedSumSq*Sxxxx-sqr(Sxxx))<>0 then
    B1coeff:=(AlfFlwRedPr*Sxxxx-Sxxy*Sxxx)/(FlwRedSumSq*Sxxxx-sqr(Sxxx))
    else B1Coeff:=100;
    C1coeff:=AlfSum/MM-B1coeff*FlwSum/MM-A1coeff*FlwSumSq/MM;
  end;

  CountA:=MM;

end;
{end of Regres1}
{--------------}


{Regres2 is part of AlfaFunc}
{--------------------------}
procedure Regres2;

var kk, MM : integer;

begin

  AlfSum   := 0;
  FlwSum   := 0;
  AlfSumSq := 0;
  FlwSumSq := 0;
  AlfFlwPr := 0;
  FlwSum3rd := 0;
  Flw2Alf1 := 0;
  FlwSum4th := 0;
  MM:=0;

  for kk:=1 to NumDat do if Trace[kk] then if Run[kk]<=RunRef then
  begin
    AlfSum    := AlfSum + Alfa2[kk];                       {sum Y, A4}
    FlwSum    := FlwSum + Flow[kk];                       {sum X, A6}
    AlfSumSq  := AlfSumSq + Alfa2[kk]*Alfa2[kk];          {sum Xsq, A10}
    FlwSumSq  := FlwSumSq + Flow[kk]*Flow[kk];          {sum Ysq}
    AlfFlwPr  := AlfFlwPr + Alfa2[kk]*Flow[kk];          {sum YX, A12}
// For 2nd degree function:
    FlwSum3rd := FlwSum3rd + sqr(Flow[kk])*Flow[kk];    {Sum XXX, A14}
    Flw2Alf1  := Flw2Alf1 + sqr(Flow[kk])*Alfa2[kk];     {Sum XXY, A16}
    FlwSum4th := FlwSum4th + sqr(Flow[kk])*sqr(Flow[kk]);  {Sum XXXX, A18}
    MM:=MM+1;
 end;

  if MM>0 then
  begin
    AlfAv       := AlfSum/MM;
    FlwAv       := FlwSum/MM;
    AlfRedSumSq := AlfSumSq - AlfSum*AlfSum/MM;       {Syy}
    FlwRedSumSq := FlwSumSq - FlwSum*FlwSum/MM;       {Sxx}
    AlfFlwRedPr := AlfFlwPr - AlfSum*FlwSum/MM;       {Sxy}
  end;

  if FlwRedSumSq>0 then Slope := AlfFlwRedPr/FlwRedSumSq else Slope:=0;

  if MM>0 then
  begin
    Sxxx  := FlwSum3rd-FlwSum*FlwSumSq/MM;
    Sxxy  := Flw2Alf1- FlwSumSq*AlfSum/MM;
    Sxxxx := FlwSum4th-sqr(FlwSumSq)/MM;
    A2coeff:=(Sxxy*FlwRedSumSq-AlfFlwRedPr*Sxxx)/(FlwRedSumSq*Sxxxx-sqr(Sxxx));
    B2coeff:=(AlfFlwRedPr*Sxxxx-Sxxy*Sxxx)/(FlwRedSumSq*Sxxxx-sqr(Sxxx));
    C2coeff:=AlfSum/MM-B2coeff*FlwSum/MM-A2coeff*FlwSumSq/MM;
  end;

  CountB:=MM;

end;
{end of Regres2}
{--------------}


{Regres5 is part of AlfaFunc}
{--------------------------}
procedure Regres5;

var kk, MM : integer;

begin

  AlfSum   := 0;
  FlwSum   := 0;
  AlfSumSq := 0;
  FlwSumSq := 0;
  AlfFlwPr := 0;
  FlwSum3rd := 0;
  Flw2Alf1 := 0;
  FlwSum4th := 0;
  MM:=0;

  for kk:=1 to NumDat do if Trace[kk] then
  begin
    AlfSum    := AlfSum + Alfa1[kk];                       {sum Y, A4}
    FlwSum    := FlwSum + Flow[kk];                       {sum X, A6}
    AlfSumSq  := AlfSumSq + Alfa1[kk]*Alfa1[kk];          {sum Xsq, A10}
    FlwSumSq  := FlwSumSq + Flow[kk]*Flow[kk];          {sum Ysq}
    AlfFlwPr  := AlfFlwPr + Alfa1[kk]*Flow[kk];          {sum YX, A12}
// For 2nd degree function:
    FlwSum3rd := FlwSum3rd + sqr(Flow[kk])*Flow[kk];    {Sum XXX, A14}
    Flw2Alf1  := Flw2Alf1 + sqr(Flow[kk])*Alfa1[kk];     {Sum XXY, A16}
    FlwSum4th := FlwSum4th + sqr(Flow[kk])*sqr(Flow[kk]);  {Sum XXXX, A18}
    MM:=MM+1;
 end;

 AlfAv       := AlfSum/MM;
 FlwAv       := FlwSum/MM;
 AlfRedSumSq := AlfSumSq - AlfSum*AlfSum/MM;       {Syy}
 FlwRedSumSq := FlwSumSq - FlwSum*FlwSum/MM;       {Sxx}
 AlfFlwRedPr := AlfFlwPr - AlfSum*FlwSum/MM;       {Sxy}

// For 2nd degree function:
  if MM>0 then
  begin
    Sxxx  := FlwSum3rd-FlwSum*FlwSumSq/MM;
    Sxxy  := Flw2Alf1- FlwSumSq*AlfSum/MM;
    Sxxxx := FlwSum4th-sqr(FlwSumSq)/MM;
    Acoeff:=(Sxxy*FlwRedSumSq-AlfFlwRedPr*Sxxx)/(FlwRedSumSq*Sxxxx-sqr(Sxxx));
    Bcoeff:=(AlfFlwRedPr*Sxxxx-Sxxy*Sxxx)/(FlwRedSumSq*Sxxxx-sqr(Sxxx));
    Ccoeff:=AlfSum/MM-Bcoeff*FlwSum/MM-Acoeff*FlwSumSq/MM;
  end;

end;
{end of Regres5}
{--------------}


{AlfaFunc is part of Main Program}
{--------------------------------}
procedure AlfaFunc;

label 1;

var
AA                                : char;
Defi,      Stor                   : array [1..1501] of real;
AlfRg1,    AlfRg2,    AlfRg3      : real;
RunRg1,    RunRg2,    RunRg3      : real;
DefIni,    Delta,     Ratio       : real;
AlfAv1,    FlwAv1                 : real;
AlfAv2,    FlwAv2                 : real;
Residu,    ResiduAb,  ResiduSq    : real;
SumResSq1, SumResAb1, AlfRg5      : real;
SumResSq2, SumResAb2              : real;
EscAct,    RunMax,    RunMin      : real;
TimeMax,   TimeMin    {RunTmp }   : real;
Factor, Past, Present, Zeta       : real;
SumRech, AveRech, RainOpt         : real;
RainMax, RainMin, SumAlf          : real;
AlfMax, AlfMin, SumAlf1, SumAlf2  : real;
AlfMax1, AlfMin1                  : real;
AlfMax2, AlfMin2                  : real;
FlowMax, FlowMin, FlowOpt         : real;
ii, jj, kk, mm, NrOfZeroRech      : integer;
nn, pp, qq                        : integer;
DumEsc {Again}                    : boolean;
InpFile                           : textfile;
Shifting, QQstr                   : string;

begin
  assign (InpFile,DMRainOff.FileName);
  reset (InpFile);
  for ii:=1 to 3 do readln (InpFile);
  readln (InpFile,DMRainOff.Title1);
  readln (InpFile,DMRainOff.Title2);
  for ii:=1 to 2 do readln (InpFile);
  kk := 23;
  for jj:=1 to kk do read (InpFile,AA);
  readln (InpFile,StorMax);
  for jj:=1 to kk do read (InpFile,AA);
  readln (InpFile,StorIni);
  for jj:=1 to kk do read (InpFile,AA);
  readln (InpFile,EscMax);
  for jj:=1 to 3 do readln (InpFile);
  readln (InpFile,TT,RR);
  if TT=' ---------------------' then
  begin
    TT:='--';
    RR:='--';
    goto 1;
  end;
  while pos(' ',TT)>0 do delete (TT,Pos(' ',TT),1);
  while pos('.',TT)>0 do delete (TT,Pos('.',TT),1);
  while pos(' ',RR)>0 do delete (RR,Pos(' ',RR),1);
  while pos('.',RR)>0 do delete (RR,Pos('.',RR),1);
  if TT='SerialTimeR' then TT:='t';
  if RR='ainR' then RR:='depth/t';
  readln (Inpfile);
1:jj := 0;
  while not eof(InpFile) do
  begin
    jj := jj+1;
    readln (InpFile,Serial[jj],Time[jj],Rain[jj],DMRainOff.Evap[jj],Run[jj]);
    str (Serial[jj],SerNum[jj]);
  end;
  NumDat := jj;
  closefile (InpFile);

  RainForm.NrOfDataEdit.Text:=inttostr(Numdat);
  for jj:=1 to NumDat do if Run[jj]<0.001 then Run[jj]:=0.001;

  RunMax:=Run[1];
  RunMin:=Run[1];
  TimeMax:=Time[1];
  TimeMin:=Time[1];
  for jj:=2 to NumDat do
  begin
      if Run[jj]>Run[jj-1] then RunMax:=Run[jj];
      if Run[jj]<Run[jj-1] then RunMin:=Run[jj];
      if Time[jj]>Time[jj-1] then TimeMax:=Time[jj];
      if Time[jj]<Time[jj-1] then TimeMin:=Time[jj];
   end;
   RunRef:= RunMin+RunFactor*(RunMax-RunMin);

    TimeVar:=true;
    DMRainOff.NoRange:=false;
    if RunMax-RunMin<0.001 then
    begin
      DMRainOff.NoRange:=true;
      Showmessage ('There is no variation in runoff values. '+
                   'Rainfall-Runoff analysis cannot be made');
      TimeVar:=false;
      exit;
    end;

    if TimeMax-TimeMin<0.001 then
    begin
      DMRainOff.NoRange:=true;
      Showmessage ('There is no variation in time ' +
                   'Rainfall-Runoff analysis cannot be made');
      TimeVar:=false;
      exit;
    end;

  if StorIni=0 then StorIni:=0.1*StorMax;
  DefIni  := StorMax - StorIni;
  Defi[1] := DefIni;
  Rech[1] := Rain[1] - DefIni;
  Stor[1] := StorIni;
  if Rech[1]<0 then
  begin
    Defi[1] := DefIni - Rain[1];
    Rech[1] := 0;
    Stor[1] := StorIni + Rain[1];
  end;

  FalseTime:=false;
  for jj:=2 to NumDat do
  begin
    Delta    := Time[jj]-Time[jj-1];
    if Delta<0 then
    begin
      FalseTime:=true;
      Showmessage ('Incorrect time sequence encountered. ' +
                   'Please correct the input file');
      exit;
    end;
    StorOK:=true;
    if StorMax<=0 then
    begin
      showmessage ('The Maximum Storage must be > 0');
      StorOK:=false;
      exit;
    end;
    Ratio    := Stor[jj-1]/StorMax;
    EscAct   := DMRainOff.Evap[jj]*Delta*Ratio;
    Defi[jj] := Defi[jj-1] + EscAct;
    Rech[jj] := Rain[jj] - Defi[jj];
    Stor[jj] := Stor[jj-1] - EscAct;
    if Rech[jj]<0 then
    begin
      Defi[jj] := Defi[jj-1] + EscAct - Rain[jj];
      Rech[jj] := 0;
      Stor[jj] := Stor[jj-1] - EscAct + Rain[jj];
    end;
  end; {jj:=2 to NumDat do}

  Regres;
  if not noWrite then SaveCoefficients;

  SumRech:=0;
  for jj:=1 to NumDat do
  begin
    SumRech:=SumRech+Rech[jj];
    Trace[jj]:=false;
  end;

  AveRech:=SumRech/NumDat;
  if AveRech=0 then AveRech:=0.001;

  if Rech[1]<0.001 then Trace[1]:=true;
  for jj:=2 to NumDat do if (Rech[jj]<0.001) {or (Run[jj]<0.1*Run[jj-1])} then
      Trace[jj]:=true;
  for jj:=2 to NumDat do if Trace[jj] then
      if Run[jj]>=Run[jj-1] then Trace[jj]:=false;

  Flow[1]:=Run[1];
  Trace[NumDat]:=false;

//Dividing the runoff domain into two parts
    SumRun:=0;
    Count1:=0;
    Count2:=0;
    for jj:=1 to NumDat do
        SumRun:=SumRun+Run[jj];
    RunAv:=SumRun/NumDat;

  NrOfZeroRech:=0;
  for jj:=2 to NumDat do              //Determinimg alfa when recharge is small
  begin
    Flow[jj]:=Run[jj];
    if Rech[jj]>0 then NrOfZeroRech:=0;
    if Rech[jj]<0.001 then NrOfZeroRech:=NrOfZeroRech+1;
    if (NrOfZeroRech>10) then Trace[jj]:=false;
    if (Trace[jj]) and (Run[jj]>RunRef) then
    begin
        Delta := Time[jj] - Time[jj-1];
        if (Flow[jj]>0) and (Flow[jj-1]>0) and (Flow[jj]<Flow[jj-1]) then
        begin
          Zeta      := -ln(Flow[jj]/Flow[jj-1]);
          Alfa1[jj]  := Zeta/Delta;
          Count1:=Count1+1;
        end else
          Trace[jj]:=false;
        if (Alfa1[jj]<0) and (jj<Numdat) and (Run[jj+1]<Run[jj]) then
        begin
          Zeta      := -ln(Run[jj+1]/Run[jj]);
          Alfa1[jj]  := Zeta/Delta;
        end;
        if (Alfa1[jj]<0) then Alfa1[jj]:=-Alfa1[jj];
    end;
    if (Trace[jj]) and (Run[jj]<=RunRef) then
    begin
        Delta := Time[jj] - Time[jj-1];
        if (Flow[jj]>0) and (Flow[jj-1]>0) and (Flow[jj]<Flow[jj-1]) then
        begin
          Zeta      := -ln(Flow[jj]/Flow[jj-1]);
          Alfa2[jj]  := Zeta/Delta;
          Count2:=Count2+1;
        end else
          Trace[jj]:=false;
        if (Alfa2[jj]<0) and (jj<Numdat) and (Run[jj+1]<Run[jj]) then
        begin
          Zeta      := -ln(Run[jj+1]/Run[jj]);
          Alfa2[jj]  := Zeta/Delta;
        end;
        if (Alfa2[jj]<0) then Alfa2[jj]:=-Alfa2[jj];
    end;

//For quadratic function
    if Trace[jj] then
    begin
        Delta := Time[jj] - Time[jj-1];
        if (Flow[jj]>0) and (Flow[jj-1]>0) and (Flow[jj]<Flow[jj-1]) then
        begin
          Zeta      := -ln(Flow[jj]/Flow[jj-1]);
          Alfa5[jj]  := Zeta/Delta;
        end else
          Trace[jj]:=false;
    end;
  end;

  Count:=Count1+Count2;
  NoZero:=false;
  if Count=0 then
  begin
    showmessage('There are no zero rainfalls. The program cannot be run.'+
                ' Use the RainOffT model instead.');
    NoZero:=true;
    exit;
  end;

  qq:=0;
  if not noWrite then for jj:=2 to NumDat do
    if run[jj]=run[jj-1] then qq:=qq+1;

  if not noWrite and (qq>1) then
  begin
    QQstr:=inttostr(qq);
    QQstr:='There are '+QQstr+' instances of zero recharge linked'+
           ' to equal runoff. This hampers the determination of an'+
           ' effective response factor (alpha). Please correct.';
    showmessage (QQstr);
  end;

  Count:=Count1+Count2;

  Problem1:=false;
  if not Nowrite then if (Count<4) or (Count2<2) or (Count1<2) then
     Problem1:=true;

  if (Count<4) or (Count1<2) or (Count2<2) then
  begin
    Count1:=0;
    Count2:=0;
    for jj:=2 to NumDat do if (Rech[jj]<0.1*Flow[jj-1]) then Trace[jj]:=true;
    for jj:=2 to NumDat do if Trace[jj] then if (Run[jj]>RunRef) then
    begin
        Delta := Time[jj] - Time[jj-1];
        if (Flow[jj]>0) and (Flow[jj-1]>0) and (Flow[jj]<Flow[jj-1]) then
        begin
          Zeta      := -ln(Flow[jj]/Flow[jj-1]);
          Alfa1[jj]  := Zeta/Delta;
          Count1:=Count1+1;
        end else
          Trace[jj]:=false;
        if (Alfa1[jj]<0) then Alfa1[jj]:=Alfa1[jj-1];
    end;
    for jj:=2 to NumDat do if Trace[jj] then if (Run[jj]<=RunRef) then
    begin
        Delta := Time[jj] - Time[jj-1];
        if (Flow[jj]>0) and (Flow[jj-1]>0) and (Flow[jj]<Flow[jj-1]) then
        begin
          Zeta      := -ln(Flow[jj]/Flow[jj-1]);
          Alfa2[jj]  := Zeta/Delta;
          Count2:=Count2+1;
        end else
          Trace[jj]:=false;
        if (Alfa2[jj]<0) then Alfa2[jj]:=Alfa2[jj-1];

    end;
  end;

  kk:=0;
  for jj:=2 to NumDat do if Trace[jj] then kk:=kk+1;

  AlfMax:=0;
  AlfMin:=1000000;
  AlfMax1:=0;
  AlfMin1:=1000000;
  AlfMax2:=0;
  AlfMin2:=1000000;
  SumAlf:=0;
  SumAlf1:=0;
  SumAlf2:=0;
  mm:=0;
  nn:=0;
  pp:=0;
  if Not NoWrite then
     AlfMin:=100000;

  for jj:=2 to NumDat do if Trace[jj] then
  begin

    if Alfa1[jj]<AlfMin then AlfMin:=Alfa1[jj];
    if Alfa1[jj]>AlfMax then AlfMax:=Alfa1[jj];
    if Alfa2[jj]<AlfMin then AlfMin:=Alfa2[jj];
    if Alfa2[jj]>AlfMax then AlfMax:=Alfa2[jj];

    if Run[jj]>RunRef then
    begin
      if Alfa1[jj]<AlfMin1 then AlfMin1:=Alfa1[jj];
      if Alfa1[jj]>AlfMax1 then AlfMax1:=Alfa1[jj];
    end;

    if Run[jj]<=RunRef then
    begin
      if Alfa2[jj]<AlfMin2 then AlfMin2:=Alfa2[jj];
      if Alfa2[jj]>AlfMax2 then AlfMax2:=Alfa2[jj];
    end;

    if Run[jj]>RunRef then
    begin
      SumAlf1:=SumAlf1+Alfa1[jj];
      SumAlf:=SumAlf+Alfa1[jj];
      nn:=nn+1;
    end else
    begin
      SumAlf2:=SumAlf2+Alfa2[jj];
      SumAlf:=SumAlf+Alfa2[jj];
      pp:=pp+1;
    end;
    mm:=mm+1;
  end;

    if mm>0 then AlfAv:=SumAlf/mm;
    if nn>0 then AlfAv1:=SumAlf1/nn else AlfAv1:=0;
    if pp>0 then AlfAv2:=SumAlf2/pp else AlfAv2:=0;

  Number:=kk;
  Scarce := false;
  if (Number<3) and not noWrite then
  begin
    showmessage ('The number of data with little rainfall is not enough'+
                 ' to determine the reaction factor.The program halts');
    Scarce:=true;
    exit;
  end;
  Note:=false;
  if (Number=3) and not noWrite then
  begin
    showmessage ('The number of data with little rainfall is limited.'+
                 ' The data fit may not be very close.');
    Note:=true;
  end;
  if (Number>3) and not noWrite then if (Count2<2) then
  begin
      showmessage ('The number of data with little rainfall in the lower'+
                 ' discharge range is small. The data fit may not be very'+
                 ' close.');
    Note:=true;
  end;

  Method    := 1;         {linear}

  Slope1:=0;
  Inter1:=0;
  SumResAb1:=0;
    Regres1;
    SumResSq1 := 0;
    SumResAb1 := 0;
    Slope1:=Slope;
    Inter1:=Inter;
    for jj:=2 to NumDat do if Trace[jj] then if Run[jj]>RunRef then
    begin
      Slope1    := Slope;
      AlfAv1    := AlfAv;
      FlwAv1    := FlwAv;
      Inter1    := AlfAv1 - Slope1*FlwAv1;
      AlfRg1    := A1Coeff*sqr(Flow[jj-1]) + B1coeff*Flow[jj-1] + C1coeff;
      Residu    := Alfa1[jj] - AlfRg1;
      ResiduAb  := Residu;
      if Residu<0 then ResiduAb := -Residu;
      ResiduSq  := ResiduAb*ResiduAb;
      SumResSq1 := SumResSq1 + ResiduSq;
      SumResAb1 := SumResAb1 + ResiduAb;
    end;

  Slope2:=0;
  Inter2:=0;
  SumResAb2:=0;
    Regres2;
    SumResSq2 := 0;
    SumResAb2 := 0;
    Slope2:=Slope;
    Inter2:=Inter;
    for jj:=2 to NumDat do if Trace[jj] then if Run[jj]<=RunRef then
    begin
      Slope2    := Slope;
      AlfAv2    := AlfAv;
      FlwAv2    := FlwAv;
      Inter2    := AlfAv2 - Slope2*FlwAv2;
      AlfRg2    := A2Coeff*sqr(Flow[jj-1]) + B2coeff*Flow[jj-1] + C2coeff;
      Residu    := Alfa2[jj] - AlfRg2;
      ResiduAb  := Residu;
      if Residu<0 then ResiduAb := -Residu;
      ResiduSq  := ResiduAb*ResiduAb;
      SumResSq2 := SumResSq2 + ResiduSq;
      SumResAb2 := SumResAb2 + ResiduAb;
    end;

  Problem2:=false;
  if (Slope1<=0) or (Slope2<=0)  then
     Problem2:=true;

  if Not NoWrite then
  begin
    Regres5;
    SumResSq5 := 0;
    SumResAb5 := 0;
    for jj:=2 to NumDat do if Trace[jj] then
    begin
      AlfRg5    := Acoeff*Flow[jj]*Flow[jj]+Bcoeff*Flow[jj]+Ccoeff;
      AlfReg[jj] := AlfRg5;
      Residu    := Alfa5[jj] - AlfRg5;
      ResiduAb  := Residu;
      if Residu<0 then ResiduAb := -Residu;
      ResiduSq  := ResiduAb*ResiduAb;
      SumResSq5 := SumResSq5 + ResiduSq;
      SumResAb5 := SumResAb5 + ResiduAb;
    end;
  end;

  Problem3:=false; {this problem will not be used}

  if not noWrite then
  begin

    Regres;

    RainMax:=0;
    RainMin:=1000000;
    for jj:=1 to NumDat do {if Trace[jj] then}
    begin
      if Rain[jj]<RainMin then RainMin:=Rain[jj];
      if Rain[jj]>RainMax then RainMax:=Rain[jj];
    end;

    RainOpt:=-0.5*Bcoeff/Acoeff;  {this the point of max or min of the parabola}
    Residu:=RainMax-RainMin;
    if (RainOpt>RainMin+0.1*Residu) and (RainOpt<RainMax-0.1*Residu) then
       if not Problem1 and not Problem2 then
       showmessage ('The quadratic trend of the relation between rainfall'+
                    ' and runoff data shows an inconsistency.'+
                    ' See output graphics');
  end;


  Method   := 1;     {method=5 for quadratic function is not used}
  for kk:=2 to NumDat do if Trace[kk] then
  begin
    if Method=1 then if Run[kk]>RunRef then
    begin
       if CountA<3 then AlfReg[kk] := Slope1*Run[kk] + Inter1
       else
       AlfReg[kk] := A1Coeff*sqr(Run[kk])+B1Coeff*Run[kk]+C1Coeff;
    end else
    begin
    if Method=1 then if Run[kk]<=RunRef then
       if CountB<3 then AlfReg[kk] := Slope2*Run[kk] + Inter2
       else
       AlfReg[kk] := A2Coeff*sqr(Run[kk])+B2Coeff*Run[kk]+C2Coeff;
    end;
  end;

end;
{end of AlfaFunc}
{---------------}


procedure SaveCoefficients;
{-------------------------}
var TmpName : string;
    DatFile : textfile;
begin
  TmpName:=changefileext (DMRainOff.FileName,'.dat');
  assign (DatFile,TmpName);
  rewrite (DatFile);
  writeln (DatFile,'Linear: Runoff = A * Rain + C');
  writeln (DatFile,'A= ',Slope:7:4,' C= ',Inter:7:4);
  writeln (DatFile);
  writeln (DatFile,'Quadratic: Runoff = A * RainSq +  B * Rain + C');
  writeln (DatFile,'A= ',ACoeff:8:5,' B= ',BCoeff:8:5,' C= ',Ccoeff:8:5);
  closefile (DatFile);
end; {SaveCoefficients}
{---------------------}


procedure ReadCoefficients;
{-------------------------}
var TmpName : string;
    DatFile : textfile;
    i : integer;
    j : string[3];
begin
  TmpName:=changefileext (DMRainOff.FileName,'.dat');
  assign (DatFile,TmpName);
  reset (DatFile);
  for i:=1 to 4 do readln (DatFile);
  readln (DatFile,j, Acoeff, j, BCoeff, j, Ccoeff);
  closefile (DatFile);
end; {SaveCoefficients}
{---------------------}



{Construc is part of Main Program}
{--------------------------------}
procedure Construc;

var
Delta, Factor, Past, Present : real;
{Auxil,} Residu, ResiduAb, ResiduSq   : real;
jj                                  : integer;

begin
  SumResRunSq := 0;
  SumResRunAb := 0;
  SumRun := 0;
  RunCalc[1]  := Run[1];
  if (Rech[1]>Rech[2]) then Rech[2]:=Rech[1];

  for jj:=2 to NumDat do if Method=1 then
  begin
    if Run[jj]>RunRef then
    begin
       if CountA<3 then AlphCalc[jj] := Slope1*RunCalc[jj-1] + Inter1
       else
       begin
         AlphCalc[jj] := Slope1*RunCalc[jj-1] + Inter1;
       end;
     end else
     begin
       if CountB<3 then AlphCalc[jj] := Slope2*RunCalc[jj-1] + Inter2
       else
       begin
         AlphCalc[jj] := Slope2*RunCalc[jj-1] + Inter2;
       end;
     end;
    if (AlphCalc[jj]<0) then
        AlphCalc[jj]:=0.01;
    Delta       := Time[jj] - Time[jj-1];
    Factor      := exp(-AlphCalc[jj]*Delta);
    Past        := RunCalc[jj-1]*Factor;
    Present     := Rech[jj]*(1-Factor);
    RunCalc[jj] := Past + Present;
    Residu      := Run[jj] - RunCalc[jj];
    ResiduAb    := abs(Residu);
    ResiduSq    := Residu*Residu;
    SumResRunSq := SumResRunSq + ResiduSq;
    SumResRunAb := SumResRunAb + ResiduAb;
    SumRun      := SumRun+Run[jj];
  end;

  if TrialNr=1 then
     SumResSq13:=SumResRunSq;
  if TrialNr=2 then
     SumResSq14:=SumResRunSq;
  if TrialNr=3 then
     SumResSq15:=SumResRunSq;
  if TrialNr=4 then
     SumResSq16:=SumResRunSq;
  if TrialNr=5 then
     SumResSq17:=SumResRunSq;
  if not NoWrite then
  begin
    RunAv:=SumRun/NumDat;
    SumSqAv:=0;
    for jj:=1 to NumDat do with DMRainOff do
       SumSqAv:=SumSqAv+sqr(Run[jj]-RunAv);
    Rsq:=1-0.5*SumResRunSq/SumSqAv;
    if Rsq<=0 then Rsq:=0.01;
    if Rsq>=1 then Rsq:=0.99;
  end;

end;
{end of Construc}
{---------------}


{WriteOut is part of Main Program}
{--------------------------------}
procedure WriteOut;

var
OutFile     : textfile;
AvDev       : real;
jj          : integer;
AA,BB,DD : string;

begin
  DMRainOff.FileName := ChangeFileExt (DMRainOff.FileName,'.out');
  assign (OutFile,DMRainOff.FileName);
  rewrite (OutFile);
  writeln (OutFile,'RESULTS OF RainOff PROGRAM');
  writeln (OutFile);
  writeln (OutFile,DMRainOff.Title1);
  writeln (OutFile,DMRainOff.Title2);
  DMRainOff.FileName := ChangeFileExt (DMRainOff.FileName,'.inp');
  writeln (OutFile,'Name of input file used: ',DMRainOff.FileName);
  writeln (OutFile);
  writeln (OutFile,'Maximum dead storage:  ',StorMax:6:2,' mm');
  writeln (OutFile,'Initial dead storage:  ',StorIni:6:2,' mm');
  EscMax:=3;
  writeln (OutFile,'Max. escape/time unit: ',EscMax:6:2,' ',RR);
  writeln (OutFile);

  if Method=1 then
  begin
    writeln(OutFile,'REGRESSION: alpha = A * runoff + C');
(*
    writeln (OutFile,'if Discharge >',format('%5.2f',[RunRef]),
                     ' then A = ',A1Coeff:7:4,'  B = ',B1Coeff:7:4,'  C = ',C1Coeff:7:4);
    writeln (OutFile,'if Discharge <',format('%5.2f',[RunRef]),
                     ' then A = ',A2Coeff:7:4,'  B = ',B2Coeff:7:4,'  C = ',C2Coeff:7:4);
*)
    writeln (OutFile,'if Discharge >',format('%5.2f',[RunRef]),
                     ' then A = ',Slope1:7:4,'  C = ',Inter1:7:4);
    writeln (OutFile,'if Discharge <',format('%5.2f',[RunRef]),
                     ' then A = ',Slope2:7:4,'  C = ',Inter2:7:4);
  end;
  if Method=5 then
  begin
    writeln(OutFile,'REGRESSION: alpha = A*runoff^2+B*runoff+C');
    writeln (Outfile,'A =',Acoeff:10:5,'   B =',Bcoeff:10:5,
                     '   C =',Ccoeff:10:5);
    writeln (Outfile,'Quadratic function');
  end;
  writeln (OutFile);

  if length(TT)=1 then AA:='        ';
  if length(TT)=2 then AA:='       ';
  if length(TT)=3 then AA:='      ';
  if length(TT)=4 then AA:='     ';
  if length(TT)=5 then AA:='    ';
  if length(TT)=6 then AA:='   ';
  if length(TT)=7 then AA:='  ';
  if length(TT)=8 then AA:=' ';
  writeln (OutFile,'--------------------------------------------');
  writeln (OutFile,'Serial    Time     Runoff    Alpha     Alpha');
  writeln (OutFile,' No.               maes.     meas.     regr.');
  writeln (OutFile,'          ',TT,AA,RR                         );
  writeln (OutFile,'--------------------------------------------');

  for jj:=2 to NumDat do if Trace[jj] then
  begin
   write (OutFile,' ',SerNum[jj]);
   if Serial[jj]<10 then write (OutFile,'  ')
   else if Serial[jj]<100 then write (OutFile,' ');
   write (OutFile,Time[jj]:10:2,Flow[jj]:10:3);
   LowSq:=0;
   if Run[jj]>RunRef then
   begin
     writeln (OutFile,Alfa1[jj]:10:3,AlfReg[jj]:10:4);
     AlfDev:=Sqr(Alfa1[jj]-AlfReg[jj]);
     LowSq:=LowSq+AlfDev;
   end else
   begin
     writeln (OutFile,Alfa2[jj]:10:3,AlfReg[jj]:10:4);
     AlfDev:=Sqr(Alfa2[jj]-AlfReg[jj]);
     LowSq:=LowSq+AlfDev;
   end;
  end;
  writeln (OutFile,'--------------------------------------------');
  if LowSq<=0 then LowSq:=0.001;
  AvDev := exp(0.5*ln(LowSq/(NumDat-2)));
  writeln(OutFile,'Stand. dev. of calc. from meas. alpha:',AvDev:6:3);
  writeln (OutFile);
  writeln (OutFile);
  if length(TT)=1 then AA:='         ';
  if length(TT)=2 then AA:='        ';
  if length(TT)=3 then AA:='       ';
  if length(TT)=4 then AA:='      ';
  if length(TT)=5 then AA:='     ';
  if length(TT)=6 then AA:='    ';
  if length(RR)=1 then BB:='         ';
  if length(RR)=2 then BB:='        ';
  if length(RR)=3 then BB:='       ';
  if length(RR)=4 then BB:='      ';
  if length(RR)=5 then BB:='     ';
  if length(RR)=6 then BB:='    ';
  if length(RR)=7 then BB:='   ';
  if length(RR)=8 then BB:='  ';
  if length(RR)=9 then BB:=' ';
  if length(RR)=2 then DD:='                  ';
  if length(RR)=3 then DD:='                 ';
  if length(RR)=4 then DD:='                ';
  if length(RR)=5 then DD:='               ';
  if length(RR)=6 then DD:='              ';
  if length(RR)=7 then DD:='             ';
  if length(RR)=8 then DD:='            ';
  if length(RR)=9 then DD:='           ';
  if length(RR)=10 then DD:='         ';

  writeln (OutFile,'RECONSTRUCTION:');
  writeln (OutFile,'----------------------------------------------------------------');
  writeln (OutFile,'Serial    Time      Rain    Recharge   Runoff    Alpha    Runoff');
  writeln (OutFile,' No.                         calc.     meas.     calc.    calc. ');
  writeln (OutFile,'          ',TT, AA,   RR, BB,RR,  BB,   RR,       DD,      RR     );
  writeln (OutFile,'----------------------------------------------------------------');
  AlphCalc[1]:=0;
  for jj:=1 to NumDat do
  begin
   write (OutFile,' ',SerNum[jj]);
   if Serial[jj]<10 then write (OutFile,'  ')
   else if Serial[jj]<100 then write (OutFile,' ');
   write (OutFile,Time[jj]:10:2,Rain[jj]:10:2,Rech[jj]:10:2);
   writeln (OutFile,Run[jj]:10:2,AlphCalc[jj]:10:3,RunCalc[jj]:10:2);
  end;
  writeln (OutFile,'----------------------------------------------------------------');
  AvDev := exp(0.5*ln(SumResRunSq/(NumDat-1)));
  writeln(OutFile,'Stand. dev. of calc. from meas. runoff:',AvDev:8:3);
  writeln(OutFile,'Coefficient of explanation R square is:',Rsq:8:3);
  writeln (OutFile);
  closefile (OutFile);
end;
{end of WriteOut}
{---------------}

end.
