inherited RainForm: TRainForm
  Left = 174
  Top = 34
  Width = 677
  Height = 623
  Anchors = []
  Caption = 'RainOff, rainfall runoff relations'
  Menu = MainMenu1
  OldCreateOrder = True
  OnClose = FormClose
  OnCreate = FormCreate
  PixelsPerInch = 96
  TextHeight = 16
  inherited StatusBar1: TStatusBar
    Top = 547
    Width = 661
  end
  object PageControl1: TPageControl
    Left = 0
    Top = 0
    Width = 661
    Height = 547
    ActivePage = InputTabSheet
    Align = alClient
    TabOrder = 1
    object IntroTabSheet: TTabSheet
      Caption = '  Intro  '
      OnShow = IntroTabSheetShow
      object IntroMemo: TMemo
        Left = 8
        Top = 33
        Width = 465
        Height = 424
        Color = 14547711
        Lines.Strings = (
          '                 INTRODUCTION TO THE RainOff PROGRAM'
          '                                        on www.waterlog.info'
          ''
          
            '   The RainOff program calculates the runoff of rainfall on wate' +
            'rsheds'
          
            '   with an area over which the spatial rainfall distribution is ' +
            'regular.'
          
            '        It converts the rainfall into recharge by routing the ra' +
            'infall'
          
            '   through a reservoir from which water escapes according to pre' +
            '-deter-'
          
            '   mined characteristcs such as storage capacity, initial storag' +
            'e and '
          
            '   maximum rate of escape representing evaporation or subsurface' +
            ' drainage.'
          
            '   This, first, reservoir gives the recharge (rainfall excess) a' +
            's overflow.'
          
            '         The recharge is routed through a second, non-linear, re' +
            'servoir with '
          
            '   a reaction factor whose value depends on the storage level. T' +
            'hus, the '
          '   the runoff is produced.'
          
            '        The reaction factor can be determined from recorded rain' +
            'fall-runoff'
          
            '   data. The program uses linear and quadratic reservoir functio' +
            'ns and '
          '   selects the function that produces the best data fit.'
          
            '        Alternatively, it is possible to introduce the reservoir' +
            ' function,'
          
            '   together with rainfall data, and the program will calculate t' +
            'he runoff.'
          ''
          
            '   This standard RainOff model needs periods without rainfall an' +
            'd recharge'
          
            '   to determine the reservoir function. However, the versatile R' +
            'ainOffT'
          
            '   model does not have this requirement, but it takes a longer t' +
            'ime for'
          
            '   calculations. Alternatively, the RainOffQ model can be used; ' +
            'it employs'
          '   a quadratic reservoir function.'
          ''
          '   sitemaster@waterlog.info')
        ReadOnly = True
        TabOrder = 0
      end
      object HelpGroupBox: TGroupBox
        Left = 480
        Top = 48
        Width = 161
        Height = 305
        Caption = 'Details'
        TabOrder = 1
        object FirstButton: TButton
          Left = 16
          Top = 40
          Width = 129
          Height = 33
          Caption = '1st (pre) reservoir'
          TabOrder = 0
          OnClick = FirstButtonClick
        end
        object SecondButton: TButton
          Left = 16
          Top = 96
          Width = 129
          Height = 33
          Caption = '2nd (main) reservoir'
          TabOrder = 1
          OnClick = SecondButtonClick
        end
        object AlphaButton: TButton
          Left = 16
          Top = 152
          Width = 129
          Height = 37
          Caption = 'Alpha (response) function'
          TabOrder = 2
          WordWrap = True
          OnClick = AlphaButtonClick
        end
        object HeadButton: TButton
          Left = 16
          Top = 208
          Width = 129
          Height = 33
          Caption = 'Water level (head)'
          TabOrder = 3
          OnClick = HeadButtonClick
        end
      end
      object FirstMemo: TMemo
        Left = 16
        Top = 40
        Width = 457
        Height = 377
        Color = 15138801
        Font.Charset = ANSI_CHARSET
        Font.Color = clWindowText
        Font.Height = -12
        Font.Name = 'Tahoma'
        Font.Style = []
        Lines.Strings = (
          '        CONVERSION OF RAINFALL INTO RECHARGE THROUGH THE '
          '        FIRST RESERVOIR'
          ''
          
            '   The recharge is found as the overflow (recharge) of a first r' +
            'eservoir, '
          
            '   that is characterised by a maximum (dead) storage capacitity ' +
            '(MaxSto, mm), '
          
            '   an actual (dead) storage (ActSto), and a maximum escape rate ' +
            '(MaxEsc, mm,'
          
            '   representing the evaporation and/or natural subsurface draina' +
            'ge per unit '
          '   of time t) and an actual escape rate (ActEsc, mm/t).'
          
            '       The initial value of ActSto must be given as IniSto. The ' +
            '(dead)'
          
            '   storage deficit is found as StoDef = MaxSto + ActEsc*t - ActS' +
            'to (mm).'
          
            '       The actual escape rate is found from the ratio R = ActSto' +
            '/MaxSto as'
          '   ActEsc = R * MaxEsc (mm/t).'
          
            '       Thus, the recharge in period of time Delta is determined ' +
            'as '
          
            '   Rech = Rain - StoDef/Delta (mm/t). However, when Rech < 0 we ' +
            'set '
          '   Rech = 0.'
          
            '       The value of ActSto2 at time T2 is found from ActSto1 at ' +
            'time '
          '   T1 = T2-Delta, where Delta is the time step, as: '
          '    ActSto2 = ActSto1 +  (Rain - Rech - ActEsc)*Delta.'
          '   '
          
            '   The initial abstraction in the US-SCS Curve Number Method com' +
            'pares with'
          
            '   the initial value of StoDef equalling StoDef(ini) = MaxSto - ' +
            'IniSto. '
          
            '       The total retention in this method compares with StoDef(i' +
            'ni) + EscTot, '
          '   where EscTot is the sum of escape values ActEsc * Delta .')
        ParentFont = False
        TabOrder = 2
        Visible = False
      end
      object SecondMemo: TMemo
        Left = 24
        Top = 24
        Width = 441
        Height = 417
        Color = 14024701
        Font.Charset = ANSI_CHARSET
        Font.Color = clWindowText
        Font.Height = -12
        Font.Name = 'Tahoma'
        Font.Style = []
        Lines.Strings = (
          '            CALCULATING RUNOFF FROM THE SECOND RESERVOIR '
          '              USING THE RECHARGE COMING FROM THE FIRST '
          ''
          '   The runoff equation is:'
          
            '           Run2 = Run1*Exp(-Alpha*Delta2) + Rech2*[1-Exp(-Alpha*' +
            'Delta2)]    '
          '  '
          '   where:'
          
            '   Delta2  is the time interval under consideration (Time2-Time1' +
            '), '
          
            '   Run2    is the amount of runoff occurring in the time interva' +
            'l Delta2,'
          
            '   Run1    is the amount of runoff of the previous time interval' +
            ' Delta1,'
          
            '   Alpha    is the reservoir function or reservoir reaction fact' +
            'or,'
          
            '   Rech2   is the recharge, coming as overflow from the 1st rese' +
            'rvoir,'
          '                during the time interval Delta2.'
          ''
          
            '   Starting with the given initial runoff (Run1=RunIni), the abo' +
            've equation'
          
            '   is used for all the consecutive time steps to obtain the hydr' +
            'ograph'
          '   of the runoff.'
          
            '        The equation can be used for watersheds with free outflo' +
            'w whose '
          
            '   maximum surface area corresponds to the area over which the r' +
            'ainfall '
          '   can be considered uniformly distributed. '
          
            '        The Alpha function can depend on the runoff itself and s' +
            'hould either '
          '   be given or determined from given runoff data .'
          ''
          
            '   NOTE: Make sure that the time interval Delta is not greater t' +
            'han the time'
          
            '   of concentration of the watershed, otherwise the measured dis' +
            'charge may '
          
            '   be the result of an umeasured rainfall over a time interval t' +
            'hat is smaller '
          
            '   than Delta, and the results of the RainOff model may be disap' +
            'pointing. '
          
            '   For example, for small watersheds with a time of concentratio' +
            'n of 2 hours, '
          '   the time interval Delta needs to be < 2 hours, say 1 hour.')
        ParentFont = False
        TabOrder = 3
        Visible = False
      end
      object AlphaMemo: TMemo
        Left = 40
        Top = 24
        Width = 441
        Height = 401
        Color = 16710655
        Font.Charset = ANSI_CHARSET
        Font.Color = clWindowText
        Font.Height = -13
        Font.Name = 'Tahoma'
        Font.Style = []
        Lines.Strings = (
          '    DETERMING THE ALPHA FUNCTION FROM RAINFALL-RUNOFF DATA'
          ''
          
            '   During dry spells with zero rainfall, the runoff equation red' +
            'uces to:'
          ''
          '           Run2 = Run1*Exp(Alpha2*Delta2)'
          '   or:'
          '           Alpha2 = -[Ln(Run1/Run2)]/Delta2'
          ''
          '   where:     '
          
            '   Delta2  is the time interval under consideration (Time2-Time1' +
            '), '
          
            '   Run2    is the amount of runoff occurring in the time interva' +
            'l Delta2,'
          
            '   Run1    is the amount of runoff of the previous time interval' +
            ' Delta1,'
          
            '   Alpha2  is the reservoir function or reservoir reaction facto' +
            'r in the'
          '                time interval Delta2'
          ''
          
            '   When the rainfall is not zero the Alpha2 value is found from ' +
            'the runoff'
          '   equation using a trial and error procedure.'
          ''
          
            '   Through a regression, the RainOff program determines the rela' +
            'tion '
          
            '   between Alpha2 and Run1 as a constant, a linear function or a' +
            ' '
          '   quadratic function, whichever gives the best fit: '
          
            '   Alpha2=C,  Alpha2 = A*Run1+C,  or  Alpha2 = A*Run1^2+B*Run1+C' +
            ' '
          '   respectively. '
          '   When Alpha2=C, the reservoir is called linear.')
        ParentFont = False
        TabOrder = 4
        Visible = False
      end
      object HeadMemo: TMemo
        Left = 40
        Top = 48
        Width = 425
        Height = 361
        Color = 16318438
        Font.Charset = ANSI_CHARSET
        Font.Color = clWindowText
        Font.Height = -13
        Font.Name = 'Tahoma'
        Font.Style = []
        Lines.Strings = (
          '           DETERMINING THE WATER LEVEL (HEAD) '
          '  '
          '   The water level or head is found from:'
          ''
          '           Head2 = Head1 + 100*(Rech-Run)/EffPor'
          ''
          '   where:'
          '   Head2  is the head at the end of the timpe step'
          '   Head1  is the head at the end of the previous time step'
          '   Rech    is the recharge during the time step'
          '   Run     is the discharge or runoff during the time step'
          '   EffPor  is the effective porosity in %'
          ''
          
            '   The initial head (Head0 = Head1 before the first time step) i' +
            's given'
          '   with the input data. '
          
            '        In well defined and regular subsurface drainage systems ' +
            'the '
          
            '   value of Head0, Head1, and Head2 equals the height of the wat' +
            'er '
          '   table above drain level. '
          
            '        In surface drainage, natural subsurface drainage, or in ' +
            'irregular'
          
            '   artificial subsurface drainage system, the head has little ph' +
            'ysical '
          '   meaning, as it is the water level of a conceptual reservoir.')
        ParentFont = False
        TabOrder = 5
        Visible = False
      end
      object BackButton: TButton
        Left = 528
        Top = 312
        Width = 65
        Height = 25
        Caption = 'Back'
        TabOrder = 6
        OnClick = BackButtonClick
      end
    end
    object FigureTabSheet: TTabSheet
      Caption = ' Figure '
      ImageIndex = 4
      object Reservoir_Image: TImage
        Left = 72
        Top = 24
        Width = 513
        Height = 425
        Picture.Data = {
          0A544A504547496D616765DAA50000FFD8FFE000104A46494600010101006000
          600000FFE100224578696600004D4D002A000000080001011200030000000100
          01000000000000FFDB0043000201010201010202020202020202030503030303
          030604040305070607070706070708090B0908080A0807070A0D0A0A0B0C0C0C
          0C07090E0F0D0C0E0B0C0C0CFFDB004301020202030303060303060C0807080C
          0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C
          0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0C0CFFC000110801B3020F030122000211
          01031101FFC4001F000001050101010101010000000000000000010203040506
          0708090A0BFFC400B5100002010303020403050504040000017D010203000411
          05122131410613516107227114328191A1082342B1C11552D1F0243362728209
          0A161718191A25262728292A3435363738393A434445464748494A5354555657
          58595A636465666768696A737475767778797A838485868788898A9293949596
          9798999AA2A3A4A5A6A7A8A9AAB2B3B4B5B6B7B8B9BAC2C3C4C5C6C7C8C9CAD2
          D3D4D5D6D7D8D9DAE1E2E3E4E5E6E7E8E9EAF1F2F3F4F5F6F7F8F9FAFFC4001F
          0100030101010101010101010000000000000102030405060708090A0BFFC400
          B511000201020404030407050404000102770001020311040521310612415107
          61711322328108144291A1B1C109233352F0156272D10A162434E125F1171819
          1A262728292A35363738393A434445464748494A535455565758595A63646566
          6768696A737475767778797A82838485868788898A92939495969798999AA2A3
          A4A5A6A7A8A9AAB2B3B4B5B6B7B8B9BAC2C3C4C5C6C7C8C9CAD2D3D4D5D6D7D8
          D9DAE2E3E4E5E6E7E8E9EAF2F3F4F5F6F7F8F9FAFFDA000C0301000211031100
          3F00FDFCA28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800
          A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800
          A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800
          A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800
          A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800
          A2BE1EFD897FE0B2FA17ED3FE04B7F15789353F803A069371E15B5F123E8DE14
          F8AD278C3C5FA7CB7325A450D8DCE8D169704AB7066BB8EDBCB89E595AEE482D
          E38E479971EDD73FF0511F85707856CF524D43C61797579773D9FF00C23F63E0
          6D76F3C5166F024324C6E7458ACDB52B58D23BAB376927B648C25FD936EDB776
          E6400F73A2BC720FDBCFE13DFF008EF48D06C7C55FDADFDB9F615B6D6B4CD32F
          2FFC3692DF4714B636F36B30C4FA75BDC5CA5C5AB4104D7092CC2F6CFCB46FB5
          41E6607C3CFF0082A2FC0BF8AFE0693C4DE1FF001C9D43417D2A0D62C2EC68BA
          844BAF412C9040134C0F029D4AE12EAE6DAD25B6B3134F0DE5CC1692469732A4
          2C01F41515C5FC15F8EDE19FDA0FC2D3EADE19BAD4248EC6EDAC2FACF53D2AEF
          48D4F4BB80892793756379145756D23452C332A4D1217867865506396376ED28
          00A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A28
          00A28A2800A28A2800A28A2800A28A2800A28A3340051451400514668A0028A2
          8A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A2
          8A0028A28A0028A28A0028A28A0028AF87BE38FF00C1613FE14E7ED2FF00123C
          07FD93F07EE3FE15B6AB69A6FF00625E7C50FB1F8FBC5DE769361A96DD17C3FF
          00D9CFF6EB893EDDF65B687ED71FDA6E6231EF8B7647AF7C5DFF008290FC33F8
          5FA3F8F3CBD6B76A1E09D2B58BDFB5EA7A56AD67E1BD46EB4CB59EE2EECA1D5E
          3B29ADAE2E205B5B9F3EDECBED57508B3BCFF4766B5991003E83A2BC77E1A7ED
          DDF0CFE2D7C52B8F07E8DAA78817568755D4B4286E351F0AEADA6695A9EA3A7C
          D3C37B6765A8DCDB47677B71135ADD9315B4D2394B4B8700A43232FB15001451
          45007C9BF03FF61BF8B9F0D3F648B0F82BAF7C56F863E24F06F87FC1567E0FD2
          553E16C91C9769691DBC089A9A5D6AD756F7B67716F0C905D5BC715BC92C770F
          E54F6CE15C1E08FF00827FF8FBE1369DE0BD5FC2BF13BC1FA7F8E3C1769AD689
          62979E08B8B9F08E97A36A93E9D3CBA769FA62EA91DDDB470C9A55998049A8CF
          1C0B25CC31C496E6D20B3FACABCEFF006A1F8E5FF0CE3F0275CF1643A59D7F57
          B7FB3E9FA1E8DF69FB2FF6F6B17971159E9BA7F9E51D6DFED37D716D6FE7C8BE
          5C5E779921088CC003E72F8D5FF04868FE34FC7CF0DF8E756F1E69FAC6A5E1BF
          10785FC4F16B7AFF0082B4ED4BC59F68D1AE74F77B283531E5258E97749652CC
          F69656D015BEBEB99C4A60965B193CFF00E09FFC11F3C4DF12FF00627F853E11
          F8CDE2AB0D4755F01FC35D1FC35A46857FE1CB4BCB7D22E12E741D56EEC758F2
          A736FAC59A5FE81636C91C0B685AC96E23927B89A517A9EDDFF047DFDB135EFD
          B67F604F0278A3C690FD93E2358E95A7DA78B23DF1BF9979369D697F05DE628E
          3847DB6C2F6C6FBCA846D83EDDE4122485D57EA3A00F1DFD8AFF00652B3FD907
          E16EA1A0DADAFC3FB19B58D564D5EEEDBC13E0AB5F08E8304AD0C30016F630BC
          B20CC76F1B3BDC5C5C4AD23498912110C10FB151450014514500145145001451
          4500145145001451450014514500145145001451450014514500145145001451
          45001451450034839A319A09E39AF917E347EDF3E2EF831E33F8F1637DA57877
          FB3BC1F6B3FF00C2117AD14DB6F2FEDB42B3D52E2CAF479BF3BB0B9792231797
          BA2B798101A3DEF518B96DD3515F54BB9F5D63068EDCD7CBFE33FF0082A9783B
          E1E4FAF5D6B1E0DF8890785F471AC5BD8F89D6CAD1B4EF125FE930CD35F5858C
          5F6AFB634C8B6B79B1A6B78A197EC92F972B8285FA8F0EFF00C1413C17696FE2
          C9BE22DBEA1F03E1F080B196EA6F881A8699A6DB4F6D7AD2A5A5CA5C4577342A
          B2BC13208E578E7564C3C4B95CE7D2FDD5FF00419EF18A3757C53F063FE0A773
          1B8934BD434FF137C4ED6B58D6EF6CFC3F69E17D2AC4497A8751F10FD9B1752D
          E436C63FB268E143C8B12A95566964F3498E4F8A1FF05D1F82FF00069BC3B0F8
          91756D1350D52D64BCD5B4FD5356D0F4CBCF0CC51DEDC58CA668AEB5189AF192
          E2D2ED4A697F6D7220C85612C065B941A97275D17CFB077FEB4DAE7DA59209A0
          3E4D7C9FF15FFE0B01F0CFE0B7C7AF177C3EF1069FABC3ACF84F48BCD648B3D5
          F42D42E3528AD6CBEDCE91585BEA326A31335B87643756902315C07CBC61FD5B
          C6FF00B56DBFC35F80F67E3AD7FC13E3AD37EDFAA5A6930681F67B4B8D61E5BA
          BE4B2B63E5C370F10591A58E4C1943223FCEA8EAC8B3B24DF5B5BE7A2FC43AFF
          005D2D73D680F9A8C6DAF92BC45FF0589F859E06FDA4B45F855E2086FF0040F1
          76A171A769B7F677BAE682B75A16A37D145241632D92EA2D7B7321FB440A65B0
          B7BAB60D2E3CEC47298F2E5FF82D87C33B0F8010FC4CBEF0FF008A34AF07EB57
          D0E9FE16D4B51D57C3F6767E2E793ED44FD9EEE5D4D6D6D5A35B39CC916A335A
          4D1B2AC6D1899D622F95DB9BA6D7FC87C8EF6B79FCAD7B9F649E9FCA8E95F2CF
          C2BFF82ADF843E3AE82FA9F80FC15F107C716367E1C6F12DFDC68A34AB9B7B08
          D5F5084DBF9FF6E10DC4E6E74D9E002D5E646768DD5CC2C655EAFC71FF000503
          F0CF876F2DED340F0DF8CFE205F6AA9A58D16DBC3B6F6AFF00DB935F5BDD5DAD
          BC335CDC43023C5676AD752B4F2451AC52C187679150A6B97DD7BAB5FE7A7E7A
          0BFCAFF76E7BD9EB46707F9D7C9FA4FF00C153B41D7FC55A7D9E8FE13F1D7896
          FBC4096B6561E1BD3B49B34D52C753FF0089CFDAAD2E6E25BF5B60F13E8D730B
          E4A451BC6089E6494347F5746E5D0315DA7AE0F6A728B8EE1E44945145001451
          45001451450014514500145145001451450014514500145145007CFBE2CFD86B
          FB7AEFE25EA967E28FECDF1378BBE2069BF11FC37AA2E9BB9BC2DA8D8E91A4E9
          89136255927B7B88F4D962B958E4B779ECF52BBB50F187329F01FDA5FF00E085
          B67FB467C45F1478864F1D787F4BD435BFF84A561D65BC096B77E26B98B5FD0F
          57D324B7D47576985CDE5BD8B6A710B182236D14369651DB4A970CB05CDBFD3B
          F153F66CF1A78FBC777DABE93FB427C5FF0003E9F79E5F97A268BA6F85A6B0B2
          DB1AA1F2DAF746B9B93BD94B9F3267F99D82ED5DAAB85FF0C6DF117FE8EC7E3F
          FF00E0A3C11FFCCF50037C1DFB0CFF00C225FF000AE7FE2A8371FF000AFF00E2
          AF8ABE26FF00C83767DBFF00B6FF00E124FF0042FF005A7CBF23FE120FF5BF37
          99F64FF569E6FEEFE82AF9FF00FE18DBE22FFD1D8FC7FF00FC147823FF0099EA
          3FE18DBE22FF00D1D8FC7FFF00C147823FF99EA00FA028AF9FFF00E18DBE22FF
          00D1D8FC7FFF00C147823FF99EAE37C57E14F891FB36FED21F00E19BE3E7C50F
          1F68BE3EF1ADEF86F57D1FC47A578663B59ADD7C31AEEA28EAF61A45ADC248B7
          1A7DB9044B820302A437001F595796F8EBE0AEADF133F69EF03F89756B8D3D7C
          1FF0D6D6EF53D22C51DDAEAEFC4175149642F24C2AF951DAE9F2DEC289E64A97
          0758959E389ECA0924F52A2803E1EFF8268FC2ED7BC2FF00B3E7EC7DF10BC2F6
          3F6ED3FC55F057C35E0DF1CC5E7471F93676DA31BFD2752CC8C4B7D96EA4BDB4
          F22050D2FF006FF9B2315B245AFB86BE7FFF00824EFF00CA2CBF669FFB255E17
          FF00D345AD7D0140051451400514514005145140051451400514514005145140
          0514514005145140051451400514514005145140051451400514504E2801A0E4
          F35E33F1BBF61CF05FED01F0E7E24785F5F9B5D5B1F89DA843AADFCF67782DEE
          B4EB88ACED2CD1ED6454CA7EEECE3C87DE1F7CAAC1A3731D7B2F6AF2AB9FDB5F
          E18DA35C2C9E288D4D9D96B5A84E3EC573FBA8748B96B6D409FDDF0D14C92284
          FBF208A468C3AA310E2DA765D7FE1FF4B859BD57F57FF33CE3C59FF04B7F07F8
          DB54D6A2D4BC5DF10AEBC2DA936AF77A77861EEAC9B4CF0E5FEAB14D15EDF59B
          9B5375E73ADCDDED49E79608FED72EC8906C09EE3A17C24D37C3DF16B5EF1941
          35F36A9E21D2F4FD26E6277536E9159BDD3C4C802860C4DDC9B89620854C0183
          9F98FF00691FF82B169FF06BC3BA8269FA25C5F6A527863C53AE58EA56FA46AF
          A8E8F6D368D79F6411DDCAB6712428CC1CCAF24B14713205123ACB14AFEFDF04
          BF6AEF05FC7E3AF47E1FBED63ED7E1811BEA56BAA787F50D1EE12394398AE238
          AF2089E6B793CB93CB9E20F149E5B85762A70B9BDC4D6CAFF868FF00114BE2B3
          DDFF00C038FF00027FC13DFC17F0EFE315978D2C753F144DAA596A736AB1C53D
          CC0D6ED2CB26B323020421B683AE5DE0060711C3C9DAFBE8C5FF0004F8B3F0C7
          8B7FB73C11F13FE27FC3BD52F1EEBFB566D19B48BA4D6E29B51BBD45639E2BFB
          0B98944335F5D2A3C2914BB25DAEF26D42ABE06FF82A77C0DF887A9E9769A4F8
          BB549A4D624B34B5926F0B6AF6B03A5E296B39DA596D5634B7B921A382776114
          F2A3C51BBCAAC82FFC63FDB5F43F0E7843E1FDE784F50B3D4AEFE215D68D77A5
          25D595C84BAD26EF53D3ACE7B81C26C754D4222AB210DB9C128C1580AF7A4D77
          BA4BD7B7DDAFA0DC96B7ED77E88E47C51FF04A9F0AF8CA6D52CEFBC7DF127FE1
          18BED4359D56D3C3B049A5C1A7E9575AB437915F4B132588B9959CDF5C38FB4C
          D36C62BB70A0A9F78F8A9F0834DF8BBE1BD3F4BD4A7BE82DF4DD5F4ED66236AE
          AACD3595DC57712B16561B0C90A86000254900A9C11F3FFC3EFF0082B5FC3FF1
          3584D7DAE5AEB9E11B3B6BED534F91752F0EEBB1DD5CCB6BACC1A541F648DF4E
          55BA134971086113968A59562DAE448D1E959FFC14CBC13AF7C4AB5163A9CD17
          83ECF46D566D71351F0F6A5A7F8834ED52DAEB4986DEC4E9D3C51DE09A65D4D3
          CBB736C659CCD6DE506F3143CC62E5CA96B6DBAFC3AEFE4C249DF5DDBB7CDE87
          757DFB244D67F1D752F1B7877E25FC45F085AF88AF2DF50D7BC37A61D2E6D235
          CB88A18EDFCD93ED7653DCC0CF0430C6FF0064B8801112B00242CEDE6FA57FC1
          29F40D2F5CD53C4D27C4EF89D71F12AFEF34FBC87C77B344B7D76D0D95BDC5AC
          0ADE4E9B1DADE0FB3DDDCC25AFEDEE5CA4B8DD948CA7B3780FF6A3F047C44F85
          5AC78D2DB56B8D27C3FE1DF3FF00B624F1069977A0DC688208C4B2FDAEDAFA28
          67B6DB11597F7D1A663747194656387F08FF006E9F867F1B751B1B1D0F58D6A1
          D4B52D4574CB6B0D67C35A9E897D24AD672DEA37D9EF6DE1944325BC133A4E54
          452794EA8ECCA54118BF856FA7DDD3E5D839F4BF7D3EEE9FE66C7C1EFD9E57E1
          4F89F52D7AFF00C5BE2AF1B788F58D2ACB48BFD4F5C4B08E6BA8AD26BC962731
          D9DADBC2AFFE99229D91AA9548FE50DB99B873FF0004F3F0C69BF0C6CF41F0FF
          0089BC6DE14D5349F11C9E27D27C47A6DD5B36A9A4DCB42F6A9146B3DBCB6B25
          BC762FF634867824510226419544B5C4FED55FF054BD17E0CC779A7F8634AD63
          C41A8DC7857C47ACE9FA92F87356BAD360BDD22E96D1EDEE5A1B7D91C5E779C1
          E59268917CA4E713C4C7D48FEDD3F0F64F19EA9E1CB7BED7AF356D2E3BCFDE43
          E18D55B4DD42E2D11DEE6CED2FC5B1B4BBBB8BCB9435B5BCB24EAD04CA63DD14
          81549FBBED5EDAEBE8F5FBAC545497BBE76FBD592F9A303E12FF00C138BC0FF0
          7BC79E1BF1169FAA78A6EB56F0EB25C4935DDC5BB7F6ADDEDD5BCFBBB9090AE6
          69E4D6AF6693CBF2D3798F62222943F419E2BE68F81BFF00054DF86BF18FC1DE
          01BAB887C69A2EBDE3AD3F4FBC3A53F8335D906906F1C4501BA9CD8AA5BDBCB3
          EF8E1B9B8F2A1B8F2DDA36655623E97EBCD69352BDE5DFF1EA66AD7F3D3D4751
          4515050514514005145140051451400514514005145140051451400514514005
          14514005145140057CFDFB647FC9C57EC9FF00F6556FBFF508F15D7D035F3F7E
          D91FF2715FB27FFD955BEFFD423C57401F40D1451401F3FF00FC1277FE5165FB
          34FF00D92AF0BFFE9A2D6BE80AF9FF00FE093BFF0028B2FD9A7FEC95785FFF00
          4D16B5F405001457967ED83F1A754F809F049B5AD0EDF4F9B5BD575FD07C2DA7
          C97F1BCB6B6371AC6B365A4C5772C48C8F3476EF7AB3B40B244661098C4B097F
          353C4BE29FED23E2EFF827978C9748F14F89BC41F1A3C3379E15D47C777DAD78
          8134DD3354F0AE99A4EA9A25AEB131FECEB2821BBB786C3576BE8E04B61725F4
          D9E2125C1BB812D403EC0A2BE2EF8E5FF0568D43C05E29FEC5F08FC31D43C617
          9A97883C43A6E8772835ABAB5D52CB407D3EC756BA923D2348D4AFADA48B58BD
          9AC5124B4F2641612CDF695596D927CFF88FFF000546F88DABFECC9FB45F8F3C
          0FF06BFB07FE147F8586B50BF8FB566D3E69EF24F0E695AF0B3B8D3EDE39278E
          E2D6DEFEE16E217922532C16B1473B7DA6E24B000FB868AF87FE0AFED8BF18F4
          EF8D1E32F83FFD93E1FF00889F13349D57FD1C7883C48BA3E9563A769FE15F06
          4DA96750B2D20BDCDC3EA7E21F323FF897409224B39FF4658A1B7278B7FE0B79
          E17F097C1E5F194FE07F102DAEA9A5693E31D12C24BB845E5FF85EF7C317DE23
          6D4A5DBBA282E161D13C43691DA798E64BAD360DF2416F76B731807DC14579EF
          C01F8E7FF0BE4F8D2F6CF4BFB2F87FC3BE2BBEF0CE93A97DA7CCFEDDFB07976D
          7D3F94515E0F27534D46CB63E77FD83CE4668A68CD7A15001451450014514500
          145145001451450014579EFED61F1CCFECC1FB2CFC4BF899FD97FDB83E1DF857
          54F13FF677DA7ECBFDA1F62B496E7C8F3763F97BFCADBBF636DDD9DAD8C1F00F
          D9F3FE0AC3A17C46D635E8FC4979F086FB49D1B4AFED37D6BE15FC4193E2158D
          9CBF6AB7B5874FBCF2B4FB5961D42F66BA8D2C2D228E796F9A0BB48D43C2A928
          07D83457865CFF00C1447E15C1E15B3D49350F185E5D5E5DCF67FF0008FD8F81
          B5DBCF1459BC090C931B9D162B36D4AD6348EEACDDA49ED923097F64DBB6DDDB
          99303E177FC1507E187C4AF8DDE2BF04AEB5A7AC9A3F8834CD2349D534F965D5
          34CD56DF52D1B4AD474FBD9EF2088DAD8477B2EA46D2CFED13017B35B32DBB4B
          21312007D25457CFB77FF0545F815A3787351D6B55F1CFFC23FE1FD3FEC92AEB
          3AD68BA8695A56A96B737D6D6115FD85DDCC11C17FA78B8BDB30F7D68F2DAC49
          796F2C92A45346ED7BC41FF0518F83FE14F15E87A2EADE26D4348D4BC4577A46
          99671DFF0087753B551A96A8F6EB63A4CAF25B84835474BB8276D3E6297715BB
          9B89218E05795403DD28AF2CF82DFB647C3CFDA13C5571A3F85758D42EAF16D5
          B51B292EF43BFD36D75FB257446BED2EE2E618E1D52CD4CB0137362F3C205D5B
          317DB71097F53A0028A28A006115F32F8D7FE09CD67E31F19F8A7567F14491A7
          883C4565AADBDA3E9FE645A7D8AC5325FD8FFAD024FB59BDD459A52004FB4A0F
          2DFC91BBE9B3FCE85E4528FBAF997A7CB47FA0A5AC797A3DCF92FE28FF00C135
          B5AF16F84974BD0FE2258E8FF6DB1F1768FAA35EF869AF92EAC75FD405FB0855
          6EE130DC5BC891AAC8CD223A8933102CA53DCB4CF819FD9BF19BC5FE2DFED4F3
          3FE12BD074DD0FEC9F66C7D97EC6F7CFE6EFDFF3EFFB6E36ED1B7CBEA777CBE8
          5B68DA314B78723DB5D3D77FC47D6FFD7F5A1F30E8DFF04E15D2FC1FA5E8F278
          C9A68F4FD1FC15A4B48BA56D328F0EDE49725C0F38EDFB4F99B31CF958CE64E9
          5CCF85BFE099FE308AF7C0117893E2B68DAC68FF000BECAC748F0FDB597835AC
          277B2B4D4F4ABD8FED72B5F4A26B965D2D62696248632652EB0AEDD8DF6215A3
          6E6B48D46A5CE9EB7E6F9DAD7FB8971BAB3F25F247C37F1A3FE09C9F132CCC1A
          87843C6FE1DD5AEB4AF143EA1E1EB6BEF0C3674982FF00C53A76B57525EB8D42
          217AB6ED6D36D4885B3BC65572645DEF6FE247FC1209BE38AF8A358F1CF8DBC3
          FAF78C7C68B25CEB120F072FF605CDE24FA2BD9FFC4B2E2EA7DD66916876D14D
          6F24EED3F9D3B09A125027DB39C0FA5371C8A9849C63CABA376F9EFF00E669CC
          DC9CBABD5FF5FD23E77F847FB04E9BE08FD92BC69F0A6FAD7E17F86ECFC731DE
          DBDE4BF0C3C0A9E0CB28D6E6DD60F385A35CDE2B5CAAA8FDEBB90C12352985E7
          8F6FF827E7C4ABEF1E45F12B50F8B5E12BAF8C3A7DDD80B0D593C073C5A00B1B
          3B3D46D52DEE34DFED3334B237F6B5F48D3477B10DE61C461236493EBA2B9340
          1D69A93BB6BAA4BE44ABA5CAB6D7F1DCF8FBC55FF04CBF136BFF000D6C743B5F
          8A3A6C3A85C697E2CD175DBDBAF0999E2D4ADB5FBF17D2B410A5E466DE686548
          C2BB3CA8C9BC18F2CAC967E09FFC12CF47F821FB4F6ABE38B1B1F82B7B61A9EA
          9AA6AEB7F71F0C215F1D5B4BA879CF322EBE976B98D5E7955775997F208899D8
          8321FAE168E82A6567A3F3FC7561ADB97CD3F9A3E2FF00097FC1303C69A3F893
          E19DC5E7C4EF07F95F0DEC74CD1A2D6348F045D68DE2BBDD374F9DA48AC5B538
          35501EDA65110B9B6B8B79ED657469160898A88FED054C52D28A7CCDAB3FEAFB
          875BFCBEE0A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A28
          00A28A2800A28A2800A28A2800AF9FBF6C8FF938AFD93FFECAADF7FEA11E2BAF
          A06BE4DF8BBF1AF4BF8E1F183F657BEB1B7D4349D4B4AF8BFA8699AE687A9C69
          1EA7E1EBF4F02F89DE4B3BA8D19D1640924722BC6EF0CD0CD0CF0C93413452B8
          07D654579EFC0BF8E67E3FFF006A6B5A2E97FF001407EE93C3BE227B9FF91ABE
          FF009D776D0ECFF907FF00AA16F745FF00D2FF007B2C71FD9BECD7377E85401F
          3FFF00C1277FE5165FB34FFD92AF0BFF00E9A2D6BE80AF9FFF00E093BFF28B2F
          D9A7FEC95785FF00F4D16B5F4050065F8B7C29A5F8F3C2DA9E85AEE97A7EB5A1
          EB5692D86A1A7DFDBA5CDADFDBCA852586589C14923746656460430241041AE3
          FE077ECC9E11FD9D9B5393C3B0F882EB50D6BCA5BED53C43E24D4BC47AA5C450
          EF30DB9BDD4679EE7ECF134B3BC70093CA8DEE27754569A466F10FD9EFF6B0FD
          A47F693F809E07F88DA17C14F82369A278F7C3F61E24D3E0BEF8C1AA477515BD
          E5B4771124AA9E1A74590248A182BB0041C311C9ECFF00E1647ED4DFF4473F67
          FF00FC3C9ABFFF00331401BBADFEC27F0CF58F85BE05F07C3A5F88341D27E1AE
          951685E1A9FC3DE29D5B43D574BD3921861FB18D46CAE62BC7B765B7B6324524
          CC92BDB40F20778A365BF0FEC61F0BECFE12F8FF00C076BE0FD3F4EF06FC4EB4
          363E22D1EC2496CED6EADCE936DA37931244EBF658D74FB3B68152DFCB0A220C
          A0392C793FF8591FB537FD11CFD9FF00FF000F26AFFF00CCC51FF0B23F6A6FFA
          239FB3FF00FE1E4D5FFF00998A00DEF883FB097C33F893E22D635ABCD2FC41A5
          F8835ED55B59BDD67C3FE2AD5BC3FAACB3B58D8D84882EEC6E619D2DE4B7D334
          E125B2388247B282578DA58D5C75DA1FC03F06F863C55E14D634BF0F69FA4DE7
          81740BAF0AF87E3B0536B6BA4E9772F62F2DA456F1958563CE9B64146CCC6200
          A8555983799FFC2C8FDA9BFE88E7ECFF00FF00879357FF00E6628FF8591FB537
          FD11CFD9FF00FF000F26AFFF00CCC5006E6B7E3EF02FEC05F0B3C0FE166D17C4
          1A07C33F0F697168567ABDB59DC6A7A57856D6CE1862B74D4675324F6D6E2DD6
          476BEB91F65892D25373730B3C425F64AF9FFF00E1647ED4DFF4473F67FF00FC
          3C9ABFFF003315F377EC89E24F8E9E15FDADE1F067C27F857F047C23F02B45BB
          9A2F1CE9DA4789F58BAF0EE89751C82DE44F0ECCDA1D95AADE194DC35DDA5AFD
          A6D45C69D324C74CBC9E69AEC03F4468A28A0028A2BCF7E39F887E29F87FFB2F
          FE159F837C01E2DF3BCDFED2FF00849FC6577E1DFB2636795E4FD9F4BBFF003B
          7664DDBBCAD9B131BF71D801E85457CFFF00F0B23F6A6FFA239FB3FF00FE1E4D
          5FFF00998A3FE1647ED4DFF4473F67FF00FC3C9ABFFF00331401F40515F3FF00
          FC2C8FDA9BFE88E7ECFF00FF00879357FF00E6628FF8591FB537FD11CFD9FF00
          FF000F26AFFF00CCC50077DFB587C0C3FB4FFECB3F12FE19FF006A7F61FF00C2
          C4F0AEA9E18FED1FB37DABFB3FEDB692DB79FE56F4F33679BBB66F5DDB71B973
          91E5DFB52FFC13B74BFDA56E3C790B6ADA7D9E87F112D345B9D6B41D47454D4F
          49D4359D175182F74EBFB8B6F32349E395204B3BF89F325E5A5AD8C293DA0B50
          D269FF00C2C8FDA9BFE88E7ECFFF00F879357FFE6628FF008591FB537FD11CFD
          9FFF00F0F26AFF00FCCC50079EFC2FFF0082676BDFB3E7F60F88BE1AF893E107
          81FC7BA5FF006CDB4F1693F0A63D3FC1A6CF53FEC9FB4241A459DFDBDCADC6ED
          0F4F617171A85C365EED48F2DEDA3B4EC26FD806E2EBC2BE34B0BCF1F6A1ABDE
          78C7E257843E22CFA9DFE9507DA99F414F0D2B432AC06185A4BA3E1E2CD2C51C
          31C66F4ED84AC415F4BFE1647ED4DFF4473F67FF00FC3C9ABFFF0033147FC2C8
          FDA9BFE88E7ECFFF00F879357FFE662803E7EF097FC10B6CFC29F18745F1847E
          3AD023D4345FECFB69AEACFC096B69AAF8A22B1F13F87B5F8EFB5AD4166373A9
          6B13B6872C5737B2B08A47BD13456B6ECB3ADD68FED11FB31FC56F1EFED6DAB6
          87E0FD17C61A5FC3BF157C4AF087C49D7F59BCB6D08E937F7BA3C9A134D18BAF
          ED27D452CCD968B14696C9A52CCDA8A23B5EAD93C895EE1FF0B23F6A6FFA239F
          B3FF00FE1E4D5FFF00998A3FE1647ED4DFF4473F67FF00FC3C9ABFFF00331401
          C6FF00C13FBFE0965E1FFD82BC52B75A2DBFC2F8ECF45D00785B48B9F0F7C3AB
          2D0B5FD4EC83C044DAE6A8249A6D46F316B0969201670C9249712496EECD00B6
          FACABE7FFF008591FB537FD11CFD9FFF00F0F26AFF00FCCC577DFB27FC733FB4
          FF00ECB3F0D3E267F65FF618F889E15D2FC4FF00D9DF69FB57F67FDB6D22B9F2
          3CDD89E66CF376EFD8BBB6E76AE70003D0A8A28A0028A28A0028A28A0028A28A
          0031451450014514500145145001451450014514500145145001451450014514
          50014514500145145001451450014514500145145001457C9BFF000556FF0082
          8E6A9FF04FCF05F82A7F0BF82B50F889E22F10F8834F3A868BA742F71A845E1F
          1AAE9D61A85D59C00A0BBBC33EA9A75A416C254769B528A5C3C504CB5F4F784B
          C57A5F8F7C2DA66BBA16A7A7EB5A1EB56915FE9FA8585C25C5ADFDBCA81E29A2
          95094923746565752430208241A00D4AF9B7F69CFF008272697FB437C6FF0005
          F8D34BF1B78C3E1DC9A2F880EB9E24B4F0DCC96CBE2E3FD8D7DA42B34B8F36CE
          F05A5EB5B9BEB568EE0DB858F7892DEC27B2EFBE01FC6CD5BE297C54F8DDA16A
          16FA7C36BF0D7C696DE1BD31EDA375927B793C39A26A8CF316660D279FA94EA0
          A851E5A4636960CCDEA940197E12F0A697E03F0B699A1685A5E9FA2E87A2DA45
          61A7E9F616E96D6B616F12048A18A2401238D1155551400A0000002B528A2803
          E7FF00F824EFFCA2CBF669FF00B255E17FFD345AD7D015F3FF00FC1277FE5165
          FB34FF00D92AF0BFFE9A2D6BE80A00F9FF00FE093BFF0028B2FD9A7FEC95785F
          FF004D16B5F4057CFF00FF00049DFF0094597ECD3FF64ABC2FFF00A68B5AEFBF
          6B0F8E67F660FD967E25FC4CFECBFEDC1F0EFC2BAA789FFB3BED3F65FED0FB15
          A4B73E479BB1FCBDFE56DDFB1B6EECED6C60807A1515E7BFB27FC733FB4FFECB
          3F0D3E267F65FF00618F889E15D2FC4FFD9DF69FB57F67FDB6D22B9F23CDD89E
          66CF376EFD8BBB6E76AE703D0A800A28A2803CF7E39FC13BCF8EA34BD2AE7C59
          E20D03C1F1F9B2EB165E1EBEBAD1F55D6251B3ECC8353B59A3B9B5B78DBCC924
          4B7292CCEB02999605B8B7BAEBBC25E14D2FC07E16D3342D0B4BD3F45D0F45B4
          8AC34FD3EC2DD2DAD6C2DE2409143144802471A22AAAA2801400000056A51400
          514514005145140051451400514514005145140051451400514565F8B2EB54B3
          F0BEA5368567A7EA5AE45692BE9F697F78F656B75701098A396748A6786367DA
          1A458A42A09211C8DA40352BC33FE099771A5DE7FC137BF67D9B43B3D434DD16
          4F86BE1C7D3ED2FEF12F6EAD6DCE976C628E59D228526915368691628C310484
          40768EFF00E0AFC6BD2FE38F856E2FAC6DF50D2752D2AEDB4CD7344D4E348B53
          F0EDFA223C967751A33A2C81248E4578DDE19A19A19E19268268A57F9C7F62FF
          008E9FF0A23FE08F5FB2FDDD9E97FF00091789BC45E00F06787BC37A22DCFD9D
          B56D46EB4CB44456609248B6F0C625BBB99638A6782CED2EE71148212A403EC2
          A2B2FC276BAA59F85F4D8B5DBCD3F52D6E1B589350BBB0B27B2B5BAB80804B24
          503CB33C31B3EE2B1B4B2150402EE46E3A940051451400514514005145140051
          4514005145140051451400514514005145140051451400514514005145140051
          45140051451400514514005145140051451401F077C71F0A6ADE2AF83FAC7C60
          F13699A8691ADFC48F8C1F0CEC348D3EFEDDED6EB49F0C69BE3AD2934A865898
          23AC970F717DA9B24F0C77501D64DA4C09B34C7BFF00ECE9E13D53F67BF8C9E2
          AF8690E99A82FC3592D60F10F80A68ADDDB4FF000FDB90B6F7DE1F4650E218ED
          A758AEADD659101875536B6B0ADBE96C128FFC14AFFE4DDBC3BFF6557E1C7FEA
          6FA157D01401F3F7EC6FFF002715FB587FD955B1FF00D423C295F40D7CFDFB1B
          FF00C9C57ED61FF6556C7FF508F0A57D0340051451401F3FFF00C1277FE5165F
          B34FFD92AF0BFF00E9A2D6BE80AF9FFF00E093BFF28B2FD9A7FEC95785FF00F4
          D16B5F4050079EFEC9FF00030FECC1FB2CFC34F867FDA9FDB9FF000AEFC2BA5F
          863FB47ECDF65FED0FB15A456DE7F95BDFCBDFE56ED9BDB6EEC6E6C64F03FF00
          0562FF0094597ED2DFF64ABC51FF00A68BAAFA02BE7FFF0082B17FCA2CBF696F
          FB255E28FF00D345D5001FF049DFF94597ECD3FF0064ABC2FF00FA68B5ABDE2B
          FDB06E7C61E29D4BC2FF0005BC37A7FC5AF11687752E9DAE6A0BE20834EF0BF8
          52F627224B1D4B5045B8992F311CA0DB5A5A5DCD0B983ED296B15C453351FF00
          824EFF00CA2CBF669FFB255E17FF00D345AD786F8B3FE089DF063E05F8AB52F1
          5FC37FD9FF00E0878BB44D4AEA5D5BC41E05F10F836C751BAD4657725CE89A85
          DB84D36428E76D94C1AC1CDB5BC51FF66092E6ED803EDEF09DAEA967E17D362D
          76F34FD4B5B86D624D42EEC2C9ECAD6EAE02012C9140F2CCF0C6CFB8AC6D2C85
          4100BB91B8EA57CB9F0BBFE09BBFB2DFC4EF0358EB4DFB287C20F0DCD75E6457
          3A56B7F0C348B5BFD3E78A468A5864510B46FB644702585E482650B2C32CB0BC
          723F47FF000E9EFD967FE8DA7F67FF00FC37BA47FF0023D007D01457CFFF00F0
          E9EFD967FE8DA7F67FFF00C37BA47FF23D1FF0E9EFD967FE8DA7F67FFF00C37B
          A47FF23D007D01457CFF00FF000E9EFD967FE8DA7F67FF00FC37BA47FF0023D7
          8F7EDAFF00F04F6F807F043E187837C51E0AF81FF07FC1FE26D2FE2A7C3DFB1E
          AFA278374ED3EFED3CCF19E8B149E5CF0C2B226E8DDD0ED232AEC0F048A00FB8
          68A28A0028A28A0028A28A0028A28A0028A2BC2FF6AEF166ABE1DF8EFF00B32D
          9E9FA96A16167AF7C4ABCB0D4E0B7B878A3D46DD7C1FE25B85866552049189E0
          82508D90248636C6E452003DD28A3345007967C6AF82BAA5FF008A6DFE207802
          E2C349F891A4DAAD9B2DE3BC5A678B6C11DE41A5EA46357758C3C92BDBDD223C
          D6534D23A24D0CD796779E41FF0004A2FD91BC65FB3F7ECD3E00BCF8B9069EBF
          12343F0568DE11B1D3E0BA17B1F82B4BB4D36C2DE5D3A1994089E4B9BBB47BCB
          99624CBC92416E65BA874FB49ABEB2A2800A28A33400515E17FB5778B355F0EF
          C77FD996CF4FD4B50B0B3D7BE255E586A705BDC3C51EA36EBE0FF12DC2C332A9
          0248C4F0412846C812431B6372291EE940051451400514514005145140051451
          4005145140051451400514514005145140051451400514514005145140051451
          400515E7BFB587C733FB307ECB3F12FE267F65FF006E0F877E15D53C4FFD9DF6
          9FB2FF00687D8AD25B9F23CDD8FE5EFF002B6EFD8DB77676B6307C3F5BFF0082
          BA780B4DF1AFC0DD2D74ED42CECFE2E5AEA5A96BF7BABDD5B5847F0BADEC74AD
          46F668F5CF9DC5A5E09F4BBFB53048CA164D3354CC81AC648D803EB2A2BC77C1
          5FB767C34F1C792A9AA788343B99B55B2D18D9F897C2BAB7876F2DA7BDF356C5
          E6B7BFB682582DEEA6825B6B7B995560B8BA4FB34523DC1111E3F59FF82A6FC1
          FF000CF8AA18752F16E9F0E89AD5A698FE1DBB82CB53B9BAF11DC5F3EBA2DE3B
          5816CF65C47749A05D1B192DE598DF928214226B36BC00FA4A8AF0BF825FF051
          AF83FF00B42C1E156F0BF89B50964F1C5D416BA0DBEA5E1DD4F49BAD504FA75E
          EA56D731C1796F14A6CE7B4D3AFDE1BB2A2DE63673471CAF22320C1F1E7FC15A
          7E01FC38D7EE347D43C69A85C6B569762CDF4AD2FC2FABEABA8339D6AF741CA5
          B5ADAC92BC7FDAD613D9798AA63F3A4B54DD9BBB5F38034BFE0A57FF0026EDE1
          DFFB2ABF0E3FF537D0ABE80AF977F6D8F8A5A17C67FD8F3C1BE24F0DDF7F6869
          3A87C54F878A8ED0C96F3412C5E3BD1629ADE786555960B88664922960951258
          658A48E44474651F515007CBBF02B4EF156ADF13FF006BEB7F04EB1A0787FC4D
          27C55D37EC77FADE8D36B1616F8F067848C9E65AC3756B249BA30EA36CE9B599
          58EE0A51BA2FF8571FB537FD163FD9FF00FF000CDEAFFF00CD3D27EC6FFF0027
          15FB587FD955B1FF00D423C295F40D007CFF00FF000AE3F6A6FF00A2C7FB3FFF
          00E19BD5FF00F9A7A3FE15C7ED4DFF00458FF67FFF00C337ABFF00F34F5F4051
          401F26FECF7FB27FED21FB367C04F03FC39D0FE357C11BBD13C03E1FB0F0DE9F
          3DF7C1FD524BA9ADECEDA3B789E564F12A234852352C5514124E140E0765FF00
          0AE3F6A6FF00A2C7FB3FFF00E19BD5FF00F9A7AFA028A00F9FFF00E15C7ED4DF
          F458FF0067FF00FC337ABFFF0034F59BF11BF660F8D1FB40FC02F8A3F0E7E237
          C52F85F7DA27C45F05EADE16827F0E7C38BED26EB4BB8BDB76B75BB669F5BBB4
          9A38D24909802465C95FDEA0521BE92A2803E7FF00F824EFFCA2CBF669FF00B2
          55E17FFD345AD7AEF8C7E29685E01F12784F49D5EFBEC7A878E3559344D122F2
          6493EDB78963777ED1655484C5AD8DD49B9CAAFEEB6E7732AB7917FC1277FE51
          65FB34FF00D92AF0BFFE9A2D6BE3FF00DBBBE059FF00828B7ED75F087C58BAA7
          F61DAF84BE2AEABE02F85DACFD9BED3FD8BAC699E1BF11DEDFEBDE46F88CDE5F
          8874AD3EDFEC774AD1B7FC22FE623B5BEA322B007EA0515E77FB2F7C72FF0086
          8EF813A1F8B26D2CE81ABDC7DA34FD7346FB4FDABFB0758B3B896CF52D3FCF08
          8B71F66BEB7B9B7F3E35F2E5F27CC8C947563E894005145140057CFF00FF0005
          2BFF009376F0EFFD955F871FFA9BE855F4057CFF00FF00052BFF009376F0EFFD
          955F871FFA9BE85401F405145140051451400514514005145140057CFDFB647F
          C9C57EC9FF00F6556FBFF508F15D7D035F3F7ED91FF2715FB27FFD955BEFFD42
          3C57401EFF008C1E940E95E09E2CFF008281784FE1F7ED55E26F869E23B3D7B4
          5B5F0BF85A1F14DE7896E346D4068D6F0B7DA9E5135E7D9BEC90C71C56DBBCD7
          B80AEECD101E646CB4BA5FFC14B3E0EDF781F5DF105D78835CD06C7C34FA70D4
          60D7FC27AC68BA8409A85C2DAD94C2CAF2D62B978269DBCB59D23688B2B8DFF2
          3ED51D76FEBA0DA69F2FA7E36B7E6BEF3DEFBD27DEAE0BE067ED25E11FDA2B44
          D52FBC2F75AB1FEC3BCFB06A365ABE877DA1EA5A6CFE524C127B2BE861B988B4
          52C722978C074915972A41AE1FE14FFC147BE127C7087CEF0BEB5E24D5239342
          97C4B627FE10ED6611AE5844B1B4D269DE65A2FF00683C7E6C4AF15A79B223C8
          A8C81C85A7D6DFD7F5A096AAFF002F9F63DD41E828E82BC3ED7FE0A27F099FE1
          BF8ABC557BADEBFE1FD2FC12F68BAE43E21F09EB1A26A5A7ADDC822B695AC6F2
          D62BA686590954956231B149006FDDBEDCFF00871FF0504F0DFC4FFDAA47C30B
          1F0DFC41B59AE3C3969E20B6D4B52F066B9A6C7FBF7B9CC33FDA6C634B5DAB6E
          0869E44DEEE620BBD0AD1D797AFF00C0BFE41D1CBA2FF34BF362FED9073FB457
          EC9FFF006556FBFF00508F15D7D035E19FB677C26F1F78F359F83FE24F873A7F
          83F59D6FE18F8D65F11CFA6F88F5CB9D16D6FEDE5D0758D29916E60B3BC75915
          F538E400C24308D86E5241AA5FF0B23F6A6FFA239FB3FF00FE1E4D5FFF00998A
          00FA028AF9FF00FE1647ED4DFF004473F67FFF00C3C9ABFF00F33147FC2C8FDA
          9BFE88E7ECFF00FF00879357FF00E662803E80A2BE7FFF008591FB537FD11CFD
          9FFF00F0F26AFF00FCCC51FF000B23F6A6FF00A239FB3FFF00E1E4D5FF00F998
          A00FA028AF9FFF00E163FED4E7FE68DFECFF00FF00879357FF00E662BD7BE165
          FF008AB56F0258DC78DB46D03C3FE2693CCFB658689ACCDAC5841891847E5DD4
          D6B6B249BA308C77409B599946E0A1D803A2A28A0F3400514514005145140051
          4514005145140051451400514514005145140051451401E7BFB587C0C3FB4FFE
          CB3F12FE19FF006A7F61FF00C2C4F0AEA9E18FED1FB37DABFB3FEDB692DB79FE
          56F4F33679BBB66F5DDB71B97391E01E2CFF008244E85E22F88BAD78834BF1A7
          883C2336B1E2BD435D86EF42F32DB55D1ECEF743F10DA496D6974D3388EE1357
          F156B9ABC776636647BC5B709E4C10797F60D7CFBF14FF00E0A0BA3FC3BFDA3A
          FF00E17E9FE03F881E32F1369BA547AADC45A28D2FCE292B2C7018ECEE6F60BE
          9ADDE796DE03A8436EFA7412CEC2E2EE016D78D6C01E41F07BFE08D767F0E3FE
          16659C9AFF0080347F0CFC6BD2B48D03C6FE1CF027C39B5F0969573A6597F6B8
          9ED2C921B8924B7FB6C7A8C11CF3CEF7372A91DD882680CD6874FEFF004FFF00
          827C6BD7DFB57F82FE2BF893E257FC245ABF83FF00B32270DE1D8ED66D5E2D3E
          CFC63650BCEF14C225B8921F1546D2BC50C7134BA7C8D1C30A5CAC56DC7FC0CF
          F82B847E21FD923E1F78F3C69F0F3C609AA5D7C35D2BE247C4397458F4F1A7F8
          1F49BB8EE197569525BF334D6730B1D4278A0B3FB65E2C36DB6682399E389FB0
          F157FC1557C15E11F847E36F1C5CF847C7F0F86FC0FE2BBBF064F7F7F05868F6
          17FA9DA6A5796172B15EDFDDDBD9C76F1B5987177733C36D235D5BDAC72C97C5
          ECE300E3FC0DFF00049ED57E1541F0CF54F0DFC48B08BC65F08FC15E0FF0B787
          EF752F0C3DDE992DC685A7788B4C96EEEAD23BD8A5963B9B4F125D6D823B888C
          13410B99674DD132FC32FF008246DC7C3DB1F104779F14B50F125E6BDE20F0E6
          BB3EA17FA0C115D4EFA4FC40D63C64C65103C70992E0EAC6D59A28A28D0C2665
          8B6B8B78EFEADFF05A8F85917C0BBEF88DA0E83F103C71E16F0FF856E3C5BE26
          B8F0C58DA6A7FF0008BDAC771A8D9A2CC52E76DD79B7DA4EA56CB3D835D5AA7D
          91EE259E1B364BB7E83E1AFF00C15C3E107C57FDB22E7E09E97A917F132EABA9
          681693FF006AE952FDBB53D39676BDB4FB04578FAADBF942D2F3F7F776505B3F
          D9B31CCE27B5338060FED2BF033FE19E3F62FD37C3E754FED8FED0F8FF00E1CF
          1379FF0066FB3F97FDAFF14AC756F236EF6CF93F6DF2B7E46FF2B7ED4DDB17EC
          0AF9FF00FE0A57FF0026EDE1DFFB2ABF0E3FF537D0ABE80A00F9FBF637FF0093
          8AFDAC3FECAAD8FF00EA11E14AFA06BE7EFD8DFF00E4E2BF6B0FFB2AB63FFA84
          7852BE81A0028A28A0028A28A0028A28A00F9FFF00E093BFF28B2FD9A7FEC957
          85FF00F4D16B5CEFC70F85DA0FC0EF1C7EC57E09F0B58FF65F867C1FE3F9344D
          22CFCE927FB259DB780FC510C1179923348FB63455DCECCC719249C9AE8BFE09
          3BFF0028B2FD9A7FEC95785FFF004D16B49FB647FC9C57EC9FFF006556FBFF00
          508F15D007AF783BE16E85E01F1278B356D22C7EC7A878E3558F5BD6E5F3A493
          EDB789636960B2E19884C5AD8DAC7B502AFEEB76373333747451400514514019
          7E2DF15E97E02F0B6A7AEEBBA9E9FA2E87A2DA4B7FA86A17F7096F6B616F1217
          966965721238D115999D880A0124802BE71F89FF00B53FC16FDA5FC2763E1BF1
          16AFF103C1FF0065F15785757B2B7D77C13AD7862FF52BCB7F12E946C05BC5A9
          58C6F736E7536D36DEE1E0465816F62F32483CD8E4AF7FF8AFE1CFF84C7E16F8
          9B48FEC0F0FF008AFF00B534ABAB3FEC4D764F2F4AD67CC85D3ECB76DE4CFB6D
          E5CEC90F932E1198F9727DD3F9E5F1F3F656F891F1F7E15C9E1D9BE097C4FF00
          15FC34F0DF883C35E23B7F03FC5AD73C33E26D64DC5A788B4B9EE5346BE7D4AE
          9E58E6D2FF00B792EC6B37E49173696F6AC96ED3C4003F4C28AFCBFF00DA9BFE
          09F5F133E25F83FE2B691E1DF857B7E266B5FF000B12E353F891F6ED261FF858
          9A2EAFA5F8820D13C37F6BFB4FF68CBF667D4B414F22FE186CA0FEC4CC7295B6
          B432E87FC151BFE099FE38F1B69FF63F831E0BD42EAF3C39E0BB84F006A363AA
          68C6E344F11F9F7D79777D7B7BAE4575776B7973249692C37FA47957D777A266
          D42F6158ED2EEDC03F4C28AFCBFF008FFF00F04EFF008C9F10BE22C9FF00087F
          833FE11BF886BE2BF1F6A577F17FFE12E5D3FF00B420D5F43F14DBF869B65BBB
          5E5CFF00652EA5A75979D73124FA7797E5D824F6B2CF2A7BF7FC129FF645BAFD
          974F8F2683C2BF103C09E1FF00107F67A5AE87E261E10D3F17507DA8CF770E9B
          E15B68F4E87CD49ADA36BA92692EAE3ECC91C91C515A5BB4C01F61514519A002
          8A28A002BE7DFDB27FE4E27F64FF00FB2AB7DFFA8478AEBE82AF9FBF6C8FF938
          AFD93FFECAADF7FEA11E2BA0087F68FF00D88AFBE3FF00C43F135F2F8C2DF44F
          0EF8EBC16DE0DD7EC868C6E350D88D7525B5CD9DD19D638248E4BA72EB2DBDC2
          C81140F2F927CBBE3BFEC25F16FC7BE14D5BC43ACF8EB41F197C4DBFBFF0869D
          A75DE83E164D02C746D3B4EF11DA6A3737260BABEBA334F85965706754758234
          8E20D92FF6B1E3B526370A51D1A92E8EEBD6FF0086FEA1D6EFCBF0B5BF247927
          ECDFF003C45F09EEFC69AF78CBC59A778C7C67E3BBF86F750BAD33456D174CB7
          482DA3B6820B6B57B8B99114471EE6692E25667773955DA8BF36FECF1FF04D4F
          897E20FD957C13E19F899F121F45BAF0E7C2F97C19A3E9FA1E8B1D9EA1E1AB8B
          EB2B782EA4B9BE8EEA54BC920F244711B74B650858B195CACABF767F0D29FBB4
          B96F75FCC927F2BAFD4A8CDC55977BFCCF8ABE077FC122A3F845A178EADD759F
          867A0C9E39BBF0CDC3D9F80FE1BC7E15D1ECBFB1B5037808B55BC9DA4967CEC7
          96498B02011950B18FA0AF3E046B907ED6F6FF001234BF116936DA55EE831683
          ADE8D77A3C9717176904B7335BC96D74B731ADB9125CBF981E09C3AAA85F2CE5
          8FAA1E9428C35536DB4FB7F95BF233E54A3CBDFF00E1CCDD67C59A5F86F50D26
          CF50D4B4FB1BBD7AEDAC74C82E2E1229351B85825B868615620C9208209E528B
          92238646C6D462352BE5DFF828CFC27F0BFC71F89DFB2EF85FC6DE19F0FF008C
          3C33AA7C55BAFB6691ADE9F0EA16177E5F833C532C7E64132B46FB644471B81C
          32291C806BA2FF00874F7ECB3FF46D3FB3FF00FE1BDD23FF0091E828FA028AF9
          FF00FE1D3DFB2CFF00D1B4FECFFF00F86F748FFE47A3FE1D3DFB2CFF00D1B4FE
          CFFF00F86F748FFE47A00FA028AF9FFF00E1D3DFB2CFFD1B4FECFF00FF0086F7
          48FF00E47A3FE1D3DFB2CFFD1B4FECFF00FF0086F748FF00E47A00F7E43C9FAD
          3ABE7FFF00874F7ECB3FF46D3FB3FF00FE1BDD23FF0091EBD33E0A7ECFBE01FD
          9AFC2971A17C39F03F843C03A2DD5DB5FCFA7F87346B6D2AD66B86444699A281
          111A4291C6A5C8C911A8CE146003B4A2981B6B74A50E49FBB400EA28A2800A28
          A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800AF1DF1F7EC7
          F67F117E3B68BE34BDF1C7C408F4FD1355835F8BC2F1DE5AB69435386DDAD92E
          A29A4B76D42CF30911C90595DDBDB4E86749A1956F2F56E7D8A8A00F93742FF8
          248F84F40F837A1F80E1F889F1424F0EDAF82ED3E1B788E279749F33C71E18B4
          374B67A4DFB8B00618E182FAF6059F4FFB1DD34772CD24F24A914A9DFEA7FB08
          F87DFE1A69FA0E8FE26F18786F54D07C6BAD78FB43F11D83D94BA9E87AA6AD77
          A9CF78D125C5B4B6924663D6350B654B8B7942C33023F7C893AFB9D1401F9DFF
          00B437FC11E3C437DE0BD73E1AFC2DD4350D2FC09F11340D5342F17788758F89
          37BFDB37A97FAAEB1A8C62E2DCE973DC5FC7A7DC6B5793C6ABAAD9497E267B6B
          F96E22CBB7D5DF0D7F63FB3F851F152E75CD2BC6FF001017C32DAAEA5AFDA782
          BED96B168363A9EA334F3DEDDEE8ADD2FAE3CD9EEEF26F22EEEA7B6492E77470
          A182D7C8F62A2803E7FF00F8295FFC9BB7877FECAAFC38FF00D4DF42AFA02BE7
          FF00F8295FFC9BB7877FECAAFC38FF00D4DF42AFA02803E7EFD8DFFE4E2BF6B0
          FF00B2AB63FF00A847852BE81AF9FBF637FF00938AFDAC3FECAAD8FF00EA11E1
          4AFA06800A28A2800A28A2800A28A2803E7FFF00824EFF00CA2CBF669FFB255E
          17FF00D345AD27ED91FF002715FB27FF00D955BEFF00D423C574BFF049DFF945
          97ECD3FF0064ABC2FF00FA68B5A4FDB23FE4E2BF64FF00FB2AB7DFFA8478AE80
          3E81A2BE0FFF00828AFED81E2EF067ED29A269FF000FCFC50D4ACFE155ADB6B5
          E21D3FC1FE0DD5BC451EBD7F36A5A64ADA397D3ED6E204BCFF00847E3D657ECB
          A9496D0AC9AF68F7208658EEECFBE5FDAC7C7DF1B7C69E3AD57E1B78DBE08E8F
          F0F7C1FE20D23C216575E21B3B9D423F125C6ABA56917D69A9DB6A36F7D143E5
          93AEDAA4362B0486F64B611ADE5BFDB525B500FACA8AFCCFFD9F7FE0A47E3EF8
          13FF0004BCD67C4DE36F1178435AD6BE1BFECC5E10F895A6EB9ADA5CC0DAD6B3
          AAC3AEA5ADB5F4935E3B5C4923E9BA6C25964492E6E279D97619E38A2E7FF6FE
          FF0082AAFC50F08F87BE2BF87ED6D74FD2FC29E30D03E24787BC15AE68F245A7
          EA1617FE1DD175896E2FEDEF0EA9FDA17124175A5B43228D1AD21B79AE53CBBE
          B848ADE6BF00FD50A28A2803C9FF00692F8F5AFF00C29D53C21E1FF07F8574FF
          001778BBC6F7F35AD8DA6A3AC9D1EC60860B792E279E6B9582E1D76A20544485
          CBC92A03B137C89F25FC10FF0082B6F8DADFC27F0A7C3FAA7C37F16FC42F146A
          5A0E97AA78CF51D3B47D527974FF00B75DCF6E9E4AE97A5DCD8B4918B799E417
          3736518540637972DB3ECFF8EDFB3B784FF68EF0FE9FA7F8AACF5475D26F06A3
          A7DE695AD5EE8BA8E9D7023788C96F79652C3730B3472CB1B79722EF491D1B2A
          C41F3EB3FF0082667C13B08FC231DAF83EE2CADFC116769A769D6B6DAF6A505A
          DC5ADA4FF69B582F614B811EA1141313244978B32C6CEE542966CCC7E2F9EBE9
          6FF3096A9DBB7E37DFEEFF0086EA7CF9E26FDBBBE23FC0FF00DA33E29F88BE20
          4D792FC3BF0BF8BEEF42D1B42F0FEAB633ABDAD97856E359779639B4A8AE3CE9
          B109C0BFD82590202B1C0CD75A7FB707EDC1F1E7E05FECED75A9DDFC3FD0FC0B
          E3499F505D1E5D33C670EB1A2DE22683A85F7992C93E942E3CD81ED49300B789
          1A41062E258DA541F4FF0089FF00640F86FE36D4F50B9D63C2B67AA36AFAADC6
          B57D0DDCD34D6F79753E9674999A4859CC6C8F624C2632A632096DBBFE6AE320
          FF008263FC17FF00845AF349BDF0DEB5AE47A80956E2EF5AF16EB1AAEA4F1C96
          37161E4FDB6E6EA4B910A5B5DDD2C71090470B4F23C6A92317AA8D9412EA9257
          EED5AEFE7FD22AEB9B9BD6EBF23DB3C1F79A96A3E15D366D62D6CECB569ADA36
          BDB7B3BA6BAB78262A0BA472B47134881B20398D0B000955CE06A6DCD66F85FC
          3907847C35A7E9366D7B25AE9B6D1DAC2D797935E5C3222855324F333CB2BE00
          CBC8CCEC72589249AD2CED344A57775B19C13E55CDB8EA28A28282BE5DFF0082
          8B78BF52F87DF13FF65DD5F49F09F883C71A859FC55BAF2B44D126B186FEF777
          833C5287CB6BDB8B6B61B158B9F3264F95182EE6DAADF5157CFDFB647FC9C57E
          C9FF00F6556FBFF508F15D002FFC364FC45FFA34EF8FFF00F837F047FF003434
          7FC364FC45FF00A34EF8FF00FF00837F047FF3435F405717F1F3E34E97FB3A7C
          1CF1078D3588350BEB3D06D0CD1E9FA74692EA1AC5C31096F6167133209AF2E6
          768ADE0843032CD3451AFCCE2803CCFF00E1B23E22FF00D1A77C7FFF00C1BF82
          3FF9A1A3FE1B23E229FF009B4EF8FF00FF00837F047FF343577FE09A5F1FAE3F
          6A5FF827BFC14F883A878834FF00156B9E2AF0569579ADEA766D018EE354FB2C
          6B7E0AC00451C8976B3A3C6A1447223A6D52A547B9D007CFFF00F0D93F117FE8
          D3BE3FFF00E0DFC11FFCD0D1FF000D93F117FE8D3BE3FF00FE0DFC11FF00CD0D
          7D0145007C5BF177E3EF8AFE29FED65FB2C69FAEFC11F8A1F0D6D61F895A85C2
          6A7E23BFF0ECF6B3B8F05F8A1440ABA76AB773798433302D1AC788DB2E18AAB7
          DA55F3F7ED91FF002715FB27FF00D955BEFF00D423C575F40D00145145001451
          45001451450015F9BDF1F7F6A2F8DDA7FED73F16B4BF0D6B9F17ADECB47F881A
          4F827C16F6F65E0E5F87363A8DDF87347BEB6B6D7E7BA8FF00B6E3B79AFEF1D6
          592D983C8B776F6F68E6EE48623FA435E79AFF00ECB9E05F14693E3AB1BED0FC
          C87E246AB06B9AF32DEDC4734DA8DBDAD95ADB5E412AC824B4B8823D3AC5A296
          D9A278A5B68E642B30F32803C0BE3F7FC1567FE1467ECB327C4CFF00840FFB53
          CBF15F8FBC33FD9BFDB7E467FE117B4F14DCF9FE6FD9DBFE3EBFE11ADBB367EE
          7EDB9DD2F93892F6ADFF000501F1F7843E26C1F0AF5BF863E1087E33EB577A62
          687A7D8F8DEE2E7C2F716F7D69AF5DC725CEA8FA5C775048B17867560D1A69F3
          0DE6C80722695ADBB0F89DFF0004BAF817F187C47AA6A9E24F02FF0069DD6ADF
          DABB91B59D423B6B0FED5B1BBB1D57EC7024EB1597DBA1BEB96BAFB32C5F699D
          92E25F32E228A54EBFE2CFEC6FF0F3E35F8AB52D7B5ED1F50FF848B53B4D3ACC
          EB3A66B77FA4EA566960FA835A9B5BAB49A29AD2451AAEA31B496EF1C92C37B3
          43233C4C52803C0345FDB7FE2DFC6DFDA53E17E83E10F0A78474ED12F3C3FE3C
          BED7ED6F3C5124325EEBDE1AD4A3D066D3C4DFD993674B3A85D45225C2243732
          C7B2668E016F258DF687C19FDB13E23C9FF04A0F857F16BC450E813FC46F8ADF
          F08CF947735D695A54BE27D62CED2CE5F2A38EDA492DECE3D4E07FB29712B25B
          F90D7B2C85AF9FE80F87FF00B2EF817E17EB1E17D4743D0CD9EA1E0FD2B53D1B
          4DBA6BDB89E6106A5756B79A83CEF248C6E6E2E6EACADE796E67324F24A24769
          0B4B297CEF107EC89E0DD47F662D0FE11E9D06A1E1DF0A784ED348B7F0E3585D
          192EB407D225B79F4B9E27B8128964B59ED2D655170B3472184099254674600F
          02FDA0BF6CDF889F0F2E3FE115F08E9BA86B1A5F80FE257807E1B789FC737F7F
          603569EF751D43C3D35DC92E9C2DA3B636771A6EAC90B5CDB32CC97774563B28
          A18FED71A7ECC1FF00051CF197C4A83E03E9F71F0EF509B4BF897E0BF0FEB5FD
          BBADEB820D4F589AFB4E8AEA66B33169B0E9179240AD34D3DBFDAEC6F4C363A8
          4F069AD0C56FF68F5FF107EC07F0F3E2A78AF43F1678FF0041D3FC45E38D3EEF
          48D76EEF2C27BFD33499F5ED39EDE483588B4D17524315E29B58A15B8732DCFD
          9145A3CF2DBEE8D93C1BFF0004E8F83FF0FB51F0ACDA2786750D3ED3C1B6BA65
          A586931F88B53FEC69CE9B0436FA7DCDDE9E6E0DA5F5E5B476D6822BBBB8A5B8
          43656844A1ADA13180788FC49FF8283FC58D7BF647F0CFC56D03E1AFF667867C
          75AAF81F55F085CE89E21B3D4F55D5F4AD57C49A2DBBE9B7F6B7D0DAC363A85D
          D86A0C88229EEADE37171BAF2031C12CF7FE257FC152FC5DF0F60BCF0DFF00C2
          A9D3F53F8A3E1FF105CE87AEE8FA66B5AB6B3A65B8874ED2F51F3ED5F4CD1AEF
          56B98CDBEB7A72B4ADA4C36F0CC668A59E366B2FB6FAFF0087FF00E09CFF0007
          FC35701ADFC33A84D15BDDE9F75A6DBDE788B53BCB5F0E8B1D46D752B5B6D2E0
          9AE1A2D32CD2EEC6C5CDA592C36EE2CADA3789A386345D1F883FB05FC28F8A5E
          23D6356D73C29F6CD43C45AAB6AFABCA9A9DE5BFF6BB3D8D8D84F6972239544F
          A7DC5AE99A7C771A7C81ACEE7EC9134D0C8CA1A803C3FE1A7FC15C6E3E34FC3D
          F1378CFC37F0B7508FC1D6375E13D1F41D4756D7A0B5935AD53C4F65E1CB8D26
          DA5861499EDA389FC408B7B37EF0411C713DBADF3CB2C36D83E39FF82C578BBC
          19E35D53C0B27C0ED43FE16568DAFDFE9171A5C57DAB6B5A7BDBD8697E1FBDB9
          BD49B44D1F51BB11C92788AD16DFCDB28C3C285E76B3B865B23EDDAC7FC13E7C
          25E0BFD967C49F0CFE17E9BE1FF08C3AE7F653452EB30EA5AD5B59CBA6DA69B6
          16770823BFB6BB8EE20B3D2AC9609E0BB865867B686E43999599F8FF00809FF0
          498F03FC39F87BA8DA788AF750BDF156B9E20B8F11DFEBDE0ED5759F075C0B89
          ECAC2CA748AE6DF51935268EEA3D32CAE2EC5D5FDC9BCBD46BA9599FCA58803A
          FF00853FB47EBDE22FDA37C17A4DE59F882D7C3FF19BC0177F1074CD1FC47A6C
          7A6EB7E0596C1B44B7B8D32E238F3BFCDFED78A468E4265B6B8B7BB532CF14D0
          C569F41D7967813F662D27C15F192DBC58ADA7C369E14F0F9F08782343D2F4E4
          D374FF000968D20B27BAB748E362269269EC6D7E621638A1B3B58A186261732D
          D7A9D0014514500145145001451450014514500145145007CFFF00F052BFF937
          6F0EFF00D955F871FF00A9BE855F4057CFFF00F052BFF9376F0EFF00D955F871
          FF00A9BE855F405007CFDFB1BFFC9C57ED61FF006556C7FF00508F0A57D035F3
          F7EC6FFF002715FB587FD955B1FF00D423C295F40D0014514500145145001451
          45007CFF00FF00049DFF0094597ECD3FF64ABC2FFF00A68B5A4FDB23FE4E2BF6
          4FFF00B2AB7DFF00A8478AE97FE093BFF28B2FD9A7FEC95785FF00F4D16B49FB
          647FC9C57EC9FF00F6556FBFF508F15D007B6E8FE13D2FC37A86AD79A7699A7D
          8DDEBD76B7DA9CF6F6E9149A8DC2C115BACD332806490410411076C911C31AE7
          6A281E61F04FE0F7C0FF008AFA47C31F8BDE09F01F802E3ECFE14B25F02F8921
          F0BC16B7DA568735AB1B5B7B3778527B4B7FB3DCB8102F96156675283730AF01
          FDA3BF6269BE2F7FC1406CFC49A97C1BFF0084D349D5BEC9A7DFEB7ABDE68F77
          A2C5A38842DD462E6429AEE9D70C56689F4CB54BBD1AFADE6963B88A37D56FAE
          2D7C07C11FF04E5F881A3FEC73E07F08CFF00FC9F185BFC15D2BC0FE0EB8FB47
          87CFFC296F1BDB36AA350F1479A2F09B5FB65D5DE9B7DF6CD27ED37D27F67EF9
          6249E2863700FD0B4FD893E0C45E17D03415F843F0C1743F0B5A6A561A2E9E3C
          2B622D747B7D491D35186DA2F2B6431DDA48EB3A200260EC1C3026B4BC47FB27
          7C2CF18F893C41AC6AFF000D7C01AB6ADE2CDBFDB77B79E1EB49EE758DB6571A
          7AFDA6468CB4DB6C6EEEAD46F27105CCD17DC9194FC61E3DFF0082706B537ECA
          FE26B197C03A86B5AC78C3E2FF0089BC4DE2EB0B2BAD2F54D6758D065D77C417
          3A4476506B3249A24B1A35FD95DFD8B50536D08B8BFB98E14D4CC72D7C85FB4F
          FC21D6BE06FECADE2AF855F172CFC1FE29F8BDE20F86BAE7877E1868127C44D2
          A1D67C22FF00DBBE29F28E970C02D6F1E3D534CBAD1EC2D6D348D3963BE1A726
          9D756D636CAB1A007EE7515F9FFF00B357EC13E34F87DFF051BD4BE21EBDA7FC
          409B566F15788F57BFF15FDAFC2D6DA0EB3A2DEBDF7F66E99F6886D1BC49A87D
          9A0B9D363FB15FCB15943269DBE295D2CAC629BF402800A28A2800A28A2800A2
          8A2800A28A2800AF9FBF6C8FF938AFD93FFECAADF7FEA11E2BAFA06BE7EFDB23
          FE4E2BF64FFF00B2AB7DFF00A8478AE803E81AF9F7C09FF1973FB47AF8DA4FDE
          7C39F843AADE69FE1003F7136A1E28B76D4F47D6AFE45E646B7B58E49B4FB757
          310795F5395A19A31A75C8FA0AB2FC25E14D2FC07E16D3342D0B4BD3F45D0F45
          B48AC34FD3EC2DD2DAD6C2DE2409143144802471A22AAAA280140000005007C2
          5FF04AFF00F8C3EFD90BF661BA8FF71F0AFE30FC3FF08E9CF6917EEAD3C25E28
          9B4A69DAFDCBFEEE3B7D5E4686DD951E30353FB3158679F57B99A3FD01AF977F
          E09EBF0BB41F8E3FF0462F821E09F14D8FF6A7867C61F05741D1357B3F3A483E
          D76773A15BC33C5E646CB226E8DD977232B0CE410706BE8EF0B68B73E1CF0AE9
          9A7DDEADA86BD75616915BCFA9DFA40975A8BA20569E558238A1124841661147
          1C60B1DA8AB85001A9451450079E7ED09FB31F847F69FD1F41B3F1743E20FF00
          8A5F55FEDBD26EF44F126A5E1FBED3EF3ECB7168658EEB4F9E09D736F7773195
          DFB59656041E31C17FC3B4BE1DFF00D0C9FB407FE1F6F1BFFF002DABACFDA33F
          6BFF0003FECAFA97856CFC61FF0009835DF8DAEE7B0D120D07C1BACF88E4BEB8
          8606B89210BA75ADC1493C88E59423ED2F1C13B28658642BC9FF00C3CB7E1DFF
          00D0B7FB407FE189F1BFFF002A6800FF0087697C3BFF00A193F680FF00C3EDE3
          7FFE5B51FF000ED2F877FF004327ED01FF0087DBC6FF00FCB6A3FE1E5BF0EFFE
          85BFDA03FF000C4F8DFF00F95347FC3CB7E1DFFD0B7FB407FE189F1BFF00F2A6
          800FF87697C3BFFA193F680FFC3EDE37FF00E5B51FF0ED2F877FF4327ED01FF8
          7DBC6FFF00CB6A3FE1E5BF0EFF00E85BFDA03FF0C4F8DFFF0095347FC3CB7E1D
          FF00D0B7FB407FE189F1BFFF002A6800FF0087697C3BFF00A193F680FF00C3ED
          E37FFE5B57B6784FC356FE0BF0B69BA3D949A84D6BA55AC5650C97F7F3DFDD3A
          468114CB713BBCD3484005A495DA473966666249F907C4D17EC8FF00B51FC638
          F50F147ECE1A878ABC63E2ABBB6B39B5BF14FECCFAF992E1F11DBC26E6FEF746
          091C688B1AF993C8B1C71A0CB2A2E47A97FC3A7BF659FF00A369FD9FFF00F0DE
          E91FFC8F401ED9E29D16E7C47E15D4F4FB4D5B50D06EAFED25B78353B0481EEB
          4E7742AB3C4B3C72C2648C90CA258E48C951B91972A7C44F8FFE327ECD07CBF1
          868BFF000BA3C136FC7FC24BE16B35B5F1569B02FF00CB4BFD1F3E55FF00970C
          6F2CB71A5BACF3CD32456DA380335CFF00C51FF8274FEC93F07FC097DE22D5BF
          661F83F79A7E9DE5F9B1689F07EDB5CBF7DF22C63CBB3B2B29AE65C33827CB8D
          B6A8666C2AB30F21FF00874FF83FF692FF009B69F801FB3AF84A4FFAA79E18D7
          FC77738FFB77B9D1F4DDB2C7FF00516FB45BDC7FCB8CCBF2807DBBF0B7E28E85
          F1A3C0B63E24F0DDF7F68693A8798A8ED0496F3412C5234535BCF0CAAB2C1710
          CC92452C12A24B0CB1491C888E8CA3A3AF2BFD91BF632F863FB05FC1B87C03F0
          8FC1FA7F833C270DDCD7ED696D24B7125CDC4A4179A69E6779A69080881E5762
          B1C71A02123455F54A0028A28A0028A28A0028A28A0028A28A0028A28A0028A2
          8A0028A28A0028A28A0028A28A0028A28A00F9FF00FE0A57FF0026EDE1DFFB2A
          BF0E3FF537D0ABE80AF9FF00FE0A57FF0026EDE1DFFB2ABF0E3FF537D0ABE80A
          00F9FBF637FF00938AFDAC3FECAAD8FF00EA11E14AFA06BE7EFD8DFF00E4E2BF
          6B0FFB2AB63FFA847852BE81A0028A28A0028A28A0028A28A00F9FFF00E093BF
          F28B2FD9A7FEC95785FF00F4D16B49FB647FC9C57EC9FF00F6556FBFF508F15D
          2FFC1277FE5165FB34FF00D92AF0BFFE9A2D693F6C8FF938AFD93FFECAADF7FE
          A11E2BA00FA068A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028AF
          2BFDA73F69B4FD9B20F06430F833C61E3ED6BC7DE203E1CD1F47F0DB69C97535
          C2E9D7DA8BBB3DFDDDADBA46B6FA7DC124CB924280A4B71C9FFC364FC45FFA34
          EF8FFF00F837F047FF00343401F4057CFDFB647FC9C57EC9FF00F6556FBFF508
          F15D2FFC364FC45FFA34EF8FFF00F837F047FF003435E5BF177E3EF8AFE29FED
          65FB2C69FAEFC11F8A1F0D6D61F895A85C26A7E23BFF000ECF6B3B8F05F8A144
          0ABA76AB773798433302D1AC788DB2E18AAB007DA545145007CFFF00F049DFF9
          4597ECD3FF0064ABC2FF00FA68B5AFA02BE7FF00F824EFFCA2CBF669FF00B255
          E17FFD345AD7D0140051451401F3F7ED91FF002715FB27FF00D955BEFF00D423
          C575F40D7CBBFF000517F895A77C1FF89FFB2EF88B56B7F105E69FA77C55BAF3
          62D1341BED72FDF7F833C5118F2ECECA19AE65C33827CB8DB6A8666C2AB30E8B
          FE1E5BF0EFFE85BFDA03FF000C4F8DFF00F953401F40515F3FFF00C3CB7E1DFF
          00D0B7FB407FE189F1BFFF002A6BADF82BFB5CF857E3EF8AAE347D0F49F8A163
          796B6AD7AF2788FE1B788FC376AC8AE8842DC6A3636F0BC9991488D5CC840660
          A5518800F53A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2
          800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2803E7FFF
          008295FF00C9BB7877FECAAFC38FFD4DF42AFA02BE1EFDA27E28EBD3FC0E6F86
          7E3CBEFED1F889F0FF00E2A7C35BB9EFD618D175ED0EF3E20D847A3EA6C62558
          85C4D0D94D15CC6B1C016F2D2ECC7025ABDABCBEFF00FB3E7C52D77F688F1E6B
          DE34B3BEFB37C29B6FF895F83D2DE18DE1F1AC4D1DBCB2EBE6675F37ECFE779B
          6B68B1848A58A29AEC49770DE59B5B80607EC6FF00F2715FB587FD955B1FFD42
          3C295F40D7CFDFB1BFFC9C57ED61FF006556C7FF00508F0A57D0340051451400
          5145140051451401F3FF00FC1277FE5165FB34FF00D92AF0BFFE9A2D693F6C8F
          F938AFD93FFECAADF7FEA11E2BA5FF00824EFF00CA2CBF669FFB255E17FF00D3
          45AD7CDFF10BC57A5FEC83FB59FC11F853E26D4F4FF0EF837C1BF12B54F1C783
          B50D46E12D2C6D3C2D3782FC5AF75682590A4491E8F77E743E5428B05969B73A
          12339790D007E88515E1BFB11785754D67C2BAE7C55F15E99A8695E32F8C5769
          AD3E9FA95BBC17DE1CD1913668FA3C91483CDB6920B4226B9B5DEF1C7A95F6AA
          F11D9357B950014514500145145001451450014514500145145007CFDFB647FC
          9C57EC9FFF006556FBFF00508F15D7D035F3F7ED91FF002715FB27FF00D955BE
          FF00D423C575F40D0014514500145145007CFF00FF00049DFF0094597ECD3FF6
          4ABC2FFF00A68B5AFA02BE7FFF00824EFF00CA2CBF669FFB255E17FF00D345AD
          7D01400514514005145140057CFDFB647FC9C57EC9FF00F6556FBFF508F15D7D
          035F3F7ED91FF2715FB27FFD955BEFFD423C57401F40D1451400514514005145
          1400514514005145140051451400514514005145140051451400514514005145
          1400514514005145140051451401F36FFC149FFE09A3E0FF00F829A7C34F0D78
          63C5D7B7FA659E87E20B1D46F0D9131B6BDA5C77704F7DA2DCBC6C937D8EEC5B
          C2CC23950A5C5A595C7CED6C887E92A28A00F937C29E2BF891FB367ED1FF001F
          2687E01FC50F1F68BE3EF1AD9789348D63C39AAF8663B59ADD7C31A169CE8C97
          FABDADC248B71A7DC020C5820290C4371D97FC364FC45FFA34EF8FFF00F837F0
          47FF003435F4051401F3FF00FC364FC45FFA34EF8FFF00F837F047FF0034347F
          C364FC45FF00A34EF8FF00FF00837F047FF3435F4051401F3FFF00C364FC45FF
          00A34EF8FF00FF00837F047FF34347FC364FC45FFA34EF8FFF00F837F047FF00
          3435F4051401F3FF00FC364FC45FFA34EF8FFF00F837F047FF0034347FC364FC
          45FF00A34EF8FF00FF00837F047FF3435F4051401E39FF0004F8F85BAF7C0FFD
          823E07F82BC516274BF13F83FE1FE83A26AF67E7473FD92F2DB4EB78678BCC8D
          9A37DB2232EE466538C82460D71FFF000508FF008277697FB7BEA5F082F2EB56
          D3F41BCF85DE3583C41733CBA2A6A126BFA33C135BEA9E1F76324663B3D46091
          62B853E6472C7185921957007D27450014514500145145001451450014514500
          14514500145145007CFDFB647FC9C57EC9FF00F6556FBFF508F15D7D035F3F7E
          D91FF2715FB27FFD955BEFFD423C575F40D0014514500145145007C9BFB04FC7
          7F0CFECFBFF048BFD98F56F13DD6A11C77DF0D7C2B616367A669577ABEA7AA5C
          1D16093C9B5B1B38A5BAB991628A69992189CA4304D2B011C523AFB07C26FDB2
          3E1E7C6BF15E9BA0E83AC6A1FF000916A769A8DE0D1B52D12FF49D4ECD2C1F4F
          5BA1756B770C535A48A355D3A458EE12392586F619A3578983D7CE3FB3A780FF
          00E13CFF008230FECB4BFF000AF7C41F117FB37C01E13BCFB2F867C4FF00F08D
          F89B4DFF008914717DAB4ABDFB45A79771FBDF2641F6DB4DD697178BE6499FB2
          DC797F8E7F631F8E5F1BBE2669FE2EBFF07EA10F8EAE3E1AFC41F03F84BE2178
          8E4F0F59F8C3C0F717D69A49D1AEF58B9D21C451C8976BE208E097468E630DAD
          EC1E622CB35DB5007E98515F9BFA6FFC139A5F8AFF00B40782EEEC7E01FF00C2
          9DF8150F8AF4CBBD63E1DB5C68FA642D2DB787FC636F7DA9CF67A3DE4D6735BD
          F36ADA158CB1F98F2DD45692457301B58D4BF9FF00ED3FFB07FC69D2FE3FF8FB
          E227872E3FE158DF5F7FC26E3C43F11AE3C43A2E8FA45B69379A06B8BA2DC8D4
          5207F11496F6731D25EED6FAF16DEC6E6DA1363692DA5BDBBD8807EB0515F8C1
          E1AFD9FB4BFDB8FC75F10758F827F0FF00FB17E07C3FF0861D4BC21E03D73C29
          E2287568AD63F18A5C69915A5CBDDF8521B88AFF0051D2B52974EF3E4892278A
          FC94D42E5631FA7BFB067C1DD4BE027ECA1E15F09EA917882D66D33ED8F05A6B
          7A858DEDFE9D6B35E4F3DB5A486C2082C61F220922845AD9C7F65B55896DE092
          686149A400F62AF9FBF6C8FF00938AFD93FF00ECAADF7FEA11E2BAFA06BE7DFD
          B9740F187FC25BF027C59E12F02F883E227FC2BCF1FCFADEADA4E8979A6DADFF
          00D8E5F0D6BDA689633A85D5AC0DB6E350B6CAF9A1B6B3101B691401F41515F3
          FF00FC364FC45FFA34EF8FFF00F837F047FF0034347FC364FC45FF00A34EF8FF
          00FF00837F047FF343401F40515F3FFF00C364FC45FF00A34EF8FF00FF00837F
          047FF34347FC364FC45FFA34EF8FFF00F837F047FF00343401F40515E7BF033E
          31F88FE2D1D53FB7FE147C40F85FFD9FE5791FF093DE68771FDA7BF7EEF27FB3
          351BCC797B17779BE5E7CD4DBBF0FB77FE287C4AD3FE107816FBC45AB5BEBF79
          A7E9BE5F9B1689A0DF6B97EFBE458C79767650CD732E19C13E5C6DB543336155
          980074745737F0B7E2C785FE38F812C7C51E09F13681E30F0CEA9E67D8F57D13
          508750B0BBF2E468A4F2E7859A37DB223A1DA4E19181E4115D25001451450014
          5145001451450014514500145145001451450014514500145145001451450014
          5145007C7FFB477ED6DF13748FDBE64F843E0DD7B40F0D582F85740D5E0BABCF
          83DE23F1D7DA2F353D4757B4617375A65F5B5B69B6F1AE9D090F77B55BCC99BC
          C0B13EDDFF0083BFF052ED07C7DF127C51E0E6F0EFC40D7356F08FF6DEA9AAEA
          1A4784A46B0B0D32CB5DF116929958AE2E659AE3CED05E148610D7378D7114D0
          DAAA0BA8ECBDB745F829A5E87F1F3C4DF11A1B8D41B5BF15787F49F0DDDC0EE8
          6D63B7D36E753B881E350A1C48CFAADC0725C82122C2A90C5B80F843FB037837
          E0D6BFF11B50D3753F184D27C4EB4B9B3D5B3AB1B392D927D6B5FD65CDACF6AB
          0DC5BC82E3C477CAB22482448E2B6DAC244691C03C8344FF0082B15F7C56F1A7
          C0787C0FF0AFC6175E1DF8ADE359B41BFD5A4BDD0353D3D6C174AD5AE05C5A6A
          1A7EAD3594D22DCE9B319638A59E68A1D3EEC490C72DC69E2E7D43F68BFDB53F
          E14778EFC7719D3F77867E0AFC3F6F89BE399841F68BFBFD3A58F565B4B2D323
          F3638FED0D2693772CB2CEE1116282258E4374F3D9E7E87FF04DFD3F4FF1A687
          E2AD43E28FC4FD73C63A2F8D2D3C6EFADDCAE8B6D26A735BE9575A47D96E2DAD
          74E86C9A392C6F67824B85B75BD78C5BA7DA825A5AAC39FF00B727EC57E2AF8E
          3A37C6093C0F7FE1F5D43E35FC2BBCF865ACC3AECF35BC361E55AEB0DA5DEDBC
          90C521F96EB56B88AE22743BE29629639236B5682F000F10FF00C153FC2BE1AF
          11E97E1FBCF877F17E3F16788B55B4D3B42F0EFF0060C3FDABAB417D63ABDDE9
          B7FE499FFD12DEEBFB0F508B6DF1B79ED1E2DF7D0D9421A65CFD03FE0AD1F0DB
          E31FED3FAE7C0DF06F8834FB1F884D77ABF87745D4AFEE34DD4AD64D6F4F8AE1
          AE219749B7D4535748E06B4BB2D25CDBDA5BCC2D488AE7FD22D5E6EC3C1DFF00
          04EDF0B7867E2EF877C757BE29F881E26F13785355B7BDD2EFB5BD4E1BA9A1B1
          B5D375AD3ACB4B924F2564B8B7B78F5FD4E413DC3497D2CB32B4F7738455AD0D
          03F645B8F839E2CD73C45E0DF15F8C2FAD16EF57F11689E00BFD660D37C2F1EB
          7A83DC5C5C4D2DCDBD93EA0F1CF7577772B47732DDDBC2F74648ADB75BDAAC20
          19E7FE0A05A1F85FF646FF0085B1E28F0FF882CE1D3BC57FF0846AFA5E856D26
          B9710EAC9E24FF00846E7FB22468B35E5B8BF0CD194856E25802B0B61330B7AE
          3F5EFF0082C47C29F05FED3DA27C23F10C7A87877C65A95DE91A46A3677FAC68
          6B75A06ADA9C56F25A69B2D8A6A0D7F75237DB2CD1AE34FB6BBB343392D72120
          B9787D03C27FB1169767FB3869BE01D775CD4352923F1AC5F11350D42C214B25
          BAD647898789E51144FE779366DA86E45859E4916DC8433BC83CF3A179FB1FD9
          FF00C2F5D4BC67A5F8E3E2078774FF00116AB69AFF00887C31A55E5ADBE95E22
          D4ED6DEDADA1BBB89BECE7504C4363611BC16F770DB4C96812586459AE56700F
          2F8BFE0B07F0DADFE1A78FBC67AA68BE30D07C29E03BB3A736AD7E74D16B7F7B
          F6BB6B31632BC778E347BCF3EFAC15ADB5DFECD9A21745E54892DAF1ADCF809F
          F0582F86BFB4CF8ABC1FA0782F45F18788B5EF175DEA966F6DA39D3758B5D0DF
          4E7D21AECDDEA163793E9E234B5D6ACEEBCC8AE658C8125BEEFB779765274127
          FC1353C3FAADC6BD36B5F103E27788EF2FAD74DB2D12EF52D42C9EEBC2E9A66A
          29A9E9863992D564D4A4B3BC8A19A193596D42405660CCCB797C2EBB0F85FF00
          B1EDAFC3FF008A5A0F8E354F1C78FF00C73E30D134AD67486D4FC43796ADF6D8
          B539B4992526DEDADE1B6B7F2D745B348D2D22822E679248E59E6926600E3CFF
          00C14F7C0327833C37AB5BE8FE30BCBCF11787E1D5DF4886D6D9B50D0EFEE355
          B4D1ACF41D453CF0963AA5CEA9733592473BA42B3699A90966896CE665E3FC77
          FF000574F0B7C34F18585AF893C33F103C3F7563F69D3BC47E141E1C8757D7B4
          9D45B54F0A59DAAF99A7DECF14D987C556171E4D925E3CD1DCE15E2B8B76B49B
          D3F57FD803C03A869BF1192DE3D434BBCF88BE20B0F143DF590B68EE341BFB19
          E0BDB37B2FDC9411C5AA4536A9E4CEB34325EEA17F2CA922DD4D1B7213FF00C1
          29FC15ADF8CB4BF146BBE2EF881E22F17DA6AB1EB7A8EB9793D84373E20BC8F5
          4F0CEA114B7315BDA456C9B17C25A3DA85B686053024C5834F299C007D1DE16D
          66E3C47E15D3750BBD2750D06EAFAD22B89F4CBF781EEB4E7740CD04AD0492C2
          648C92AC629248C953B5D970C7528A2800A28A2800A28A2800A28A2800A28A28
          00A28A2803E7EFDB23FE4E2BF64FFF00B2AB7DFF00A8478AEBE81AF9FBF6C8FF
          00938AFD93FF00ECAADF7FEA11E2BAFA06800A28A2800A28A2803E7FFF00824E
          FF00CA2CBF669FFB255E17FF00D345AD79EFED2BFB73F8EBF66AFDA9BE2E793E
          17FF0084B7E19FC31F857A0FC41D737EA56FA77F625A8BBF12FF00693DB62292
          7BCD427B7D3EDBECF6B27956A7EC72F997568CCBE7FA17FC1277FE5165FB34FF
          00D92AF0BFFE9A2D6BBDF88FFB2E7817E2D0F1F7FC241A1FF687FC2CFF000AC5
          E0AF13FF00A6DC45FDA7A3C5F6FD96DF248BE563FB4EFBF7916C90F9FCB9D89B
          403E70D23FE0AED26A1F197C65A7B7C27F1837C3DF09DDF8974D7F13C76BA8DB
          451DC6822F45E4B77777D636DA0DAD9BCDA75D4314E35A90F992DA09A3837DC7
          D973FE167FC15BBC49F137C47FF081AFC25FECBF8BBA86ABA75868DA56AD77AE
          E87A15D457963ADDF24D3DDEA9A1D9EA116D87C3BAA8261D32788C86D11653E6
          5C1B5F7F9FF60CF84F7FE3BD5F5EBEF0A7F6B7F6E7DB9AE745D4B53BCBFF000D
          A4B7D1CB15F5C43A34D2BE9D6F717297174B3CF0DBA4B30BDBCF31DBED53F998
          1A67FC1307E0BE9275AB8B7F0EF8823D73C41F606BFF0012FF00C261AD1F135C
          4B63F6D5B5B8FED8377FDA0B7090EA1796BE7ACE256B49BECACED6CA90A80687
          FC13D7E35789BF683FD9C2E3C4DE2EB7D42C75B93C6BE30D30D8DFC768B75A5D
          BD9789F54B2B5B397EC8CF6ED25BDBDBC30B3C72481CC45BCC90B191BDCAB8CF
          811F00BC1BFB31FC34B5F067803C3FA7F853C2B63777B7B69A558295B5B37BBB
          B9AF2711212447199E7959634C47186088AA8AAA3B3A0028A2BE7DFDB9B5FF00
          17FF00C25BF02BC23E13F1D7883E1E7FC2C4F1FCFA26ADAB68967A6DD5FF00D8
          E2F0D6BDA908A31A85ADD40BBAE34FB6CB7945B6AB0057713401F41515F3FF00
          FC31B7C45FFA3B1F8FFF00F828F047FF0033D47FC31B7C45FF00A3B1F8FF00FF
          00828F047FF33D401F405719F1B35CF1F687E14B79BE1CF867C21E2AD69EED52
          7B4F11F892E740B58EDF6396916782C2F5DA40E2302331282198EF0542B7997F
          C31B7C45FF00A3B1F8FF00FF00828F047FF33D47FC31B7C45FFA3B1F8FFF00F8
          28F047FF0033D4007FC2C8FDA9BFE88E7ECFFF00F879357FFE6628FF008591FB
          537FD11CFD9FFF00F0F26AFF00FCCC57AE7C30F07EA5F0FBC0963A46ADE2DF10
          78E350B3F33CED6F5B86C61BFBDDD2338F316CADEDAD86C56083CB853E5452DB
          9B73350F8D9F0A6E7E31F85EDB478BC61E30F0759B5DAC9A8C9E1BB982D2EB55
          B5D8E92D935C3C324D6F1C81F266B37B7BA8CA2B4571130C900F80BF6BAF16FC
          4AF067C639AEB41F863F0C3C2BFB43F88ED21BD8E0F857F183529BC5DE218706
          D2DEE352B06F0A4B617366BE5359C57FAE40D6562D39DB7168EC241F777ECADE
          22F88FE2DFD9CFC19A97C5EF0EE81E11F89D7DA5432F89347D12FDAFAC2C2F0A
          FCE91CA47D0940D2AC6C59166B85513C97BE0B7C00F06FECEBE159F47F05F87E
          C341B3BEBC6D475092105EEB58BD744496FAF6E1CB4D7979288D0CB7370F24D2
          95DCEECDCD769400514514005145140051451400514514005145140051451400
          5145140051451400514514005145140051451400514514005145140051451400
          5145140051451400514514005145140051451400514514005145140051451401
          F3F7ED91FF002715FB27FF00D955BEFF00D423C575F40D7CFDFB647FC9C57EC9
          FF00F6556FBFF508F15D7D034005145140051451401F3FFF00C1277FE5165FB3
          4FFD92AF0BFF00E9A2D6BE80AF9FFF00E093BFF28B2FD9A7FEC95785FF00F4D1
          6B5F40500145145001451450015F3F7ED91FF2715FB27FFD955BEFFD423C575F
          40D795FED19FB20781FF006A9D4BC2B79E30FF0084C16F3C13773DFE893E83E3
          2D67C39258DC4D035BC9306D3AEADCBC9E4492C41DF7148E79D54AACD20600F5
          4A2BE7FF00F87697C3BFFA193F680FFC3EDE37FF00E5B51FF0ED2F877FF4327E
          D01FF87DBC6FFF00CB6A00FA028AF9FF00FE1DA5F0EFFE864FDA03FF000FB78D
          FF00F96D5C6FC6BFD913E10FC03F0B5BEB1AEEADFB575F59DC5DAD9247E1BF89
          3F12FC4B741D91DC16B7D3AFAE2648F11B0323208C12AA5833A8201F59515F36
          F84FFE0A0BF0CBC15E16D3747B3D03F68F9ACF49B58ACE092FFE0CF8FAFEE9D2
          3408A65B89F4C79A690800B492BB48E72CCCCC4939FF00147F6D2F827F1C7C09
          7DE17F1B7C37F8C1E30F0CEA9E5FDB748D6FF679F196A16177E5C8B2C7E64136
          8ED1BED9111C6E070C8A47201A00FA8A8AFCEFF167EDB30FEC7BE15D4BC43E03
          F127C6ED6FC09A15A4B7FA8786FE2DFC2AF880F6BA6DBC685E59A1F133E8F3DF
          DA46BBA7B999F514D4C308A386136310DCBF66FECADFB48685FB5FFECE7E0BF8
          A1E19B3F1069FE1FF1D6950EAF616FADE9B269F7F1452AE409227FD1D0BC522E
          D92292489D24600F43A28A2800A28A2800A28A2800A28A2800A28A2800A28A28
          00A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A28
          00A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A28
          03E7EFDB23FE4E2BF64FFF00B2AB7DFF00A8478AEBE81AF9FBF6C8FF00938AFD
          93FF00ECAADF7FEA11E2BAFA06800A28A2800A28A2803E7FFF00824EFF00CA2C
          BF669FFB255E17FF00D345AD7D015F3FFF00C1277FE5165FB34FFD92AF0BFF00
          E9A2D6BE80A0028A28CD001451450015E39FB5A7ED0BE2AF81D75F0DF48F0578
          4BC3FE30F137C4CF15BF862CEDF5BF114DA158DA797A46A7AAC93C9710D9DE49
          FEAF4C7408B09CB4AA4B2806BD8EBE7EFDB23FE4E2BF64FF00FB2AB7DFFA8478
          AE8017FE1647ED4DFF004473F67FFF00C3C9ABFF00F33147FC2C8FDA9BFE88E7
          ECFF00FF00879357FF00E662BE80A2803E7FFF008591FB537FD11CFD9FFF00F0
          F26AFF00FCCC51FF000B23F6A6FF00A239FB3FFF00E1E4D5FF00F998AFA028A0
          0E73E166A3E2AD5BC0B6371E36D1F40F0FF89A4F33ED961A26B336B1616F8918
          47E5DD4D6B6B249BA308C77409B599946E0A1DB3BE34DCF8F97C296F0FC3BB3F
          07CDAD5EDDADB4F77E23BCB986D747B76470D78B041133DEC913F9645A196D04
          C370FB54070D5DA51401E1BE13FD8874BD67C53A678AFE2B6B9A8FC62F18E977
          716A5A7BEB71245A0F872EE3712C52E97A3A7FA2DB4904A65F22F26171A9471C
          CD13DF4C95EE5451400514514005145140051451400514514005145140051451
          4005145140051451400514514005145140051451400514514005145140051451
          4005145140051451400514514005145140051451400514514005145140051451
          401F3F7ED91FF2715FB27FFD955BEFFD423C575F40D7CFDFB647FC9C57EC9FFF
          006556FBFF00508F15D7D034005145140051451401F3FF00FC1277FE5165FB34
          FF00D92AF0BFFE9A2D6BE802702BE7FF00F824EFFCA2CBF669FF00B255E17FFD
          345AD7D00791401E1FE15FDBAFC097FF00B42F8BBE19F883C45E12F0AF8AF43F
          10C5A0687A66A1E20B78B50F1497D2B4FD41A4B6B57D9236DFB7796563127FAB
          DD91BB6AF4B71FB5FF00C27B3F893AE783E4F8A1F0F53C61E18B49350D67426F
          11D98D4B49B58E359649EE2DFCCF3218D2365767750A158124020D7CF1F163F6
          20F89DE32F8C3F1421D3B4FF00854FE09F8ADE38F0F789EEB5BBDBEBB5D7B458
          34AB6D2136C76CB68D15C4CD2E9F2F944DCC220F3049994B18D66F017EC45F12
          B49F1FF843C3BA95A7C3583E1EF80FE216ABF102C7C4965A8DDB788B5392F24B
          F985B49626D521B77DDA83C725C2DECDE6C70E3C95F3888E5DF9236DECAFEBA5
          DFDF7F5E8554E54DB5D969DDDBFCF4F2EA753F087FE0B0FF00B3E7C6DF107C37
          D2F43F895E129352F8A36B3CFA559BF8834D33DBCF1B40A2CA744B9665BB91AE
          00489039631C838DBCFACF843F6BEF84FF0010752F1559E83F143E1EEB979E04
          5924F12C161E23B3B993C3AB197590DE2A484DB8531C818CBB705181C60D780F
          C2BFD917E2E780F40F83B637563F0F5FFE15BE9DAAF836F24B7F13DE86B9D22E
          D6C826A71674EE2F17ECA49B26C47F38C5DF1CF057BFF04DCF8B1F10BE04DAF8
          0F5CB5F847A05BF803E146BFF0DBC2FA8E8BA9DECD27889F50B286CE3B8BD89A
          CE21A7DB85B74964B78DEF73248087FDCA992A366DFE1E7BFDDD3EFF00260ACE
          493F9F97F5FA799F57F873F6DEF82FE31D634CD3F47F8BDF0BF56D435CD527D1
          34EB5B3F1558CF36A17F02C6D3D9C28B29324F1ACB1178941751221206E19E47
          F6C56CFED15FB27F1FF3552FBFF508F15D70FE39FF008275EA1ACFC43F891AD6
          936FE0BB11E297F018D25846D1CB669A06A02E65562B0FC836051084246E033E
          5819A87F6E9F0078AB50FF0082977EC3DE28B5D6BECFE09D1FC57E2CD2B55D27
          ED932FDB750BBF09EA32D8DCF90079527930D9EA29E6390F1FDAF080892420E9
          AEF76BE5A59FCF5338B6D5CFB0A8A28A0A0A28A2800AF9FF00FE0AC5FF0028B2
          FDA5BFEC9578A3FF004D1755F4051401F97FA77C33D77FE09E9F187C5F716F1F
          C1FF0086F7FA3FFC2277B13FC30F8771F82FC3DE27F095D789F498BC43A96AB0
          CD75742E2E348B582F15E65223D2ECB57FB434FBB50DB6BD87C38FDAABC71FB7
          2FEDF7E24F05F82FE3678C3C23F0D6DAEFC4977A3EA1E19D0F46F3351B7B1D23
          E1FBDBF972EA7A6DC89ACDE7D7B54B88AE23522E23B98648E592DFC9AFD10A28
          03F33FE037FC147FE21FC6B83E1E78A356F1F58787FE20F8AAEBE1FF00F62FC2
          3B0B4B04B5F19E83AD69DA05CEB3AEC56D3C726AF34766DA9EBA56E2D6ED6DA1
          1A10F3964FB3DE79B43E0F7C1BF116A3FF000A23FB5BE2C7C40D7BFE126FDAA7
          C6FF00F0927F6859E86FFF000947F62FFC24BFD9DF6EDBA72F9DE47FC23363E5
          74FB3EE1E4793F63D37EC3FA7F45007C7BFB4E78FF00C55A67ED1BF1CB58D074
          5FF84DBC4DF037E0B69FE32F871E1F96D26BD857C437EDE2A82574B684AC93DC
          5C47A65A5AAB026648A4B98A06885E5C897E53D2FF00684B86FF00828F2EA5E1
          1F8BBA7FC68D356D7C3D67A5F8E2E3C0B0788249D22F0D7C54BCCC234C8A18B5
          4921BB8DA33268AB6D2491AC9A79633A5DB4BFA95E20F85DA0F8AFC75E1DF13D
          E58EEF10784FED29A65FC534904D0C573188EE2DDCC6CBE6DBC9B6276824DD11
          96DADA529E6DBC2F1F49401F99FF000D7F6E4F15DFFC26B38F55FDA2B4F9BC29
          378D6DB45F187C50D3750F0E6BDA6F82AD5F49D52F525B5F1143A6DAE8CD1CD7
          96DA458B41A86971DD5B4D7D329F312FF4AB819FE3AF8BFE3BF0E78C7E3F7C60
          F057C61FEDEB5F85FF0000344F175BEAA9E14B7B7FF8587FD9BAA78E65D396E5
          A55311D3E78606FB44FA7C56FF006EF362B9B19ECADD96393F5028A00FC8FF00
          DB2BFE0A7BF1B3E08FC56F8A5FD83E36D3D634B4F1E6996DA14F1DB35E7825F4
          9F0EEBBA96977B369834A67B292E5F47867B696FF59B98F52B5967B986C238E4
          31E9DE9FFF000521FDABFE2C7EC81E04F88D6971F1C3FE11AF16F837E15CBE2C
          F094EBE0DB3B887E22EB93C9AD36A76B0583472CEF6FA4DBDB69D245F67989B0
          8AEA3B9D525BF84397FD21AF2CF8D3FB1F7823F686F155BEA7E2E1E30D4A38AD
          16C27D1E1F196B365A06A96E1DD9A1BDD2A0BA4B0BD8E4F31D254B982413467C
          B903C602000F90BE0BFED17F13FE3F7EDE5E24F87BE3AF127C31D53C1BAC7883
          C51E19D7FE165FEA716A5A9DA7876DFF00B420B1BD97438F44175671DE45069F
          2B5DEA3AB4D63710EA444712BDF594317D3DFF0004F5F176ABE2CFD9C275D5B5
          2D435793C3FE34F17F85ECEE2FEE1EEAE8D8697E27D534DB24967909967912D2
          D20469A6679A5286491E4919DDBD7BC59E1AB7F1A785B52D1EF64D421B5D56D6
          5B29A4B0BF9EC2E9124428C62B881D268640092B244EB221C32B2B0041E12F0A
          697E03F0B699A1685A5E9FA2E87A2DA4561A7E9F616E96D6B616F12048A18A24
          01238D1155551400A0000002803528A28A0028A28A0028A28A0028A28A0028A2
          8A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A2
          8A0028A28A0028A28A0028A28A0028A28A00F9FBF6C8FF00938AFD93FF00ECAA
          DF7FEA11E2BAFA06BE7EFDB23FE4E2BF64FF00FB2AB7DFFA8478AEBE81A0028A
          28A00CBF14E8B73E23F0AEA7A7DA6ADA8683757F692DBC1A9D8240F75A73BA15
          59E259E39613246486512C72464A8DC8CB953E7FFB33FC6AD57E2269BAC7873C
          656F61A4FC4AF05DDBD9EBBA7DB46F0C7756E679D2C357B789D9CAD9EA1041E7
          C6AB2CE2193ED168F3C9716771B7D52BCB3F699F82DAA7C42D3B47F127836E2C
          349F895E0BBB4BCD0750B977863BAB733C0F7FA45C4A8AE56CF50820F2242D14
          E2193ECF76904971676FB403E62FD9FBC55AA6B3FF00048BFD93FE15785753D4
          34BF197C62F86BE1AD15350D32E1E0BEF0E68C9A2DABEB1AC472C67CDB6920B4
          261B6BAD8F1C7A95F694928D9357DE15F16FFC11B3E0078CBC33FB367C38F187
          C4CF0FEA1E17F12693F0D7C35E05F0EE81A9A85BDF0EE9765A6DAFDB249A125F
          ECB797DA8095E654752F6B63A32CF145716D2C6BF691E68018073D6BCC3F694F
          DA76D3F66EB5F09AC9E17F15F8C354F1B6B4DE1FD1F4BF0FC36F25D5CDDFD8AE
          AF0026E278228D0C76728F31E4555254B154DCEBEA18DA2BC47F6C6FD9975CFD
          A4F54F85ADA1F89EFBC1EDE09F163EBF75AA69F3247A85B47FD91A959A1B612C
          13C124826BC8498E78DA268C481837DC6977E9DFF02A36D6FD9FDF6D3F13CEBE
          317FC15DBC15F033E0C68BE35D7BC27E26B0B5D4354D4743BFB0D4FC41E18D0E
          F343D42C6431CD6B29D4B56B68679095729F6296E55D53706DAC85BB3B3FF828
          068FE31F19786F46F047813E217C406F147842D3C6F6D7BA4DBD85B59DB69B77
          E77D9DA67BEBBB6DB23B45B444017F9C1C6D595A3C3BDFF8260E85069FA1C9A3
          FC49F8A9E1BF12E9B06B16DA8F89AC2EB4D9755F10C7AB5C43737E2E4DC594B0
          C4659A0898359C56ED1045588C68A147A37C0DFD923C37FB3FEA3A4DC68B79AD
          5D368BE0FD2FC136EB7B34720365A7998C3236D8D4999BCF7DED90A70B855E72
          D2BC75D1E9B7A3BFCAF6F3DFD4CDDFA7FC3EAADF3B5FCB6337F604FDA3FC49FB
          56FECB1E15F1CF8ABC1BA9782B58D6AD239A5B4B992D1A2BADC8ADF68B716F75
          73B6062C42ACAEB28DA7720E09E9BF685FD98FC23FB4FE8FA0D9F8B61F107FC5
          31AAFF006DE9375A2789352F0FDF69F79F65B8B432C775A7CF04EB9B7BBB98CA
          EFDACB2B020F183F66AFD9FE1FD99BE17DBF83EC7C4BE23F1168FA6CAC34B1AC
          AD9F9BA55AF023B38DADA0877C31818569BCC98E4EF95F8C7A1734E4EEEE8A3C
          07FE1DA5F0EFFE864FDA03FF000FB78DFF00F96D47FC3B4BE1DFFD0C9FB407FE
          1F6F1BFF00F2DABE80A2803E7FFF0087697C3BFF00A193F680FF00C3EDE37FFE
          5B51FF000ED2F877FF004327ED01FF0087DBC6FF00FCB6AF6CF165D6A967E17D
          4A6D0ACF4FD4B5C8AD257D3ED2FEF1ECAD6EAE02131472CE914CF0C6CFB4348B
          148541242391B4F89FFC2C8FDA9BFE88E7ECFF00FF00879357FF00E662803D77
          E17FC35D3FE0FF00816C7C3BA4DC7882F34FD37CCF2A5D6F5DBED72FDF7C8D21
          F32F2F669AE65C33903CC91B6A8555C2AAA8E8EBE7FF00F8591FB537FD11CFD9
          FF00FF000F26AFFF00CCC51FF0B23F6A6FFA239FB3FF00FE1E4D5FFF00998A00
          EF7E05FED47E05FDA37FB521F09EB9F68D5B41F2BFB6743D42CAE349D7741F3B
          7983EDDA6DDC715E59F9CB1BC917DA218FCD8F1226E46563E875F077EDB9E21F
          1CCDE16D0F5EF8C1F083F670D26F34FBB7D3BC2DACDAFC72F10699E2886F6E53
          7358E897563E1B4D4BED9771DBF97F66B07F3AED14C3B2556287D3FF00E0973F
          107F682F1F7C2EF11C9F1DBC2BFD870DAEAA0783F53BFD5E1BAD7BC43A63C292
          1B9BEB7834DD3A3B6FDE3308964B4B4B958C88AE2D229A069AE403EA2A28A280
          0A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A280
          0A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A280
          0A28A2800A28A2800A28A2800A28A2800A28A2803C33F6CEF84DE3EF1E6B3F07
          FC49F0E74FF07EB3ADFC31F1ACBE239F4DF11EB973A2DADFDBCBA0EB1A5322DC
          C16778EB22BEA71C801848611B0DCA48354BFE1647ED4DFF004473F67FFF00C3
          C9ABFF00F3315F4051401F3FFF00C2C8FDA9BFE88E7ECFFF00F879357FFE6628
          FF008591FB537FD11CFD9FFF00F0F26AFF00FCCC57D0145007CFFF00F0B23F6A
          6FFA239FB3FF00FE1E4D5FFF00998A3FE1647ED4DFF4473F67FF00FC3C9ABFFF
          003315F40668CD007CFF00FF000B23F6A6FF00A239FB3FFF00E1E4D5FF00F998
          A3FE1647ED4DFF004473F67FFF00C3C9ABFF00F3315F4051401F3FFF00C2C7FD
          A9BFE88DFECFFF00F879357FFE6628FF00858FFB537FD11BFD9FFF00F0F26AFF
          00FCCC57D01466803E7FFF00858FFB537FD11BFD9FFF00F0F26AFF00FCCC51FF
          000B1FF6A6FF00A237FB3FFF00E1E4D5FF00F998AFA028A00F9FFF00E163FED4
          DFF446FF0067FF00FC3C9ABFFF0033147FC2C8FDA9BFE88E7ECFFF00F879357F
          FE662BE80CD1401F3FFF00C2C8FDA9BFE88E7ECFFF00F879357FFE6628FF0085
          91FB537FD11CFD9FFF00F0F26AFF00FCCC57D01466803E7FFF008591FB537FD1
          1CFD9FFF00F0F26AFF00FCCC51FF000B23F6A6FF00A239FB3FFF00E1E4D5FF00
          F998AFA028A00E73E166A3E2AD5BC0B6371E36D1F40F0FF89A4F33ED961A26B3
          36B1616F891847E5DD4D6B6B249BA308C77409B599946E0A1DAFF8A745B9F11F
          85753D3ED356D4341BABFB496DE0D4EC1207BAD39DD0AACF12CF1CB099232432
          89639232546E465CA9D4A2803CB3E0A7EC89E0DF829E2AB8F14C70EA1E27F885
          A85A3596A1E34F125D1D4B5FBC85DD2596DD6E1C62D6CDE74F3C5859AC165148
          CCD15BC59C57A9D1450014514500145145001451450014514500145145001451
          4500145145001451450014514500145145001451450014514500145145001451
          4500145145001451450014514500145145001451450014514500145145001451
          4500349DDED5E61E3AFDAEFC07F0EFE31E9FE01D4F52D59BC4D7E96CE63B3D03
          50BEB3D3D6E65786D8DE5DC103DB5979D223A47F69962F319485CD7A793C57C8
          BFB5DFC33F885A8FED29A5EB9F0BFC0BE39D1FC65336936CDE3BD23C45A6A787
          6EB4F4BA737365ADE9B7570B24CB1C524ED1BDBDA4F3AF9C3CA9E02D2289FB49
          74BD983F85BEB6D3EF47D72DFE45281C57E5EF847FE09B7F14746F137C6ED46D
          ADFE2769FF0015FC55A3F8AED2C7C6426F08D8F86FC43F6E9E46B147BAB38D7C
          40CE909B7118BCDE96AF0B88DB62445BD1BC4BFB27699ACFC0CF05D9F87FF639
          FF008467C0FE1FF170D4BC5BF0A3CBF0ADA7FC26519D365B78AEBC9B7BF7D36F
          7C8B97B79765F4F131FB2EF00BC710635E5BFA69EBFD7F9D83ADBCDAFB96FF00
          D7CAE7DF59C7F8D727F1CBE3069BFB3F7C15F1778EF5A82FAEB48F05E8D77AE5
          EC3668AF732C16D0BCD22C6AECAA5CAA10A1994138C9039AF8A7E127FC1327FE
          162F88FE1BDAFC4FF85BA4C9F0DF46B0F1BCB6BE0CD56EAD351B1F0947A8EA3A
          54BA5698F0248D049E54105CBAC7179D6F6D222889C08E06AF2FF8CBFF0004F7
          F89FF117F67CB5F0EF8D3E0B4BF16BC597BF02B4AF08787356BFD774B91FE1E7
          88E1B5BB5BE964B8B9B91346F7124B699B9B213B4C6D824A563556AD29C5349C
          9DAF6D3AABDFF2B2FBF72E9A8BD65F3FBEDA7CB5FD0FD22F89BF1AF48F855A1E
          877DA825ECC7C45AB5968B616D6B189279E7BA95635C296036A29796439F9638
          A46E76E0F60B92DED5F38FED99A549A0F887F67BF11DE2C6BA57847E23599D4D
          9F1B61FB769BA86916EDD0F3F6CD42D578200DF9CF15E07A37FC127B4FF17FC6
          3F0AEBDE32F857A06B09AC78F3C737BE389EFA4B6B9FED9D16EEF6FEE74982F1
          4C87ED56A241A7CD1DAB0748654490C71C8ACC21E89B8EB66D7E5A79EE64A568
          C5CB76A3756D55DCBFC97DE7E85E496C56469BE2FB5D5BC4BAA6930C3AA2DD68
          E216B879F4DB982D64F354B2F9370E8219F014EE113BF96701F69201FCADFDA7
          3FE09CFF00193E26FC31F00D8BFC31D4B57F18783FE1BE93A378775ED223F074
          BA868FABDB3CE655D4356D5965D4A14880B66B77D25C3EF69D9A5466574FA93F
          6A5FD8F7C55F1B2EFE2B58B6832EA1A3F8D35EF87F2A04D4A3B56BAB3D3F56B6
          9B5260E25592331C092375576C623DCD814ED7B38F595B5D2CAFBBF22B69A83D
          AC9B7D3D3E47D31F13FE30E97F092E7C34BAB25E2DBF89B5A874186E2245686D
          6E26490C2662581549244585480C4C93443003161D76771AF817E20FECC49F00
          3C25E26F879E1CF0BE97E13F0E78E3E3AF84B51F00E8FA77910D8DBDADAAE87A
          8EA0F696F1EE4B6556D335799A308996595F6912066F7BFDA47F64FD3BF689FD
          AA7E126B5E26F09695E2BF08F836C35B9EE1352486E2D6DAFE56D3CD9BB5BC87
          F7AC0C333A1D8C2378D5FE5708D45972A7E7AF92E54FF36D7C8A716A56F2BAFB
          DF53DFCF5FA537278AFCC9F863FF0004E0F12E81F10BE316A7E34F0BFC75D6BC
          45E2CD3BC4F637BAE786E6F0259D878BACF50B9736D0C370DE46AB2DC476ED0F
          971EA8E6DA0781D03188207C7D77FE09EFF117C5FF00B2FE93E156F8369E13F0
          1E87E3E9352BAF07F85BC2FE04D37C43E2BD3CE95E4437BA8D84F25DF86EE2F2
          3BBD8CEDBA159123124705B3C5144662DB577D969F3B7E04F2EB6F37F95EFF00
          A1FAA05B9A4DDCD7C5DF023FE09CBA25E7C52F0D6A1E36F03EA7AFE83E19F865
          A5F8774597C752699A86ADA55C8B8D40DC44E966CD6B1DC4704F0C426B65D8A8
          EC913ED2E0F9CD9FEC29F15F56F801E22B1F18786078B350F058D0FC0FA46932
          6AD6AB2F8F7C25A4EA097377990C9E54726A906D8E4B7B978D2436A893148D8B
          07D7E7F85EDFE4FD3D09D7F2F9B693D3F157EEBCCFD00F1478C6CFC1C9606F23
          D4A6FED2BD8AC21FB169B737DB2490E15A4F251FCA887F14D26D8D3AB328AD80
          DCD7C2BF077F642F14E91A6C93F877E15B7C25F06DC7C50D13C43A47808DEE9A
          8BE1CB0B58624BDBA10594D2D95B99E65797C8B59A40DC48409649147B4FEC53
          FB2869FF000335BF889E2AD4BC23A4E95E36F1978BF5BBD9F570B14D7F7DA74B
          A8CF35A219D4B32C3E5B238837054677628AECE4A8DEED3FEB48FF009BFB8257
          5B797E3CD7FBACBEF3E83A28CD15450514514005145140051451400514514005
          1451400514514005145140051451400514514005145140051451400514514005
          1451400514514005145140051451400514514005145140051451400514514005
          145140051451400514507A50034FCC6BCFFE28FED35E06F8257BAA5BF89B5C5D
          2EE347F0EDE78B2EA2FB24F338D36D0A2DC4E82346321469230634DD21322E14
          EE19EFBBD78DFED49FB2447FB4978C3E1FEB29AE7F60DC783B55F37505160B77
          FDBBA53C90CD71A636E6511A4D3DA593B3E1F02DF6ED3BB72E72BE9CBFD79FDF
          BF90D6BB92788BF6CBF09C7AEE8FA6E83AAE8FAB5F5FDE6889731DC4B776EB05
          AEAA66FB2C91B476B32BCD22C1232C4E631800BC910652DE1B7BFF00057DD16E
          E0F0CEA51E83E26D07489BE276A1E03D61752F07EB9F69B98A1B3D61EDDEC236
          B489EE6EA6B8D3E0536F04770F1998C4CBE6329AEDBE18FF00C138E1F86FE11B
          5D3DBC59F6EB9B3F1B69FE288EE7FB2BCAD961A7C315AD8E98A9E710AB15ADBC
          2865070D21964F2D7CC2A2FF00857F61BD6F47F899A56A375E36D2AEBC3BE1BF
          88BA87C41D274E8BC3D2437D1BDFD96A905CDACF746ED9251E6EA6648E448222
          A90EC6590BF98B54FE26E5B74FBA3FFDB0BA35E5BF77697EBCA749E37FDB8BC2
          3A3FEC61E24F8DBE1B1A8F8B7C3BA0E937BA8476D6BA75E477934D6AD24725B4
          B6FE435CDBC89346D14AB243BA0292191542362AE85FF050EF85BA8FC35B9F13
          6A5AC6ADE1DB7D322D2E5D46D357F0F6A7A7DEE9FF00DA5706DACCBDB5C5B473
          EC92657512796142A3392A80B55BD0BF6408B4BFD99BE207C35B8D7A6B8B7F1E
          5EF89EE65BF8ED044F66BAD5F5EDD94542EC18C22F366E246FF2F761776D1E7F
          E2AFF82736A3F1775AF096A5E37F1AE8FA84FA7F86AEBC37E2AB6D23C32D6365
          E2A411DCC5A748239AEEE1EDFEC82F6EDC02F2F98F36E063036D36FDE76DB4B7
          E375EBB2F9FA872ECAFD5AF55A5BD3AB3BEF88BFF0505F853F0BF5ABCD32FB5C
          D6B54D62C752B8D2A7D2FC3FE17D5B5FD4126B78209EE1BECD636D34C618A3BA
          B6F32708624799119C390B5D278AFF006AFF0087BE09F80765F14B50F1459FFC
          203A8A58C969ACDB4725DC172B7B34505AB208559984924F12E42E06EC9C0048
          F19F0FFF00C13FFC75F0B6CBC25AE7827E2A68363F12B4BB7D66DF5FD6B5DF07
          49AA699E213AADE25F5CCA2CA3BFB796DE44B88A210E2E9D122531B24836325D
          F8D7FB1A6B9E1EFD80FC2DF09FE1FDFDD5F6B1E1DD73C2F345AADC25B2CC45A6
          BF617B777EF1B6C85995629E7318C6E236282480451D12EB749F6D5EAFF5D5AB
          79853D6694B6FC6DA5AFDBF13B7B2FDBF3E1CEAFF0F6F3C4D631FC44D42D74BD
          59744BFD36D3E1CF88AE35CD36E9A113AADCE949626FE0468591C492C0B19592
          3218EF5C97BFF0500F8556DA3F81AF23D7758BFF00F8590D731F87AD34FF000D
          6A97DA85E496D2247751BDA436CF3C125BBBE2649A3468764BE6041149B7C7FE
          29FF00C1307C49F1BBC317D75E31F1D7807C57E30D6BC550788F55B6D67E1F35
          E782B528EDF4E7D3EDECE6D15B51F3658E34613AB4B7CE45CAAC98DAA91A76DF
          B287FC13E13F65ED2BE18DA45E24D3EFA3F87167E24B51158787E3D26D6EBFB5
          EFE2BCFDCC114863B68E0F2FCB58D0302A46366DC17A75FE95BFCF4FF30EAADE
          77F2EDF814FE19FF00C155FE1EF8D3C27AC6A9AA68FF00117459B4DF15DF7856
          D2C23F01788AFAF75696DE5B950F6D6F1E9FE74E7CAB59259561493ECDF76565
          38CFD1BE13F145AF8DBC2DA6EB1651EA10D9EA96D1DDC11DF584FA7DD223A865
          12DBCE893432007E68E54575390CA0822BE5CF88BFF04F4F1878AFC1FE22F0DD
          A78B3E12DF683A8F8BEEBC5FA38F137C3ABED4EFFC3D737325C4D24B05D5B6B5
          68F15E4735C3182F2DC412C0A3032E7CD1EB5FB397827C7DF0A45878375DD59B
          C49E15F09F8634CD3EDFC47A9C8F36B5E23D4D7CD1773CAC65722111ADB85F37
          74CEEF29677DA1DE63771D77D3F2D6FF003265A49B5B6BF75F4B7C88F4AFDB93
          E1C6BBE36D7BC3B63A8788AF352F0EDBDF5C4BE4F853567B7D47EC4DB6EE3D3E
          716DE4EA5342FF0023C364F34AAE0AECDC0815345FF82827C2DD5FC07E29F114
          BAAF88F47B5F059B61AB58EB9E10D6346D621374FE5DAF97A75DDAC5793FDA25
          CC50F930BF9D2868E3DEE0A8F0EF057FC11C349F87D71F12AD745BAF85DA1DA7
          8E2C75CB5B1F12695F0E52CFC7FA53EA92C92B9975D5BCCDCC7199A440BF668E
          468D62532EE42ED4FE1C7FC11B9FE1EF857C70BA77893E18F8475DF12DF786F5
          7D297C0FF0CA3F0E683A3DF6877925DDBCB2E9EB7B2BDD095DD566DD72AECAA4
          2C89F26C2177F1765F7B7AFDC8A9E8F4D757F75B4FBDFF00C31E89F133FE0A6D
          E1AF873F14FE1B2DE5AF8AECFC19E3AD03C457FE55CF8075F4F124977A75C699
          1A245A5FD945EF97E55D5DCAE4DA9F92159032C6ACCDD77ED47FB65E93F07FF6
          49D33E2E787756D0752F0BEA5A9F86DD355977CF632695A96AB636D2DD218D94
          9C5ADCBC8841237052558654E97857F67BF16DF7C5AF03F8E7C6FE2EF0EEB7E2
          4F0A787F5CD06E4687E1C9B49B1BE5D46EB4E992548A6BDBA788C4BA7842A659
          3CC32960630BB4E4E9BFB139D3FF0062AF86FF0007C789431F87A7C2C7FB5BFB
          3F1F6FFEC4BEB1BBFF0051E6FEEFCFFB16CFF58DE5F999F9F6E0D452E58EBADD
          7DDCCEFF00858D23CB757F997B4AFDBFBE1BEB9F0C6EFC59A77FC27FAB58E9DA
          C1D02FF4FD3FE1EF882EF5CD32F44426F2AEB4B8EC9AFEDBF74C8E1E68110ACB
          110D8910B69786BF6DFF0085BE2DD1A2BEB2F14A8B79BC3B79E2ACDD585D5AB4
          5A7D9CDE45E3C8B2C4AD1CB6F37EEE681C09A26F95E353C5794FED23FF0004D2
          93E3A5EF8AAE17C45E13BA8FC4DE3AB6F1A3E8BE2CF089F117872E845A15B690
          2D2FAC05DDBFDB154DB8BA8D8CB188E6111D8E6304F3F63FF0485B3B2FD9CBE1
          9F8061F195958C9E05D53533A85E69DE1A8AC6D75AD1353BC7B9D47454B38E61
          1DADBCD9850142C2316E9843D28D1FE1E7BAD7EE7F3B19CF46ADAF57FE5F77E2
          7AF6B9FB78F81FC09A5F8BB5FF00146ADA7E83E0DF0BC3A1CE750922D43ED883
          552A96FF006AB57B3436E5A59235015E561B98CA20DA45361FF828CFC29BAF87
          9FF09243A9F8AEE215D6DBC38FA4C3E0AD6E4F10C3A8AC1F696B67D216D0EA2A
          E2DC79E775B81E491267610C63F8A9FB150F899E29F176A43C49F611E2AD73C2
          5AC88C69DE67D97FB0B5182F7CACF9A3779FE4ECDD85F2F7670F8DA7E7EFF828
          9FEC4BF12B55D4A7D7BE1CD9EB5E2AB8F127C445F17DEC5A2DC3E9DA9684A9E1
          B87474589E3D774596556303333A6A3090270A609D41659E6B464DF7D3EF8FFC
          1FB8AA714E2B99EB677ECF4D0FB23E047C74F0D7ED2DF08B41F1DF836EEF350F
          0C7896DFED7A6DD5D69B75A7C9730924093C9B98E39955B1952C837290C32A41
          3D88E95E5DFB18F84B5EF027ECADE04D17C49E1CD13C21AC693A3C367368BA44
          7E5D9E9AB18DB1C4A827B808C2309BD16E2E155F7AACF300257F5118C5695231
          526A3B5F433849B8EBB8EA28CD19A92828A28A0028A28A0028A28A0028A28A00
          28A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A00
          28A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A00
          283CD14500341DA6BE5BFDB7BF68EF1A7C25B9F88F0782E791B5AD0FE156A7E2
          6D3A1BCBCB7834D86E609828B823EC53CE66452CCA0B985F68468816F357EA40
          6B8DF197C07F097C41D7B52D4B58D1E3BFBCD5F429FC357864964D971A7CCDBA
          5B7640C130C7F8B1BBB671C56338C9DADE7F93B7E362A3A6FDD7DD757FC2E7CE
          E9FB7BFC44F03FC4AF871E0FF19F81FE1CF86A4F1569FA74B79AFEAFE37D42CF
          49BCBABBB9922163A55D1D17ECD7BA87971ACA2CA596D26732623478D1A61E9D
          FB41FED1DE33F04FC55F0EF807E1BF81F41F1A78BB5AD2AF75D986BDE257F0FE
          9B65656B25BC4DFBF8ACEF2579DE5BA895231004DA24669136AABD75FF008276
          7C33925D03ED8DF12358B3F0D1B7367A76ADF12FC4BA969B29B79BCF84DCD9DC
          5FBDBDD14936B03711C87E441D1140EA3E3E7EC97E07FDA56F349BAF1459EBD1
          EA5A1A4F158EA7A0F88F52F0EEA50C53851341F6BD3EE209CC126C8CBC2CE636
          68A362A59148D67ABBC7BB7F2E8BE4634E2D2B3EC97CFAB3C12F7FE0ADF6E3E1
          A5CF882D3E1D6B525D1D0F45F10D8699717EB1DC5F5B5DCD789A801B23907996
          11E9F792304DEB2848B6B28955AB575EFF00828778DBC4BF16E2F087C35F84FA
          4F8BAEB50BBF1241617FAAF8C7FB1EC278743934DB7B999DD2CEE1D435D5ECF6
          CAA8921125AA96DA923BC3EBC7F62BF85DFDA9E07BB5F06E970BFC38D26EB42F
          0E4709922B7D32C6E6148268042AC237531205064562A0BED2BBDB36BE19FEC9
          DE01F83ABE135F0EE84F63FF00083E937BA268CEFA85D5C496D6B7B3413DDABB
          4B2334CF2CB6D03B4B297937293B86E7DCF4BB6FCFC96BB79E965EB77D91A2B2
          B7E3D6FA7F9FE4717E24FDB81E1FD837C37F1BBC3FE0FBCD624F1669DA1DFE9D
          E1DB8D422B3B863AA4F6B0C70BCF878D590DD0C9E5495EA01C8F37F89DFF0005
          38F17FC2BF8F9A3FC39B8F83DA8F8935EB3B4D2EE7C607C2FF00DBFAE5BE8DF6
          F9E48E35B49EDF446827D91C4F2B9BD974F1B7852E436DFA22D3F669F05D8FC1
          0D0FE1CC3A2ECF05F8661D3A0D374EFB5CE7ECC9612432DA0F377F9ADE5BC111
          CB392DB30DB8120D0F883FB25782BE26FC5BD3FC757D0F8A2C3C53A747041F6C
          D13C55AAE86B7F0C12BCB0C3791595CC315EC51BC92958EE56540269401891C3
          13B39DD2F76F7F95B45F785972B5D6DA3F3BA3C26F7FE0A7BAE68127C6A9B5AF
          03784F456F84FA06BFAFD9787EFF00C5B7967E2ED7EDF4C66097434DB8D2E38C
          69F71B0EDBEB5B9BB80332A02EE1D63D3F12FF00C1427C6DF0E2E358D13C55F0
          A74AB2F1A5C43A34FE15D374EF187DB6CF561AAEA0DA7DBC77B74F6711B29229
          82B4E238AE91636CC4F70C365745F16BFE09A5E07F883E08F8896B677DE2E8FC
          49E3DF0CEAFE1A8B57F10F8AB58F13C5A147A944639DED2D2FEF2486DC13B094
          B710EE58D53217006C689FF04E2F843A47833C49A249E1DD435287C591DA45A8
          5D6A1E20D4AF6FA14B4732DA47677535C3CF631DB4A4CB6F1DA49125BC877C41
          1B9A23B46FF3F3FEB4FF0022A56B7BBBDDFC9696FD7FCCF3DD67FE0A1DF10B40
          D6ACFC1737C21D167F8AB378D20F07CBA55BF8D59B415171A35DEAD05F26A4F6
          092BC222B52B2A1B4599087291CB88C4D8FE34FF0082A4F8A3C39F0D3C23AE49
          F0E7C27E1F1AA5FEBDA4789756F16F8CAEF4AF09F85AF749D44E9D2C326B16FA
          55D468B3CE921B792F23B35942AA83E73086BDD3E1E7EC45F0D7E158D25F4BD0
          F5296FB47D79FC5116A5AA6BDA86ADA95C6A4D652D81B9B9BBBA9E5B8BA61693
          490A89E4915136050BB136E778EBFE09F5F0CBE22E84DA4DFDAF8DAD3479AEF5
          2BDBAD3749F1DEBDA4D8EA326A3752DDDEFDAADED2F228AE5659A69494995D02
          C8C8A021DB4DB574D7F5F9FF005F703B5977FF0082FF00E07E3EA79D691FF053
          0BEF12FEDAF77F0BF47F863E26D63C2FA5EB6BE1BD4FC5565A76B53C7657C6CD
          2E5A42E9A59D345AA19638DA493524983313E415DA5B8FFDAF7E3678EFE13FED
          ADE23F15CFA58D5BE1FF00C1BF8557FE35834EB5F881A8E8E6FEE156E8B19EC2
          0B536F7658DBAC2A2E649121526645F33E4AFA3F4DFD8E7C07A07C673E3ED2AC
          FC45A1EB8ED1BDC5B695E28D534FD1AF9D2DD6D924B8D2E0B94B0B8916048E30
          F2C0EDB618867F769B77FC5DF00BC1FE3ED7B5AD435CD06D756B8F11E82DE19D
          516E99E482FB4D66919AD9E227CB2AC6593276E486209C60564EE9C24BA5EFD2
          FEEB5F9BB931B5DA96DA7E0D37F868790FED1FFB7C5F7C0ED7BC55A5E97E0393
          C51A9787B4EF085E5ADB47AC259B6A72F8835BB8D25200CF1948CC2D00937B36
          1F7ED3E581BCF3F0FF00C1423C6E59FC2327C31F0EC7F18BFE1393E078B44FF8
          4CA53E1D9645D1935B6BBFED4FECFF003C422C5C706C3CCF3FF77B766661DF78
          0BFE09C9F087E1BD9DFC761A0EB5752EA6DA335DDD6ADE29D5B58BC9FF00B1EF
          5AFB4D56B8BBBA965DB6F70C59577EDDB8420C6020D9F897FB10FC35F8B87569
          358D17528EFB59D7A1F144FA8699AF6A3A4EA306A5158C5A7A5CDBDDDACF14F6
          CDF64852122078D5D37860DBDF76DEE2BEEFF4F87FFB6FC3E42B5ACFFAD12D7E
          777FD58F21D5BF68DF8DFA5FED41E31D075AD07C19A5F84745F86369E21BB1A4
          F8A9EEAF34ABE93FB443C96BE7690AB704CB02C43CE64409124BE59677843354
          FDBF3C73A378363B8F0A7C3BB3F1E5AF82FC03A5F8D3C637FACF8B23D26F8C17
          70CD22C5651C360F0DE5D98ED2E1D849F618371882B2876117B34DFB1BF80EE3
          C41A4EA935BF8A2E350D1F416F0C89E6F166AD2B6A1A7B2C8BE55F6EB93F6F65
          F3646592EFCD911E467565625AB13E24FF00C13AFE117C597D2FFB67C3BAA797
          A5E8F0F879A1D3FC4BAA69906ADA643FEAAC7508ADAE634D46D972E04578264C
          4B28C62590365AA4FF0007DB5974EBBC7EEFBD5AF34FA5B6FF00C057E92FBFEE
          F38BFF00F8294F891BE22EAEFA5FC2DB7BEF86BE1FF15F873C2B7FE229FC4DF6
          6D49A4D72DF4B92D65834E36A7788A4D56059D659E22A9868CCCDBA24EA7F6F3
          FDB7B5CFD9187872DFC37E11D27C75AB6BB0DEDD3E906EB5C3A9082D843BA686
          DB49D1B5495E20D2AABCB2AC3146D242A5C99001E97A97ECB7E03D52DF5C866F
          0FA795E26D7B4CF136A289753C6B3EA1A70B2165300AE0208869D67FBB4DB1B7
          93F32B6E7DD4BF681FD8F7C05FB4E5F69D75E2ED3F5A92F74BB6B8B18AE748F1
          16A5A1CF2DADC1433DA4D258DC42D3DB48628CB41317898A292A48AAA96B2E4E
          FD7B597EB7F95871B6EF7B5ADD2FDCF04F16FEDC971A65CCDF1834DB5D6AEBC3
          30FC05BAF88D07862E6F4DB2CEE9E5DD2472637C69318FF74640ADB727A8E0E3
          FED4BFB67FC50B1F873ACE87A978117C23E35D3F56F04EBBA2DBF873C626F0EB
          7617BE29B4B47B29E77B7B516D70E11A19A31E6C052E7026917781EE5F167F60
          BF05F8D7F67BF10781741B65F0BC9A97C3DBBF86FA65F8335E2E91A64D018913
          C9794094467637CCC1DB66378C9353782FFE09F5F0AFC09A66A16F6FE1FD42F6
          4D52EF4ABDB8B9D4B5FD4B51B856D32ED2F2C21865B8B892482D6DEE10491DA4
          4C96EA4B011E1D81718C549764EFE76E66D7CED65AE9D3CC51F755F77D7E4A2B
          F491E57E35FF008292F8C7C01F0CFC42755F873E16B5F88FE17F1AC7E0CBAF0E
          C3E24D5F54B5D524934C8B544974E934ED12EAFEEDBECB3C6ED19D3A3D823B86
          66091077F6EFD8E3F68FFF0086B5FD9DF41F1D36857BE19BAD4A4BBB5BBD2EE9
          66592CAE6D6EA5B59D313C304DB7CD85CAF9D0432ED2BBE289F722D6F895FB11
          FC38F8AF73AA5D6A9A4EB16BA8EAFAE47E259F52D23C47A968FA8C7A825847A7
          09A0BAB3B88A7B7CD9C490B2C2E88EBBB72B16627AAF81DF033C2DFB36FC33D3
          FC1DE0BD2DB47F0EE96F3C96D6A6EA6B968DA699E7958C933BC8C5A591D89663
          CB7A55271E5D56BA7E4AFF007B09EEB976EB7EFE47674514548C28A28A0028A2
          8A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A2
          8A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A2
          8A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A00319A
          28A2800A28A2800A28A2800A28A2800A28A2800A28A2800C5145140051451400
          5145140051451400514514005145140051451400514514005145140051451400
          514514005717F1DFE3C7867F66EF86975E2EF175D6A16BA1DA5DD95831B0D2AE
          F55BA9AE2F2EE1B3B5862B5B48A5B89A496E2E218D5238D89320E31923B4AF9B
          7FE0AAFE2CD2FC05FB2769FAF6BBA9E9FA3687A2FC4AF87D7FA86A17F7096F6B
          616F178D3447966965721238D115999D880A0124802803BFF86FFB607823E2A7
          85FC4FAA6947C611C9E0FB4FB7EA9A3EA5E0DD674BD7E2B7292B47347A55D5AC
          77F3C72F913A42F0C0E2792DE68E32F244E8BEA75F9DFF00B7A7ED0BA5FC77F0
          BFC4CF8ADF04FC71A7F8A344F857FB3B7C4AB0BAF187843594B8B5D1759BD4D1
          6EB4F860BEB77286F1534AB9999217692D82DBBCA221736C65CFFDB7FF0069ED
          63E1B7EDF3A2DAE83A97882D7C416FE3FF0005787CC1A8F8FB54B5922D2351D4
          74AB6BCB8B2F0B5AD9BE9D7DA3C897D7168758D4E54923D466B8822944B6BA7C
          4403F4828AFCDFF00FC6CBCBCFDBB3E1469F79F13BE207FC2C6D5BE3578D748F
          1A782D756BA934A8743B5D3FC587C3A6F2C70D0E9BBEC2DB4FB8B544FB30D493
          7DE3C77B25BADCC1C7E8BE3AD43C1DFF0004DDFD96EFBC55E32F89FE35D7BE26
          F82ECFC517FA87887E2C6B7E0FB5D6B54934BD2C43611EA1A35ACFA95CEA8D1C
          863B1D22D23C5F88F52B99D6EAFA3134801FAA1457E4FDCFC6CF88FF00173F65
          9F187C5ED53E277C40B5F137817F642F05FC55D3ED34AD59B4CD2E7F154D69E2
          7BB3AA5C5ADB848E6FDE59C61ED1BFD0A74216E2DA710DBF93F677ECC1A66ABF
          0ABF6CEF8A5F0E5FC59E30F16689A7F82FC29E2B33F88F547D46EA5D5B51BEF1
          1DBDFDCAB3612DA39934CB322CED521B380A37916F0891C3007D255C67C38F8E
          DE19F8B7E2BF13693E1DBAD435297C2377F60D42F0695771E98F701E58E586DA
          F5E216B772412C32C33A5B4B21B79A368A611C83657C65F1BFE2FDE697FB6478
          B2D64F1E78834FF8B9A7FC54F07691F0FF00C1D1F8A2EADBFB67C1772BE1EFED
          ABB8B405996DB52B745B9F131935092D667B7FB2CE44D1FD823307AF7FC1247E
          1A69DF0BFF0065EF1358E9B71E20BA864F8A9F1032DABEBB7DAC4C3C9F16EAD6
          A9896EE6964198EDE367C37EF2569667DD34D2C8E01F51515F9BFF0000FE365E
          5E7EC0FE34F127C3DF89DF103C5DFB5447F05AFB5BF1878521D5AEBC55FD85E3
          45D3A390453E9738B88745D423D49AE22874A852D126FF004A8FEC932D928B5C
          FF00187C4D8350F0DFC42D1FE037C69F186B1F0B64F107C25B2D2FC63A3F8EE7
          F1949A66B7A978D9ACB5AB7B7D56FE5BDDD20D3C69264B095E4B748EE519EDF6
          DE49E7007E98515F9DDE39F1DC9F0C6FBC49E03F12FC41F18787BE077837E3A4
          3E18F106BDA9F8DF51B4BAD0BC3F37802DF5A892EBC4725C0BF8237F10DDDAAA
          CD25E2BB1B986CC398245B739FFB647C678BC35E1CF81D0E8BF113FB4BE06EA9
          A5789E5FF84A3C73F18757F86567A85E417DA6C7A3A0F12D95B1BBBEFF004397
          5316A923BAEA56B0B5EBCD78F025CB807E90D65E8DE2CD2FC49A86AD67A7EA5A
          7DF5DE8376B63A9C16F7092C9A75C34115C2C332A926390C13C12846C131CD1B
          636BA93F967F1F3E3B78DBC3075D8FC69F17FE2058FC5CD27F66BF086BFE0DD2
          F4D92FFC3FA5F8ABE2249FF09208CAD935BDB19B50B9BAB78522D16E238FEDC8
          244974FB8FB12ADAFA05EDFE9DF063C77FB62DF7867C5DE20B1D7747F8FF00F0
          EF5DF14AB78BAFAE5B43F0F491F842EAFEF278A5B86167A79B53ACACB2ED8E1F
          B1D9C90B1FB3592470807E905739A97C51D0B49F8A5A37826E2FBCBF1378834A
          BFD6F4FB3F2643F68B3B19ACA1BA97CC0BE5AEC9350B35DACC19BCECA860AE57
          E01F1F7ED91A17C4EF87FF001D3C43A4FC49FF00849FE1CDC7C6AB0D134DD7F4
          FF008A327867C21A759AF82B45B978AF7C4964B3CDA569FF006F1300D6251A6D
          4A7B7B673E5DDDC2BE87FC138FE2D7887E367C68FD9FB5CF1436A1FDA90F82BE
          30E8E90DF4D7B3DD59DAD878E3C3D61696D2CD7D0417B3490DB5B43134D7B0C7
          75298CBDC2899A4A00FD11A2BF3FBFE0A23ACF8A74BF8A5FB5078A34BF881F10
          341FF852BF00749F1DF86748D2B5C9ACB4A8B5E49BC5F2C57F7104647DA76FD8
          2147B694B5A5CA605CC171E55B9857E39EB3E2AFD9D7C4FF0018BC0F61F103E2
          06A1E19B1D2BE19F88BC43ACEAFAE4D35FD8DAEB1E2BD4EC3C53A90BB054E976
          E748B0695FEC5F65B5D3D61967B64B3219C007E805739F0D3E28685F17FC3B73
          AB7876FBFB474FB3D5752D12597C9921D979A7DF4F617916245527CBBAB69E3D
          C06D6D9B94B29563F01FFC2E5D3BFE101FB3FF00C2D3F107FC32DFFC2EAFEC7F
          F84F3FE13FBEFB37FC22FF00F0857DB77FFC257F69FB5FD9FF00E12CFF0046FB
          4FDBB3E7FF00C4BFCCF2FF00D16BC8346F8CF79E1AFD9D7E13AAFC44F0FEADF0
          8F5EF157C5BBEBEF187887E305D7C2FD2BC43A9278DE4FECBB93AFE896D892E2
          E2D67D5668EC6158ADAE104F3AA7FA1C41003F56F4DF8A3A16ADF14B59F04DBD
          F799E26F0FE9561ADEA167E4C83ECF677D35EC36B2F9857CB6DF269F78BB558B
          2F93960A190B6768BF1DBC35E24F8C9AB780F4FBAD42FBC45A0DA2DD6A66DF4A
          BB974FD38B08996DA6BF588DA4778639E0985A34C2E0C33473795E53AB9F9CBF
          60BBCF156A5FB536B171E39D4BFB63C6D71F007E17C9E21BFF00ECD9B4DFB76A
          26EFC5A6E66FB2CD05BCB6FBE6DEDE549042F1E76B451905078878A747D17E0D
          FED05F1C2EB58F1978C3C1BF0D7C55FB44D9D97C46D727F1E6ABA5DAE95A5FFC
          2B7B4D42D89D47ED48DA546FAD4DA7C224B796DCC81ACEC4B35B886D8007E985
          15F9FF00FB346B3E2AF8D3F1E7F67FD3750F881F103FE10F874AF89FACD84769
          AE4CB0F8CB47D2FC63A25BF8667BAB9C99AFADCE9B2DACD1DD79A64BD8A42659
          AE20BCBA4B9F6EF8F7A6EA9E34FF008291FC0DF0F2F8B3C61A1F86E1F0578B7C
          49A9691A3EA8F656BAFDC58EA9E1516897613E768E37B977C2321706485D9EDE
          7B982600F7EF15F896DFC15E16D4B58BD8F509AD34AB596F278EC2C27BFBA748
          D0BB08ADE0479A6908042C712348E70AAACC403A95F8E1A8FED97E2D3E16F8E9
          0F85FC4DE30D363BCFD9DBC7FE2EBEBBBCF88FAB78835FD3FC41609A60B617F0
          496905878675CB3FB7DC1B9D2B479765B4975189238E38AC59BE8EF895AD78AB
          43F8EBF1A3C790FC40F881F6AF06FC7FF00783740D17FB7265D0B4BD3F55B7F0
          55B6A91FD89488AE3ED30EA97436DC8992DE43E7DB2DBDC3CD34A01F677C38F8
          EDE19F8B7E2BF13693E1DBAD435297C2377F60D42F0695771E98F701E58E586D
          AF5E216B772412C32C33A5B4B21B79A368A611C836567F8E7F6A1F02FC36F196
          A1E1FD6B5CFB16ADA57FC23DF6A83EC5712795FDBDAA4BA5693F324654F9F7D0
          4B1704F97B77C9E5A10E7F38F497D27F67AFD97B49F0FDB5F7C40B8B3D6BE2AF
          C509608B54F8C3E25F0CD86A77969E2EBCB3B6B24D52C23BDD62EF589A2526D3
          49B6057506FED4B99239EEE34763C39F14B5EF8E1E08F07F8D7C537DFDA9E26F
          187803F65FD6F57BCF26383ED77973E3CBE9A797CB8D5634DD23B36D455519C0
          00605007EAFD15C5FC47D6FC7DA5F8AFC310F847C33E0FD7345BBBBD9E22BBD5
          FC4B73A55D6976FBE21E65A411585CA5E49B0CC7CB925B6198E31BF0E5A3F21F
          F828069BAAF8BBC7BFB3A7852C7C5BE30F08E9BE30F89571A66B92F86F547D36
          EB52B04F0A788EEA4B36993E758E47B68F2F1959A22AB2C32433C714D1807D25
          457E7FFC35FDAC3FE2FB7C15F85BA87C4AFF008B99FF000BFF00E207F6FF0084
          6E3C43FF0013EFF847BECFE36BAD2FED564D279FFD9FF67FEC89ADFCC4F27CBF
          B0BC7F2F926BCBFE0AFC40F8B9F0B7F631F86BAE783FC79F13FC75F12BE287EC
          97E23F1FBBEB17D2788AEAFF00C4BA7D8F86FF00B21AD2CE457852488EA97116
          C8210D7A5A37BBFB5DC0F38807E96FC52F8A3A17C17F02DF7893C497DFD9FA4E
          9FE5ABBAC125C4D3CB2C8B1436F04312B4B3DC4D33C71450448F2CD2CB1C71A3
          BBAA9E7FE05FED37E11FDA3C6A8DE119BC41750E8C625B9B8BDF0DEA5A5DB79A
          FBC3DBA4B750451CB7104914B0DCC11B34B693C6F0DC2433298C7E79FC6FD3FC
          0FF1C7C33E28F0EFC3DF895E30F885F0474BF1AFC1FBAD3B5AD2FE29EB3AFC71
          7882F3C6B259EAD6C9AD0BE96E0C91D81D265FB27DA4A5AC925ADD471433C893
          B7D5BFF0491F869A77C2FF00D97BC4D63A6DC7882EA193E2A7C40CB6AFAEDF6B
          130F27C5BAB5AA625BB9A590663B78D9F0DFBC95A599F74D34B23807D455CE69
          BF14742D5BE296B3E09B7BEF33C4DE1FD2AC35BD42CFC9907D9ECEFA6BD86D65
          F30AF96DBE4D3EF176AB165F272C143216FCB283E2178B7C07FB187EC85A978C
          3E246A1AAF85FE257C3693C55E2DF127C44F8DFAB7C37B5B8D7DEC7C3C34EB71
          AEE9F03CAB20B4935211E9E3625D886EAF27371750C970FEA0BF107C55E0FB6F
          889AE78F358F105FF8C24F801F0913C53ABE90F37855A5BA9F58F13457F77733
          CB691DCE8DA7EE92692F2E96D61BAD3ECFED33471C33C081003F43359F16697E
          1BD4349B3D4352D3EC6EF5EBB6B1D320B8B848A4D46E16096E1A185588324820
          82794A2E488E191B1B51883C33E24B7F16E9F25D5AC7A8431C5777366CB7B633
          D9485E09E481C849911DA32F1B1490031CB194923678DD1DBF293E08FC4BB2F8
          C3F123E09EA1E34F146A1A7E83E02FDA7A5F0C784A48BE276BDAAE9F25BDDFC3
          C9350B544D56FC5A5CEB11DDEA53AB5BCD751C82686FCDB5B3CD6370AB37A743
          F1974ED524F07DBFC6CF8A9E20F04FC23BAF157C5E8EF75FBAF1F5F784213AC5
          878E7EC9A25836AF05CDB4C3669ADAAAC363E788DE2B5661137D8D1A200FD21A
          2BF2BFC6DE3EF8B9AF7C04F889F10BC61E3CF8A1E1BF883F0AFF0064CF08FC47
          FEC482F64D0ED6DFC646DBC537135F5ED844B1869127B25496C641F63980D973
          6D37936E21F60F8DFF0015E4F057FC14AACB4FBDF1D6A1AA6AB7DAFE896FA2F8
          774AF1EEA3A2F88B4CB09D2D219A2B6F09C96EDA6F8834BF31AF2EAF35867F3A
          D6DE6D4523749B4788A807DE1451450014514500145145001451450014514500
          1451450014514500145145001451450014514500145145001451450014514500
          1451450078ED9FEC7F67FF000BD74DF19EA9E38F881E22D3FC3BAADDEBFE1EF0
          C6AB796B71A5787753BAB7B9B69AEEDE6FB38D41F30DF5FC6905C5DCD6D0A5D9
          48A18D61B6583D8A8A2800A28A2800A28A2800A28A2800A28A28038BD17E0A69
          7A1FC7CF137C4686E3506D6FC55E1FD27C377703BA1B58EDF4DB9D4EE2078D42
          871233EAB701C9720848B0AA4316ED28A2800A28A2800A28A2800A28A2800A28
          A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28
          A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28
          A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28
          A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28
          A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28
          A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28
          A2800A28A2803FFFD9}
      end
      object RefMemo: TMemo
        Left = 168
        Top = 456
        Width = 281
        Height = 49
        Color = clMoneyGreen
        Lines.Strings = (
          '  For the equations used see web page:'
          '  https://www.waterlog.info/pdf/reservoir.pdf ')
        TabOrder = 0
      end
    end
    object InputTabSheet: TTabSheet
      Caption = '  Input  '
      ImageIndex = 1
      ParentShowHint = False
      ShowHint = False
      OnShow = InputTabSheetShow
      object TimeLabel: TLabel
        Left = 86
        Top = 185
        Width = 29
        Height = 16
        Hint = 'Give time in units (hr, day), not dates'
        Caption = 'Time'
        ParentShowHint = False
        ShowHint = True
      end
      object RainLabel: TLabel
        Left = 152
        Top = 185
        Width = 25
        Height = 16
        Hint = 'Use mm per time unit'
        Caption = 'Rain'
        ParentShowHint = False
        ShowHint = True
      end
      object FileNameLabel: TLabel
        Left = 24
        Top = 22
        Width = 20
        Height = 16
        Caption = 'File'
      end
      object Title1Label: TLabel
        Left = 24
        Top = 46
        Width = 32
        Height = 16
        Caption = 'Title1'
      end
      object Title2Label: TLabel
        Left = 24
        Top = 70
        Width = 32
        Height = 16
        Caption = 'Title2'
      end
      object OptionLabel: TLabel
        Left = 24
        Top = 93
        Width = 43
        Height = 16
        Caption = 'Options'
      end
      object NrOfDataLabel: TLabel
        Left = 24
        Top = 123
        Width = 36
        Height = 32
        Caption = 'Nr. of Data'
        WordWrap = True
      end
      object RunoffLabel: TLabel
        Left = 280
        Top = 185
        Width = 37
        Height = 16
        Hint = 'Use mm per time unit'
        Caption = 'Runoff'
        ParentShowHint = False
        ShowHint = True
      end
      object InputImage: TImage
        Left = 504
        Top = 284
        Width = 137
        Height = 161
        Picture.Data = {
          0A544A504547496D616765D70F0000FFD8FFE000104A46494600010101006000
          600000FFE1002245786966000049492A00080000000100005104000100000000
          00000000000000FFDB004300080606070605080707070909080A0C140D0C0B0B
          0C1912130F141D1A1F1E1D1A1C1C20242E2720222C231C1C2837292C30313434
          341F27393D38323C2E333432FFDB0043010909090C0B0C180D0D1832211C2132
          3232323232323232323232323232323232323232323232323232323232323232
          3232323232323232323232323232323232FFC000110800A80089030122000211
          01031101FFC4001F000001050101010101010000000000000000010203040506
          0708090A0BFFC400B5100002010303020403050504040000017D010203000411
          05122131410613516107227114328191A1082342B1C11552D1F0243362728209
          0A161718191A25262728292A3435363738393A434445464748494A5354555657
          58595A636465666768696A737475767778797A838485868788898A9293949596
          9798999AA2A3A4A5A6A7A8A9AAB2B3B4B5B6B7B8B9BAC2C3C4C5C6C7C8C9CAD2
          D3D4D5D6D7D8D9DAE1E2E3E4E5E6E7E8E9EAF1F2F3F4F5F6F7F8F9FAFFC4001F
          0100030101010101010101010000000000000102030405060708090A0BFFC400
          B511000201020404030407050404000102770001020311040521310612415107
          61711322328108144291A1B1C109233352F0156272D10A162434E125F1171819
          1A262728292A35363738393A434445464748494A535455565758595A63646566
          6768696A737475767778797A82838485868788898A92939495969798999AA2A3
          A4A5A6A7A8A9AAB2B3B4B5B6B7B8B9BAC2C3C4C5C6C7C8C9CAD2D3D4D5D6D7D8
          D9DAE2E3E4E5E6E7E8E9EAF2F3F4F5F6F7F8F9FAFFDA000C0301000211031100
          3F00F7EA28A290051451400514D500A8C814EA0028A303D28C0F4A0028A4C0F4
          A5A0028A28A0028A28A0028A28A0028A28A0028A28A00E7F56D6352B5D66C74C
          D374FB5BA9EEADE7B866B9BB68151626897036C6E492661D874351D96B1AC7FC
          2410695AA697656DF68B69AE6396D6F9E6FF0056F129521A14C67CD07209E86A
          4BCFF9285A37FD82AFFF00F46DA5179FF250F46FFB055FFF00E8DB4A6337D461
          714B5C3F8BAD6D6EBC63A14779E1DFEDF8C69F7CC2DBCB81F61F32D7E7C4CCAB
          C723839F9BEB506937EFA6F8667BED322834AB4BFD43FD06CA5B5699ED1044AA
          F18B580E4C9E6452B346AC36EE776C1565A423BFA2BCF26F1A5CB693FDAC9656
          86EE0D1F5899649ADDD1B7DACD1C7F758878D1C8DCD19E46141395C9E9F48D4B
          529359BED2F545B4F3E0B782ED5AD43054595A55F2CEE3972A613F3E1776E1F2
          2E3900DCA2B90BAF11EB10EA1AB6D8EC459596AB65A7C79573249E79B5DC4F20
          0DA277C1E724AF0361DE5EF88F58FED6934EB08EC44875A1A6A3CEAF858CD80B
          92E403F3306CF1C06036E549DE003AFA2B8C9BC4BACBE936B34314711FB45D5B
          5CDDC7A74F7ABE641318801044C1D449B5DF7162136ED258B035B77FAE7D87C1
          D73AFF009705C791A7B5EECB79F7C726D8CBE124DBCA9C70DB791CE3B5006C51
          5E79E27BCD765B3BAD0AE2F34D79D6E34C79274B2758A586E2E8C462688CA491
          98FE6F9B0E8C5303EF56A7C3CD3BEC7A35E4D2C7626E9F50BA81A5B5B5F2498E
          19E48E343F3312AA148419C2A6D51F772403AFA28A2800A28A2800A28AF39D26
          DE25F8C3ABDC88A313BA5CA348146E655834D2A09EA402CC40EDB8FAD00755AA
          E86751D46D6F61D56F2C2E6DA296157B5109DC92142C0896371D625E98EF51D8
          F87E4B5D623D4AEB5AD47509A2B792DE35B95815516468D988F2A2424E624EA4
          F7AF8EE28D3CB076AF41D87A53BCA8F1CA2FE42BEAA1C2D5A74D545516AAFB33
          175D2E87DB0D676CFA8C37CD193750C52431C993F2A3B21618E872634E71DBEB
          5527D074BB9B796068248D24B83740C33C91347291F33C6CAC0C65B2D9DA4677
          B939DED9F31B8B7866D27E1B492C51BBC3A7D9BC6CCA0946FB5E9AB95F43B598
          64762477AF63AF976ACEC6C612F84B404B03611E9A91DA7D9EE6D4431B322AC5
          70C1E6400118048078FBB8C2E0569A5A5B47A8CD7EB191753C51C323E4FCC885
          CA8C74E0C8FDB3CF3D055AA2A40CD9747D3A68AFE392D895BE9567B83BD81322
          AA2ABA9CE559446982B820A8239E6A0B1F0D69160C8F0C33B489766F04971752
          CCE6631793B8B3B127F7676E09207D456CD14018D3786B48B8812210CF0EC966
          9964B6BA9609434AE64906F460FB59CE4AE76E42F1F28C687D8ACBFB3FFB3FEC
          B07D8BCAF23ECDE58F2FCBC6DD9B7A6DC718E98AB3450063C1E18D26081E2F26
          79B7CB0CCD25CDD4B3C85A2712463CC762DB55C6E0B9DB92DC7CC73A167656FA
          7C0D0DAC7E5C6D2C9311B89CBC8ED239E7D5998FB678E2AC5140051451400514
          51400579F697FF00256F53FF00B7BFFD27D2ABD06BCFB4BFF92B7A9FD2EFFF00
          49F4AA680F97A2FF0052BF41FCA9D4D8BFD4AFD07F2A757EC787FF00758FA7E8
          79F2DCFA0A4FF9037C3AFF00B05D9FFE96E975EBD5E4327FC81BE1D7FD82ECFF
          00F4B74BAF5EAFC7A7F133D00A28A2A0028A28A0028A28A0028A28A0028A28A0
          028A28A002B3E3D2B4E875297528B4FB48EFE64D92DDAC2A2575E3867C648F95
          7827B0F4AD0A2803E6E5F807E2E5500DF6887031C4F37FF1AA5FF8509E2EFF00
          9FDD13FF000226FF00E355EADE20D4F5483C4EEB6BAA4F6F6B6DFD959B648A22
          92FDA2F1E29371642DF714636B0C75A3C41A9EAB0F89DD6D7549EDED6D8E959B
          648E2292FDA2F1E29371642DF714636B0C75AF6239F63E31508CF45E4BFC88F6
          50EC6BE93E18B38340F0FDA6AB6567777BA4DAC31C7334424F2A444505A36619
          5E501C8C1E057474515E43772C28A290F438EB480812F6DE4D426B05933750C5
          1CD226D3C23970A73D3931BFE5EE2A9A7887489346BBD5E3BD8DEC2CD1DE7950
          1608A8BBC9C01920AE18103E656565C8604E3F8CA5BED31AC35DD32049AF2249
          AC56398FC84CEA3CA04641CB5C476C99CE00762703E65C88B406D235BB1F0B5A
          2C8FA5CEF677C669194CB8B44546208C0C0682C011B727CE931D3E400F43A2BC
          E344D4353B8F1C79535EC0B70350BB4B9B73A94D24C6D54CA21CD9ECF2E15C08
          184B91B86DE49970DB1E39B816DF6069F5282D6D4F981A2B9D4E6D36391FE5DA
          7ED31824301B8088FDF0CCDFF2CE803AB13C2D70F6EB2C667445778C30DCAAC4
          8524750095600F7DA7D29F815E7B653C31789358BFF37591A84DE18B3B95B766
          06F1B067DC56DCFEEFCD04463684DA1D8F037B6EA7A25F6A7A941E24B3D22E3C
          D6B4B4B5BCD3C5BEAF35EC735C0799B68B89954B46E6148DD54EC0038C862F80
          0F4EC0A5AC3F0B4F35FE972EAD2CB23A6A370F736E0B128B6FC2C2501E54344A
          92153CEE77E0670372800A28A2800A28A280380F137FC8CFA87FDCBFFF00A729
          693C4BFF00233EA1FF0072FF00FE9CA5A3C4BFF233EA1FF72FFF00E9CA5A3C4B
          FF00233EA1FF0072FF00FE9CA5A607A0504E05148C32A452030EE3C424CF245A
          769B7DA9794C5257B654545607040791955C82082149DA5486C1E29F67AEACB7
          296B796577A7DCC99F2A3B945C49804E15D1990B6037C9BB76149C639AC8D275
          8D3FC3DA545A56B579158DC5B663796ECF94B74727F7CAED85767E24600B1532
          618E7ACB75A959F88E7B0B6D1EE16ECC5771CF25EDBFCF1DBAA1DCC3CC1F2EE6
          03CB281B76D94920AE72CBB7969DCE9FED102CD1DB99A313488D2246586E6552
          03301DC02CB93DB70F5A96B94D4A2B44F8A3E1E9A6B89239E4D36F9214372EAB
          232BC0701376D63B59C91839DA09FB8A472FA7EADA91D1A49B48D42EEF35A3E1
          DB9B8D4A11335CB5BEA416231A1898B085F734E0441541DA46D3B000883D4EA3
          927861789259634799F644ACC0176DA5B0BEA76AB1C0EC09ED5E613EA8631E22
          5F0F6B3777FA7C56FA614926BE91E28E37B9956E0ADC10CC13606DD302C530D8
          61E58552D5A3B99FC33777BA9C6F689E2268EC9EDF579EE220AD66E4279EE13C
          F2660464EEC6F68B38DC9401E97677B6FA840D35AC9E646B2C9093B48C3C6ED1
          B8E7D19587BE38E28BDB796EECE4821BC9ECE46C627802174C10780EACBCF4E4
          1EBEBCD709A124D637BA65D457B767EDFE22D52D6585A53E50883DE49B563FBB
          9DF1AB6F20BF246EDBF2D60586AFACC9E16D6AE9F528D2F23F0EDD4D7E90EA93
          DCCF15E0452ACE8C816CDD4F9BFBB561CE4004479500F5AB0B2B7D334FB6B0B3
          8FCBB5B68961853713B51400A3279380075AB155ECAD7EC5671C06E27B865C96
          9A77DCEEC49249EC3249E000A3A00000058CD00145145001451450071BAE681A
          BDF788BED3689646C67FECEF39E6B874923FB35D3CEDB5046436E0C00CB2E0D1
          AE681ABDF788BED3689646CA7FECEF35E6B874923FB35D3CEDB5046436E0C00C
          B2E0D765453010D67FF6C597F6A7F677DA0FDABA6361D9BB1BB66FC6DDFB7E6D
          99DDB7E6C639ABE4D7092363C54CDD71E23FFDC5D26EC5C55CB9E23F885A1F87
          2E3ECB319AEAE5705E1B550C630C090589214741C673C838C73563C33E33D23C
          525A3B39258EE9577BDB4EBB5D5738C8C12AC3A72A4E3233826BE7DBABFB8D52
          F27D4AE5B37172E65639240DDC8009E7681C01D8015ABE11BFB8D2FC5FA55C5B
          360C9731DBC8B93B596460841C751821876CA8F4AE08E2DBAB66B43EB2AF0E42
          182F6AA4F9D2BF91EFB63E23B5D435492C22866565F37CA95C0D93F94E23976E
          09236390A7705CE72BB8735AB3C29736F2C0E64092214631C8C8C0118E19482A
          7DC10476AE1FC383FE2A3B2FFB8DFF00E97C75DDE6BBCF9292B3D0CCD2F451A6
          DC5C5D4D7F777F7970891BDCDD08C3796858A2011A22E017739C67E639240006
          A51450485145140051451400514514005145140051451400DF7AE0E4FF0091A5
          BFEC63FF00DC5D77A7D2B8A36574DE2D23ECF2853AB7DBBCC319D9E4FD87C8CE
          FF00BBBBCCE3667777C639A1AB9A53691E016DFF001EB17FB8BFC8569E85FF00
          23368D9FFA085B7FE8D5A7EBDA2BF8735DB9D264DC56139859BFE5A427EE3670
          33C707031B830CD6AF803447D77C5D680161058C8B75348B9E0A90517382012D
          8E0F550DD08AF1634E5EDB6EA7E9B88C651FECD73BE8E3FA1E9DE1BFF9192CFF
          00EE35FF00A5F1D7775C8E89A35F5AF883CC9E1290DB1BFC4A594ACDF69B9599
          768073F2AA90DB82F246370E6BAEAF6AD63F319BBBD05A28A282028A28A0028A
          28A0028A28A0028A28A0028A28A00290818A5A280381D42E6E356F15AE9BA8DA
          69377A4AEAFF006016F7164649037D83ED3E66F2FB7392571B3A13CD3ECAFEEF
          4DF13A6936506976DA326AA74E5B582D0A48B9B23745C3870BF78918D9D39CE6
          A2FF0099D7FEE6AFFDC351FF0033B7FDCD5FFB86A2CAF72B99DADD0EFF0068F4
          A5A28A090A28A2800A28A2800A28A2800A28A2800A28A2800A28A2800A28A280
          3CDC6A169FF0B17FB3CDD41F6EFF00848FCF36E241E6797FD91B77EDCE76E78C
          E31F8D0350B5FF00858834F3736FF6EFF848FCF36E241E6797FD91B77EDCE76E
          78CE31F8D7A3E01A30298C5A28A290828A28A0028A28A0028A28A0028A28A002
          8A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A0028A28A002
          8A28A00FFFD9}
      end
      object EvapLabel: TLabel
        Left = 200
        Top = 176
        Width = 71
        Height = 28
        Hint = 'Use mm per time unit'
        Caption = 'Max, escape rate  *)'
        Font.Charset = ANSI_CHARSET
        Font.Color = clWindowText
        Font.Height = -12
        Font.Name = 'Tahoma'
        Font.Style = []
        ParentFont = False
        ParentShowHint = False
        ShowHint = True
        WordWrap = True
      end
      object StarLabel: TLabel
        Left = 416
        Top = 168
        Width = 97
        Height = 16
        Caption = '*) see Start help'
        Color = clInfoBk
        ParentColor = False
      end
      object FileNameEdit: TEdit
        Left = 72
        Top = 16
        Width = 569
        Height = 24
        ReadOnly = True
        TabOrder = 0
      end
      object Title1Edit: TEdit
        Left = 72
        Top = 40
        Width = 569
        Height = 24
        Hint = 'Description of the area'
        TabOrder = 1
      end
      object Title2Edit: TEdit
        Left = 72
        Top = 64
        Width = 569
        Height = 24
        Hint = 'Particulars and units used (e.g. mm, day)'
        TabOrder = 2
      end
      object OptionComboBox: TComboBox
        Left = 72
        Top = 88
        Width = 425
        Height = 24
        Color = clInfoBk
        ItemHeight = 16
        ItemIndex = 0
        TabOrder = 3
        Text = 
          'Determine alpha from rainfall and runoff data and reconstruct ru' +
          'noff'
        OnChange = OptionComboBoxChange
        OnExit = OptionComboBoxExit
        Items.Strings = (
          
            'Determine alpha from rainfall and runoff data and reconstruct ru' +
            'noff'
          
            'Predict discharge or runoff from rainfall given the alpha functi' +
            'on')
      end
      object InputOpenButton: TButton
        Left = 558
        Top = 491
        Width = 83
        Height = 25
        Action = InputOpenAction
        Caption = ' Open input'
        TabOrder = 4
      end
      object InputSaveButton: TButton
        Left = 472
        Top = 491
        Width = 79
        Height = 25
        Action = InputSaveAction
        Caption = ' Save / Run'
        TabOrder = 5
      end
      object NrOfDataEdit: TEdit
        Left = 72
        Top = 128
        Width = 65
        Height = 24
        Hint = 'Between 15 and 500'
        TabOrder = 6
        Text = '20'
        OnExit = NrOfDataEditExit
      end
      object StringGrid1: TStringGrid
        Left = 72
        Top = 205
        Width = 289
        Height = 276
        ColCount = 4
        FixedCols = 0
        RowCount = 15
        FixedRows = 0
        Options = [goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine, goRangeSelect, goEditing, goTabs]
        TabOrder = 7
        OnSetEditText = StringGrid1SetEditText
      end
      object FirstGroupBox: TGroupBox
        Left = 152
        Top = 120
        Width = 345
        Height = 49
        Caption = 'First reservoir (see Figure)'
        Color = clBtnFace
        Font.Charset = ANSI_CHARSET
        Font.Color = clBlack
        Font.Height = -13
        Font.Name = 'Tahoma'
        Font.Style = []
        ParentColor = False
        ParentFont = False
        TabOrder = 8
        object InitStorLabel: TLabel
          Left = 192
          Top = 24
          Width = 78
          Height = 16
          Caption = 'Initial storage'
          Color = clBtnFace
          Font.Charset = ANSI_CHARSET
          Font.Color = clMaroon
          Font.Height = -13
          Font.Name = 'Tahoma'
          Font.Style = []
          ParentColor = False
          ParentFont = False
        end
        object MaxStorLabel: TLabel
          Left = 12
          Top = 24
          Width = 102
          Height = 16
          Caption = 'Maximum storage'
          Font.Charset = ANSI_CHARSET
          Font.Color = clMaroon
          Font.Height = -13
          Font.Name = 'Tahoma'
          Font.Style = []
          ParentFont = False
        end
        object EscapeLabel: TLabel
          Left = 350
          Top = 12
          Width = 67
          Height = 32
          Caption = 'Maximum escape rate'
          Font.Charset = ANSI_CHARSET
          Font.Color = clMaroon
          Font.Height = -13
          Font.Name = 'Tahoma'
          Font.Style = []
          ParentFont = False
          Visible = False
          WordWrap = True
        end
        object InitStorEdit: TEdit
          Left = 280
          Top = 20
          Width = 49
          Height = 24
          Hint = '<= Maximum storage'
          TabOrder = 0
          Text = '80'
          OnExit = InitStorEditExit
        end
        object MaxStorEdit: TEdit
          Left = 120
          Top = 20
          Width = 49
          Height = 24
          Hint = '> 0'
          TabOrder = 1
          Text = '100'
          OnExit = MaxStorEditExit
        end
        object EscapeEdit: TEdit
          Left = 432
          Top = 20
          Width = 49
          Height = 24
          Hint = '< 0.1 * maximum storage'
          TabOrder = 2
          Text = '2'
          Visible = False
          OnExit = EscapeEditExit
        end
      end
      object AlphaGroupBox: TGroupBox
        Left = 416
        Top = 184
        Width = 217
        Height = 233
        Caption = 'Alpha characteristics'
        TabOrder = 9
        object A1Label: TLabel
          Left = 16
          Top = 122
          Width = 49
          Height = 16
          Caption = 'A1 value'
        end
        object B1Label: TLabel
          Left = 16
          Top = 171
          Width = 48
          Height = 16
          Caption = 'B1 value'
        end
        object DivideLabell: TLabel
          Left = 8
          Top = 56
          Width = 97
          Height = 16
          Caption = 'Ruoff divide (RD)'
        end
        object DivideLabel: TLabel
          Left = 16
          Top = 96
          Width = 171
          Height = 16
          Caption = 'Runoff>RD            Runoff<Rd'
        end
        object A2Label: TLabel
          Left = 128
          Top = 122
          Width = 49
          Height = 16
          Caption = 'A2 value'
        end
        object B2Label: TLabel
          Left = 128
          Top = 171
          Width = 48
          Height = 16
          Caption = 'B2 value'
        end
        object AlphaLabel: TLabel
          Left = 8
          Top = 24
          Width = 106
          Height = 16
          Caption = 'Alpha=A*runoff+B'
        end
        object A1coeffEdit: TEdit
          Left = 8
          Top = 137
          Width = 73
          Height = 24
          Hint = '>= 0'
          TabOrder = 0
          OnExit = A1coeffEditExit
        end
        object B1valueEdit: TEdit
          Left = 8
          Top = 185
          Width = 73
          Height = 24
          Hint = '>= 0'
          TabOrder = 1
          OnExit = B2valueEditExit
        end
        object DivideEdit: TEdit
          Left = 120
          Top = 48
          Width = 65
          Height = 24
          TabOrder = 2
          Text = '0'
          OnExit = DivideEditExit
        end
        object A2CoeffEdit: TEdit
          Left = 120
          Top = 137
          Width = 73
          Height = 24
          Hint = '>= 0'
          TabOrder = 3
          OnExit = A1coeffEditExit
        end
        object B2ValueEdit: TEdit
          Left = 120
          Top = 185
          Width = 73
          Height = 24
          Hint = '>= 0'
          TabOrder = 4
          OnExit = B2valueEditExit
        end
      end
      object PredictGroupBox: TGroupBox
        Left = 296
        Top = 200
        Width = 97
        Height = 209
        Caption = 'Initialize'
        TabOrder = 10
        Visible = False
        object InitRunLabel: TLabel
          Left = 8
          Top = 24
          Width = 69
          Height = 16
          Caption = 'Initial runoff'
        end
        object InitLevelLabel: TLabel
          Left = 8
          Top = 72
          Width = 63
          Height = 32
          Caption = 'Initial water level'
          WordWrap = True
        end
        object PorosityLabel: TLabel
          Left = 8
          Top = 136
          Width = 71
          Height = 32
          Caption = 'Drainable porosity (%)'
          WordWrap = True
        end
        object InitRunEdit: TEdit
          Left = 8
          Top = 40
          Width = 73
          Height = 24
          TabOrder = 0
          Text = '0'
          OnExit = InitRunEditExit
        end
        object InitLevelEdit: TEdit
          Left = 8
          Top = 104
          Width = 73
          Height = 24
          TabOrder = 1
          Text = '0'
          OnExit = InitLevelEditExit
        end
        object PorosityEdit: TEdit
          Left = 8
          Top = 168
          Width = 73
          Height = 24
          TabOrder = 2
          Text = '5'
          OnExit = PorosityEditExit
        end
      end
      object WaitMemo: TMemo
        Left = 496
        Top = 8
        Width = 145
        Height = 121
        Color = clBlue
        Font.Charset = ANSI_CHARSET
        Font.Color = clYellow
        Font.Height = -13
        Font.Name = 'Tahoma'
        Font.Style = []
        ParentFont = False
        TabOrder = 11
        Visible = False
      end
      object HelpButton: TButton
        Left = 360
        Top = 491
        Width = 105
        Height = 25
        Caption = 'Start help, units'
        TabOrder = 12
        OnClick = HelpButtonClick
      end
      object AlfaMemo: TMemo
        Left = 328
        Top = 424
        Width = 225
        Height = 57
        Color = cl3DLight
        Lines.Strings = (
          'To calculate the A and B values for a '
          'subsurface drainage system with '
          'pipes or ditches use button AlfaCalc')
        TabOrder = 13
        Visible = False
      end
      object AlfaButton: TButton
        Left = 560
        Top = 440
        Width = 75
        Height = 25
        Caption = 'AlfaCalc'
        TabOrder = 14
        Visible = False
        OnClick = AlfaButtonClick
      end
      object ClearButton: TButton
        Left = 280
        Top = 491
        Width = 75
        Height = 25
        Caption = 'Clear all'
        TabOrder = 15
        OnClick = ClearButtonClick
      end
      object TryMemo: TMemo
        Left = 496
        Top = 120
        Width = 137
        Height = 49
        Color = clInfoBk
        Font.Charset = ANSI_CHARSET
        Font.Color = clWindowText
        Font.Height = -12
        Font.Name = 'Tahoma'
        Font.Style = []
        Lines.Strings = (
          'Try various values of '
          'initial storage to find'
          'the best result.')
        ParentFont = False
        TabOrder = 16
      end
    end
    object OutputTabSheet: TTabSheet
      Caption = '  Output  '
      ImageIndex = 3
      OnShow = OutputTabSheetShow
      object SeeOutputButton: TButton
        Left = 552
        Top = 471
        Width = 88
        Height = 33
        Action = OutputOpenAction
        TabOrder = 0
      end
      object OutputMemo: TMemo
        Left = 8
        Top = 24
        Width = 593
        Height = 425
        Font.Charset = ANSI_CHARSET
        Font.Color = clWindowText
        Font.Height = -13
        Font.Name = 'Courier New'
        Font.Style = [fsBold]
        ParentFont = False
        ScrollBars = ssBoth
        TabOrder = 1
      end
      object ViewGraphButton: TButton
        Left = 456
        Top = 471
        Width = 82
        Height = 33
        Caption = 'View graph'
        TabOrder = 2
        OnClick = ViewGraphButtonClick
      end
    end
    object GraphicsTabSheet: TTabSheet
      Caption = ' Graphics '
      Font.Charset = ANSI_CHARSET
      Font.Color = clWindowText
      Font.Height = -13
      Font.Name = 'Tahoma'
      Font.Style = []
      ImageIndex = 3
      ParentFont = False
      OnShow = GraphicsTabSheetShow
      object GraphImage: TImage
        Left = 16
        Top = 0
        Width = 623
        Height = 465
        ParentShowHint = False
        ShowHint = False
        Visible = False
      end
      object PictureImage: TImage
        Left = 32
        Top = 8
        Width = 609
        Height = 449
        ParentShowHint = False
        ShowHint = False
        Visible = False
      end
      object SeeGraphButton: TButton
        Left = 551
        Top = 479
        Width = 89
        Height = 25
        Action = GraphOpenAction
        Caption = 'Open graph'
        TabOrder = 0
      end
      object MakeGraphButton: TButton
        Left = 447
        Top = 479
        Width = 89
        Height = 25
        Action = OutputOpenForGraphics
        Caption = 'Make graph'
        TabOrder = 1
      end
      object SaveGraphButton: TButton
        Left = 343
        Top = 479
        Width = 89
        Height = 25
        Action = GraphSaveAction
        Caption = 'Save graph'
        TabOrder = 2
      end
      object Panel1: TPanel
        Left = 144
        Top = 104
        Width = 225
        Height = 201
        Caption = 'Panel1'
        TabOrder = 3
        object RadioGroup1: TRadioGroup
          Left = 8
          Top = 8
          Width = 153
          Height = 177
          Caption = 'Select graph'
          TabOrder = 0
        end
        object RunoffRadioButton: TRadioButton
          Left = 16
          Top = 40
          Width = 121
          Height = 25
          Caption = 'Runoff in time'
          Checked = True
          TabOrder = 1
          TabStop = True
        end
        object RechRadioButton: TRadioButton
          Left = 16
          Top = 64
          Width = 105
          Height = 33
          Caption = 'Rain/Recharge'
          TabOrder = 2
        end
        object AlphaRadioButton: TRadioButton
          Left = 16
          Top = 96
          Width = 129
          Height = 25
          Caption = 'Alpha and runoff'
          TabOrder = 3
        end
        object CalcObsRadioButton: TRadioButton
          Left = 16
          Top = 128
          Width = 137
          Height = 17
          Caption = 'Observed-calculated'
          TabOrder = 4
        end
        object RainRunRadioButton: TRadioButton
          Left = 16
          Top = 152
          Width = 129
          Height = 17
          Caption = 'Recharge-Runoff'
          TabOrder = 5
        end
        object GoButton1: TButton
          Left = 160
          Top = 88
          Width = 49
          Height = 25
          Caption = 'Go'
          Font.Charset = ANSI_CHARSET
          Font.Color = clWindowText
          Font.Height = -13
          Font.Name = 'Tahoma'
          Font.Style = [fsBold]
          ParentFont = False
          TabOrder = 6
          OnClick = GoButton1Click
        end
      end
      object Panel2: TPanel
        Left = 152
        Top = 128
        Width = 209
        Height = 113
        Caption = 'Panel1'
        TabOrder = 4
        object RadioGroup2: TRadioGroup
          Left = 8
          Top = 8
          Width = 137
          Height = 97
          Caption = 'Select graph'
          TabOrder = 0
        end
        object RadioButton1: TRadioButton
          Left = 24
          Top = 40
          Width = 113
          Height = 25
          Caption = 'Runoff in time'
          Checked = True
          TabOrder = 1
          TabStop = True
        end
        object RadioButton2: TRadioButton
          Left = 24
          Top = 64
          Width = 113
          Height = 33
          Caption = 'Rain/Recharge'
          TabOrder = 2
        end
        object GoButton2: TButton
          Left = 144
          Top = 48
          Width = 49
          Height = 25
          Caption = 'Go'
          Font.Charset = ANSI_CHARSET
          Font.Color = clWindowText
          Font.Height = -13
          Font.Name = 'Tahoma'
          Font.Style = [fsBold]
          ParentFont = False
          TabOrder = 3
          OnClick = GoButton2Click
        end
      end
      object SelectButton: TButton
        Left = 232
        Top = 479
        Width = 91
        Height = 25
        Caption = 'Select graph'
        Enabled = False
        TabOrder = 5
        OnClick = SelectButtonClick
      end
      object CommentButton: TButton
        Left = 136
        Top = 480
        Width = 75
        Height = 25
        Caption = 'Comment'
        Enabled = False
        TabOrder = 6
        OnClick = CommentButtonClick
      end
      object Panel3: TPanel
        Left = 176
        Top = 144
        Width = 209
        Height = 121
        TabOrder = 7
        object RadioGroup3: TRadioGroup
          Left = 8
          Top = 8
          Width = 145
          Height = 105
          Caption = 'Select graph'
          TabOrder = 0
        end
        object RadioButton3: TRadioButton
          Left = 16
          Top = 40
          Width = 113
          Height = 17
          Caption = 'Runoff in time'
          Checked = True
          TabOrder = 1
          TabStop = True
        end
        object RadioButton4: TRadioButton
          Left = 16
          Top = 64
          Width = 129
          Height = 17
          Caption = 'Watertable in time'
          TabOrder = 2
        end
        object RadioButton5: TRadioButton
          Left = 16
          Top = 88
          Width = 113
          Height = 17
          Caption = 'Rain/Recharge'
          TabOrder = 3
        end
        object GoButton3: TButton
          Left = 152
          Top = 56
          Width = 49
          Height = 25
          Caption = 'Go'
          Font.Charset = ANSI_CHARSET
          Font.Color = clWindowText
          Font.Height = -13
          Font.Name = 'Tahoma'
          Font.Style = [fsBold]
          ParentFont = False
          TabOrder = 4
          OnClick = GoButton3Click
        end
      end
    end
  end
  object MainMenu1: TMainMenu
    Left = 16
    Top = 504
    object FileItem: TMenuItem
      Caption = '&File'
      object InputOpenMenu: TMenuItem
        Action = InputOpenAction
      end
      object OutputOpenMenu: TMenuItem
        Action = OutputOpenAction
      end
      object GraphOpenMenu: TMenuItem
        Action = GraphOpenAction
      end
      object InputSaveMenu: TMenuItem
        Action = InputSaveAction
      end
      object Savegraph: TMenuItem
        Action = GraphSaveAction
      end
      object ProgramExit: TMenuItem
        Action = FileExit1
        Caption = 'Program e&Xit'
      end
    end
    object Edit: TMenuItem
      Caption = '&Edit'
      object Copy: TMenuItem
        Action = EditCopy1
      end
      object Cut: TMenuItem
        Action = EditCut1
      end
      object Paste: TMenuItem
        Action = EditPaste1
      end
    end
  end
  object ActionList1: TActionList
    Left = 56
    Top = 504
    object EditCut1: TEditCut
      Category = 'Edit'
      Caption = 'Cu&t'
      Hint = 'Cut|Cuts the selection and puts it on the Clipboard'
      ImageIndex = 0
      ShortCut = 16472
    end
    object EditCopy1: TEditCopy
      Category = 'Edit'
      Caption = '&Copy'
      Hint = 'Copy|Copies the selection and puts it on the Clipboard'
      ImageIndex = 1
      ShortCut = 16451
    end
    object EditPaste1: TEditPaste
      Category = 'Edit'
      Caption = '&Paste'
      Hint = 'Paste|Inserts Clipboard contents'
      ImageIndex = 2
      ShortCut = 16470
    end
    object EditDelete1: TEditDelete
      Category = 'Edit'
      Caption = '&Delete'
      Hint = 'Delete|Erases the selection'
      ImageIndex = 5
      ShortCut = 46
    end
    object FileExit1: TFileExit
      Category = 'File'
      Caption = 'E&xit'
      Hint = 'Exit|Quits the application'
      ImageIndex = 43
    end
    object InputSaveAction: TAction
      Caption = 'Save i&Nput'
      OnExecute = InputSaveActionExecute
    end
    object InputOpenAction: TAction
      Caption = 'Open &Input'
      OnExecute = InputOpenActionExecute
    end
    object OutputOpenAction: TAction
      Caption = 'Open &Output'
      OnExecute = OutputOpenActionExecute
    end
    object GraphOpenAction: TAction
      Caption = 'Open &Graph'
      OnExecute = GraphOpenActionExecute
    end
    object OutputOpenForGraphics: TAction
      Caption = 'Open &Graph'
      OnExecute = OutputOpenForGraphicsExecute
    end
    object GraphSaveAction: TAction
      Caption = 'Save g&Raph'
      OnExecute = GraphSaveActionExecute
    end
  end
  object InputOpenDialog: TOpenDialog
    DefaultExt = 'inp'
    Filter = 'Input files (*.inp)|*.inp'
    Left = 40
    Top = 456
  end
  object InputSaveDialog: TSaveDialog
    DefaultExt = 'inp'
    Filter = 'Input files (*.inp)|*.inp'
    Left = 40
    Top = 416
  end
  object OutputOpenDialog: TOpenDialog
    DefaultExt = '.out'
    Filter = 'Output files (*.out)|*.out'
    Left = 136
    Top = 448
  end
  object GraphOpenDialog: TOpenDialog
    DefaultExt = 'bmp'
    Filter = 'Graph files (*.bmp)|*.bmp'
    Left = 84
    Top = 451
  end
  object GraphSaveDialog: TSaveDialog
    DefaultExt = 'bmp'
    Filter = 'Image files (*.bmp)|*.bmp'
    Left = 92
    Top = 419
  end
end
